G_BEGIN_DECLS

typedef void (*mc_cli_account_signal_callback_removed) (TpProxy *proxy,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *mc_cli_account_connect_to_removed (gpointer proxy,
    mc_cli_account_signal_callback_removed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*mc_cli_account_signal_callback_account_property_changed) (TpProxy *proxy,
    GHashTable *arg_Properties,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *mc_cli_account_connect_to_account_property_changed (gpointer proxy,
    mc_cli_account_signal_callback_account_property_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*mc_cli_account_callback_for_remove) (TpProxy *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *mc_cli_account_call_remove (gpointer proxy,
    gint timeout_ms,
    mc_cli_account_callback_for_remove callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean mc_cli_account_run_remove (gpointer proxy,
    gint timeout_ms,
    GError **error,
    GMainLoop **loop);


typedef void (*mc_cli_account_callback_for_update_parameters) (TpProxy *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *mc_cli_account_call_update_parameters (gpointer proxy,
    gint timeout_ms,
    GHashTable *in_Set,
    const gchar **in_Unset,
    mc_cli_account_callback_for_update_parameters callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean mc_cli_account_run_update_parameters (gpointer proxy,
    gint timeout_ms,
    GHashTable *in_Set,
    const gchar **in_Unset,
    GError **error,
    GMainLoop **loop);


G_END_DECLS
