G_BEGIN_DECLS

typedef void (*mc_cli_account_manager_signal_callback_account_removed) (TpProxy *proxy,
    const gchar *arg_Account,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *mc_cli_account_manager_connect_to_account_removed (gpointer proxy,
    mc_cli_account_manager_signal_callback_account_removed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*mc_cli_account_manager_signal_callback_account_validity_changed) (TpProxy *proxy,
    const gchar *arg_Account,
    gboolean arg_Valid,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *mc_cli_account_manager_connect_to_account_validity_changed (gpointer proxy,
    mc_cli_account_manager_signal_callback_account_validity_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*mc_cli_account_manager_callback_for_create_account) (TpProxy *proxy,
    const gchar *out_Account,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *mc_cli_account_manager_call_create_account (gpointer proxy,
    gint timeout_ms,
    const gchar *in_Connection_Manager,
    const gchar *in_Protocol,
    const gchar *in_Display_Name,
    GHashTable *in_Parameters,
    mc_cli_account_manager_callback_for_create_account callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean mc_cli_account_manager_run_create_account (gpointer proxy,
    gint timeout_ms,
    const gchar *in_Connection_Manager,
    const gchar *in_Protocol,
    const gchar *in_Display_Name,
    GHashTable *in_Parameters,
    gchar **out_Account,
    GError **error,
    GMainLoop **loop);


G_END_DECLS
