/* We don't want gtkdoc scanning this file, it'll get
 * confused by seeing function definitions, so mark it as: */
/*<private_header>*/

static inline void
mc_cli_add_signals_for_nmc4 (DBusGProxy *proxy)
{
  dbus_g_proxy_add_signal (proxy, "AccountPresenceChanged",
      G_TYPE_UINT,
      G_TYPE_UINT,
      G_TYPE_STRING,
      G_TYPE_UINT,
      G_TYPE_STRING,
      G_TYPE_INVALID);
  dbus_g_proxy_add_signal (proxy, "AccountStatusChanged",
      G_TYPE_UINT,
      G_TYPE_UINT,
      G_TYPE_UINT,
      G_TYPE_STRING,
      G_TYPE_INVALID);
  dbus_g_proxy_add_signal (proxy, "McdError",
      G_TYPE_UINT,
      G_TYPE_STRING,
      G_TYPE_UINT,
      G_TYPE_INVALID);
  dbus_g_proxy_add_signal (proxy, "PresenceRequested",
      G_TYPE_UINT,
      G_TYPE_STRING,
      G_TYPE_INVALID);
  dbus_g_proxy_add_signal (proxy, "PresenceStatusRequested",
      G_TYPE_UINT,
      G_TYPE_INVALID);
  dbus_g_proxy_add_signal (proxy, "PresenceChanged",
      G_TYPE_UINT,
      G_TYPE_STRING,
      G_TYPE_INVALID);
  dbus_g_proxy_add_signal (proxy, "PresenceStatusActual",
      G_TYPE_UINT,
      G_TYPE_INVALID);
  dbus_g_proxy_add_signal (proxy, "UsedChannelsCountChanged",
      G_TYPE_STRING,
      G_TYPE_UINT,
      G_TYPE_INVALID);
  dbus_g_proxy_add_signal (proxy, "StatusActual",
      G_TYPE_UINT,
      G_TYPE_UINT,
      G_TYPE_INVALID);
}


/**
 * mc_cli_nmc4_signal_callback_account_presence_changed:
 * @proxy: The proxy on which mc_cli_nmc4_connect_to_account_presence_changed ()
 *  was called
 * @arg_status: <![CDATA[The connection status]]>
 * @arg_presence: <![CDATA[The presence]]>
 * @arg_message: <![CDATA[The presence message]]>
 * @arg_reason: <![CDATA[The connection status reason]]>
 * @arg_account_id: <![CDATA[The account name]]>
 * @user_data: User-supplied data
 * @weak_object: User-supplied weakly referenced object
 *
 * Represents the signature of a callback for the signal AccountPresenceChanged.
 */
static void
_mc_cli_nmc4_collect_args_of_account_presence_changed (DBusGProxy *proxy,
    guint arg_status,
    guint arg_presence,
    const gchar *arg_message,
    guint arg_reason,
    const gchar *arg_account_id,
    TpProxySignalConnection *sc)
{
  GValueArray *args = g_value_array_new (5);
  GValue blank = { 0 };
  guint i;

  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 5; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, G_TYPE_UINT);
  g_value_set_uint (args->values + 0, arg_status);

  g_value_unset (args->values + 1);
  g_value_init (args->values + 1, G_TYPE_UINT);
  g_value_set_uint (args->values + 1, arg_presence);

  g_value_unset (args->values + 2);
  g_value_init (args->values + 2, G_TYPE_STRING);
  g_value_set_string (args->values + 2, arg_message);

  g_value_unset (args->values + 3);
  g_value_init (args->values + 3, G_TYPE_UINT);
  g_value_set_uint (args->values + 3, arg_reason);

  g_value_unset (args->values + 4);
  g_value_init (args->values + 4, G_TYPE_STRING);
  g_value_set_string (args->values + 4, arg_account_id);

  tp_proxy_signal_connection_v0_take_results (sc, args);
}
static void
_mc_cli_nmc4_invoke_callback_for_account_presence_changed (TpProxy *tpproxy,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  mc_cli_nmc4_signal_callback_account_presence_changed callback =
      (mc_cli_nmc4_signal_callback_account_presence_changed) generic_callback;

  if (callback != NULL)
    callback (g_object_ref (tpproxy),
      g_value_get_uint (args->values + 0),
      g_value_get_uint (args->values + 1),
      g_value_get_string (args->values + 2),
      g_value_get_uint (args->values + 3),
      g_value_get_string (args->values + 4),
      user_data,
      weak_object);

  g_value_array_free (args);
  g_object_unref (tpproxy);
}
/**
 * mc_cli_nmc4_connect_to_account_presence_changed:
 * @proxy: A #TpProxy or subclass
 * @callback: Callback to be called when the signal is
 *   received
 * @user_data: User-supplied data for the callback
 * @destroy: Destructor for the user-supplied data, which
 *   will be called when this signal is disconnected, or
 *   before this function returns %NULL
 * @weak_object: A #GObject which will be weakly referenced; 
 *   if it is destroyed, this callback will automatically be
 *   disconnected
 * @error: If not %NULL, used to raise an error if %NULL is
 *   returned
 *
 * Connect a handler to the signal AccountPresenceChanged.
 *
 * <![CDATA[Emitted when an account's connection status changes]]>
 *
 * Returns: a #TpProxySignalConnection containing all of the
 * above, which can be used to disconnect the signal; or
 * %NULL if the proxy does not have the desired interface
 * or has become invalid.
 */
TpProxySignalConnection *
mc_cli_nmc4_connect_to_account_presence_changed (gpointer proxy,
    mc_cli_nmc4_signal_callback_account_presence_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error)
{
  GType expected_types[6] = {
      G_TYPE_UINT,
      G_TYPE_UINT,
      G_TYPE_STRING,
      G_TYPE_UINT,
      G_TYPE_STRING,
      G_TYPE_INVALID };

  g_return_val_if_fail (TP_IS_PROXY (proxy), NULL);
  g_return_val_if_fail (callback != NULL, NULL);

  return tp_proxy_signal_connection_v0_new ((TpProxy *) proxy,
      MC_IFACE_QUARK_NMC4, "AccountPresenceChanged",
      expected_types,
      G_CALLBACK (_mc_cli_nmc4_collect_args_of_account_presence_changed),
      _mc_cli_nmc4_invoke_callback_for_account_presence_changed,
      G_CALLBACK (callback), user_data, destroy,
      weak_object, error);
}

/**
 * mc_cli_nmc4_signal_callback_account_status_changed:
 * @proxy: The proxy on which mc_cli_nmc4_connect_to_account_status_changed ()
 *  was called
 * @arg_status: <![CDATA[The connection status]]>
 * @arg_presence: <![CDATA[The presence]]>
 * @arg_reason: <![CDATA[The connection status reason]]>
 * @arg_account_id: <![CDATA[The account name]]>
 * @user_data: User-supplied data
 * @weak_object: User-supplied weakly referenced object
 *
 * Represents the signature of a callback for the signal AccountStatusChanged.
 */
static void
_mc_cli_nmc4_collect_args_of_account_status_changed (DBusGProxy *proxy,
    guint arg_status,
    guint arg_presence,
    guint arg_reason,
    const gchar *arg_account_id,
    TpProxySignalConnection *sc)
{
  GValueArray *args = g_value_array_new (4);
  GValue blank = { 0 };
  guint i;

  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 4; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, G_TYPE_UINT);
  g_value_set_uint (args->values + 0, arg_status);

  g_value_unset (args->values + 1);
  g_value_init (args->values + 1, G_TYPE_UINT);
  g_value_set_uint (args->values + 1, arg_presence);

  g_value_unset (args->values + 2);
  g_value_init (args->values + 2, G_TYPE_UINT);
  g_value_set_uint (args->values + 2, arg_reason);

  g_value_unset (args->values + 3);
  g_value_init (args->values + 3, G_TYPE_STRING);
  g_value_set_string (args->values + 3, arg_account_id);

  tp_proxy_signal_connection_v0_take_results (sc, args);
}
static void
_mc_cli_nmc4_invoke_callback_for_account_status_changed (TpProxy *tpproxy,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  mc_cli_nmc4_signal_callback_account_status_changed callback =
      (mc_cli_nmc4_signal_callback_account_status_changed) generic_callback;

  if (callback != NULL)
    callback (g_object_ref (tpproxy),
      g_value_get_uint (args->values + 0),
      g_value_get_uint (args->values + 1),
      g_value_get_uint (args->values + 2),
      g_value_get_string (args->values + 3),
      user_data,
      weak_object);

  g_value_array_free (args);
  g_object_unref (tpproxy);
}
/**
 * mc_cli_nmc4_connect_to_account_status_changed:
 * @proxy: A #TpProxy or subclass
 * @callback: Callback to be called when the signal is
 *   received
 * @user_data: User-supplied data for the callback
 * @destroy: Destructor for the user-supplied data, which
 *   will be called when this signal is disconnected, or
 *   before this function returns %NULL
 * @weak_object: A #GObject which will be weakly referenced; 
 *   if it is destroyed, this callback will automatically be
 *   disconnected
 * @error: If not %NULL, used to raise an error if %NULL is
 *   returned
 *
 * Connect a handler to the signal AccountStatusChanged.
 *
 * <![CDATA[Emitted when an account's connection status changes         DEPRECATED]]>
 *
 * Returns: a #TpProxySignalConnection containing all of the
 * above, which can be used to disconnect the signal; or
 * %NULL if the proxy does not have the desired interface
 * or has become invalid.
 */
TpProxySignalConnection *
mc_cli_nmc4_connect_to_account_status_changed (gpointer proxy,
    mc_cli_nmc4_signal_callback_account_status_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error)
{
  GType expected_types[5] = {
      G_TYPE_UINT,
      G_TYPE_UINT,
      G_TYPE_UINT,
      G_TYPE_STRING,
      G_TYPE_INVALID };

  g_return_val_if_fail (TP_IS_PROXY (proxy), NULL);
  g_return_val_if_fail (callback != NULL, NULL);

  return tp_proxy_signal_connection_v0_new ((TpProxy *) proxy,
      MC_IFACE_QUARK_NMC4, "AccountStatusChanged",
      expected_types,
      G_CALLBACK (_mc_cli_nmc4_collect_args_of_account_status_changed),
      _mc_cli_nmc4_invoke_callback_for_account_status_changed,
      G_CALLBACK (callback), user_data, destroy,
      weak_object, error);
}

/**
 * mc_cli_nmc4_signal_callback_mcd_error:
 * @proxy: The proxy on which mc_cli_nmc4_connect_to_mcd_error ()
 *  was called
 * @arg_serial: <![CDATA[Operation ID of the channel request]]>
 * @arg_client_id: <![CDATA[D-Bus name of the process which requested the           channel]]>
 * @arg_error_id: <![CDATA[Error code]]>
 * @user_data: User-supplied data
 * @weak_object: User-supplied weakly referenced object
 *
 * Represents the signature of a callback for the signal McdError.
 */
static void
_mc_cli_nmc4_collect_args_of_mcd_error (DBusGProxy *proxy,
    guint arg_serial,
    const gchar *arg_client_id,
    guint arg_error_id,
    TpProxySignalConnection *sc)
{
  GValueArray *args = g_value_array_new (3);
  GValue blank = { 0 };
  guint i;

  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 3; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, G_TYPE_UINT);
  g_value_set_uint (args->values + 0, arg_serial);

  g_value_unset (args->values + 1);
  g_value_init (args->values + 1, G_TYPE_STRING);
  g_value_set_string (args->values + 1, arg_client_id);

  g_value_unset (args->values + 2);
  g_value_init (args->values + 2, G_TYPE_UINT);
  g_value_set_uint (args->values + 2, arg_error_id);

  tp_proxy_signal_connection_v0_take_results (sc, args);
}
static void
_mc_cli_nmc4_invoke_callback_for_mcd_error (TpProxy *tpproxy,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  mc_cli_nmc4_signal_callback_mcd_error callback =
      (mc_cli_nmc4_signal_callback_mcd_error) generic_callback;

  if (callback != NULL)
    callback (g_object_ref (tpproxy),
      g_value_get_uint (args->values + 0),
      g_value_get_string (args->values + 1),
      g_value_get_uint (args->values + 2),
      user_data,
      weak_object);

  g_value_array_free (args);
  g_object_unref (tpproxy);
}
/**
 * mc_cli_nmc4_connect_to_mcd_error:
 * @proxy: A #TpProxy or subclass
 * @callback: Callback to be called when the signal is
 *   received
 * @user_data: User-supplied data for the callback
 * @destroy: Destructor for the user-supplied data, which
 *   will be called when this signal is disconnected, or
 *   before this function returns %NULL
 * @weak_object: A #GObject which will be weakly referenced; 
 *   if it is destroyed, this callback will automatically be
 *   disconnected
 * @error: If not %NULL, used to raise an error if %NULL is
 *   returned
 *
 * Connect a handler to the signal McdError.
 *
 * <![CDATA[Emitted when a requested channel could not be dispatched.]]>
 *
 * Returns: a #TpProxySignalConnection containing all of the
 * above, which can be used to disconnect the signal; or
 * %NULL if the proxy does not have the desired interface
 * or has become invalid.
 */
TpProxySignalConnection *
mc_cli_nmc4_connect_to_mcd_error (gpointer proxy,
    mc_cli_nmc4_signal_callback_mcd_error callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error)
{
  GType expected_types[4] = {
      G_TYPE_UINT,
      G_TYPE_STRING,
      G_TYPE_UINT,
      G_TYPE_INVALID };

  g_return_val_if_fail (TP_IS_PROXY (proxy), NULL);
  g_return_val_if_fail (callback != NULL, NULL);

  return tp_proxy_signal_connection_v0_new ((TpProxy *) proxy,
      MC_IFACE_QUARK_NMC4, "McdError",
      expected_types,
      G_CALLBACK (_mc_cli_nmc4_collect_args_of_mcd_error),
      _mc_cli_nmc4_invoke_callback_for_mcd_error,
      G_CALLBACK (callback), user_data, destroy,
      weak_object, error);
}

/**
 * mc_cli_nmc4_signal_callback_presence_requested:
 * @proxy: The proxy on which mc_cli_nmc4_connect_to_presence_requested ()
 *  was called
 * @arg_presence: <![CDATA[The requested presence]]>
 * @arg_message: <![CDATA[The presence message]]>
 * @user_data: User-supplied data
 * @weak_object: User-supplied weakly referenced object
 *
 * Represents the signature of a callback for the signal PresenceRequested.
 */
static void
_mc_cli_nmc4_collect_args_of_presence_requested (DBusGProxy *proxy,
    guint arg_presence,
    const gchar *arg_message,
    TpProxySignalConnection *sc)
{
  GValueArray *args = g_value_array_new (2);
  GValue blank = { 0 };
  guint i;

  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 2; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, G_TYPE_UINT);
  g_value_set_uint (args->values + 0, arg_presence);

  g_value_unset (args->values + 1);
  g_value_init (args->values + 1, G_TYPE_STRING);
  g_value_set_string (args->values + 1, arg_message);

  tp_proxy_signal_connection_v0_take_results (sc, args);
}
static void
_mc_cli_nmc4_invoke_callback_for_presence_requested (TpProxy *tpproxy,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  mc_cli_nmc4_signal_callback_presence_requested callback =
      (mc_cli_nmc4_signal_callback_presence_requested) generic_callback;

  if (callback != NULL)
    callback (g_object_ref (tpproxy),
      g_value_get_uint (args->values + 0),
      g_value_get_string (args->values + 1),
      user_data,
      weak_object);

  g_value_array_free (args);
  g_object_unref (tpproxy);
}
/**
 * mc_cli_nmc4_connect_to_presence_requested:
 * @proxy: A #TpProxy or subclass
 * @callback: Callback to be called when the signal is
 *   received
 * @user_data: User-supplied data for the callback
 * @destroy: Destructor for the user-supplied data, which
 *   will be called when this signal is disconnected, or
 *   before this function returns %NULL
 * @weak_object: A #GObject which will be weakly referenced; 
 *   if it is destroyed, this callback will automatically be
 *   disconnected
 * @error: If not %NULL, used to raise an error if %NULL is
 *   returned
 *
 * Connect a handler to the signal PresenceRequested.
 *
 * <![CDATA[Emitted when a presence has been requested.]]>
 *
 * Returns: a #TpProxySignalConnection containing all of the
 * above, which can be used to disconnect the signal; or
 * %NULL if the proxy does not have the desired interface
 * or has become invalid.
 */
TpProxySignalConnection *
mc_cli_nmc4_connect_to_presence_requested (gpointer proxy,
    mc_cli_nmc4_signal_callback_presence_requested callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error)
{
  GType expected_types[3] = {
      G_TYPE_UINT,
      G_TYPE_STRING,
      G_TYPE_INVALID };

  g_return_val_if_fail (TP_IS_PROXY (proxy), NULL);
  g_return_val_if_fail (callback != NULL, NULL);

  return tp_proxy_signal_connection_v0_new ((TpProxy *) proxy,
      MC_IFACE_QUARK_NMC4, "PresenceRequested",
      expected_types,
      G_CALLBACK (_mc_cli_nmc4_collect_args_of_presence_requested),
      _mc_cli_nmc4_invoke_callback_for_presence_requested,
      G_CALLBACK (callback), user_data, destroy,
      weak_object, error);
}

/**
 * mc_cli_nmc4_signal_callback_presence_status_requested:
 * @proxy: The proxy on which mc_cli_nmc4_connect_to_presence_status_requested ()
 *  was called
 * @arg_presence: <![CDATA[The requested presence]]>
 * @user_data: User-supplied data
 * @weak_object: User-supplied weakly referenced object
 *
 * Represents the signature of a callback for the signal PresenceStatusRequested.
 */
static void
_mc_cli_nmc4_collect_args_of_presence_status_requested (DBusGProxy *proxy,
    guint arg_presence,
    TpProxySignalConnection *sc)
{
  GValueArray *args = g_value_array_new (1);
  GValue blank = { 0 };
  guint i;

  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 1; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, G_TYPE_UINT);
  g_value_set_uint (args->values + 0, arg_presence);

  tp_proxy_signal_connection_v0_take_results (sc, args);
}
static void
_mc_cli_nmc4_invoke_callback_for_presence_status_requested (TpProxy *tpproxy,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  mc_cli_nmc4_signal_callback_presence_status_requested callback =
      (mc_cli_nmc4_signal_callback_presence_status_requested) generic_callback;

  if (callback != NULL)
    callback (g_object_ref (tpproxy),
      g_value_get_uint (args->values + 0),
      user_data,
      weak_object);

  g_value_array_free (args);
  g_object_unref (tpproxy);
}
/**
 * mc_cli_nmc4_connect_to_presence_status_requested:
 * @proxy: A #TpProxy or subclass
 * @callback: Callback to be called when the signal is
 *   received
 * @user_data: User-supplied data for the callback
 * @destroy: Destructor for the user-supplied data, which
 *   will be called when this signal is disconnected, or
 *   before this function returns %NULL
 * @weak_object: A #GObject which will be weakly referenced; 
 *   if it is destroyed, this callback will automatically be
 *   disconnected
 * @error: If not %NULL, used to raise an error if %NULL is
 *   returned
 *
 * Connect a handler to the signal PresenceStatusRequested.
 *
 * <![CDATA[Emitted when a presence has been requested.         DEPRECATED]]>
 *
 * Returns: a #TpProxySignalConnection containing all of the
 * above, which can be used to disconnect the signal; or
 * %NULL if the proxy does not have the desired interface
 * or has become invalid.
 */
TpProxySignalConnection *
mc_cli_nmc4_connect_to_presence_status_requested (gpointer proxy,
    mc_cli_nmc4_signal_callback_presence_status_requested callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error)
{
  GType expected_types[2] = {
      G_TYPE_UINT,
      G_TYPE_INVALID };

  g_return_val_if_fail (TP_IS_PROXY (proxy), NULL);
  g_return_val_if_fail (callback != NULL, NULL);

  return tp_proxy_signal_connection_v0_new ((TpProxy *) proxy,
      MC_IFACE_QUARK_NMC4, "PresenceStatusRequested",
      expected_types,
      G_CALLBACK (_mc_cli_nmc4_collect_args_of_presence_status_requested),
      _mc_cli_nmc4_invoke_callback_for_presence_status_requested,
      G_CALLBACK (callback), user_data, destroy,
      weak_object, error);
}

/**
 * mc_cli_nmc4_signal_callback_presence_changed:
 * @proxy: The proxy on which mc_cli_nmc4_connect_to_presence_changed ()
 *  was called
 * @arg_presence: <![CDATA[The actual presence]]>
 * @arg_message: <![CDATA[The presence message]]>
 * @user_data: User-supplied data
 * @weak_object: User-supplied weakly referenced object
 *
 * Represents the signature of a callback for the signal PresenceChanged.
 */
static void
_mc_cli_nmc4_collect_args_of_presence_changed (DBusGProxy *proxy,
    guint arg_presence,
    const gchar *arg_message,
    TpProxySignalConnection *sc)
{
  GValueArray *args = g_value_array_new (2);
  GValue blank = { 0 };
  guint i;

  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 2; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, G_TYPE_UINT);
  g_value_set_uint (args->values + 0, arg_presence);

  g_value_unset (args->values + 1);
  g_value_init (args->values + 1, G_TYPE_STRING);
  g_value_set_string (args->values + 1, arg_message);

  tp_proxy_signal_connection_v0_take_results (sc, args);
}
static void
_mc_cli_nmc4_invoke_callback_for_presence_changed (TpProxy *tpproxy,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  mc_cli_nmc4_signal_callback_presence_changed callback =
      (mc_cli_nmc4_signal_callback_presence_changed) generic_callback;

  if (callback != NULL)
    callback (g_object_ref (tpproxy),
      g_value_get_uint (args->values + 0),
      g_value_get_string (args->values + 1),
      user_data,
      weak_object);

  g_value_array_free (args);
  g_object_unref (tpproxy);
}
/**
 * mc_cli_nmc4_connect_to_presence_changed:
 * @proxy: A #TpProxy or subclass
 * @callback: Callback to be called when the signal is
 *   received
 * @user_data: User-supplied data for the callback
 * @destroy: Destructor for the user-supplied data, which
 *   will be called when this signal is disconnected, or
 *   before this function returns %NULL
 * @weak_object: A #GObject which will be weakly referenced; 
 *   if it is destroyed, this callback will automatically be
 *   disconnected
 * @error: If not %NULL, used to raise an error if %NULL is
 *   returned
 *
 * Connect a handler to the signal PresenceChanged.
 *
 * <![CDATA[Emitted when the actual presence has changed.]]>
 *
 * Returns: a #TpProxySignalConnection containing all of the
 * above, which can be used to disconnect the signal; or
 * %NULL if the proxy does not have the desired interface
 * or has become invalid.
 */
TpProxySignalConnection *
mc_cli_nmc4_connect_to_presence_changed (gpointer proxy,
    mc_cli_nmc4_signal_callback_presence_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error)
{
  GType expected_types[3] = {
      G_TYPE_UINT,
      G_TYPE_STRING,
      G_TYPE_INVALID };

  g_return_val_if_fail (TP_IS_PROXY (proxy), NULL);
  g_return_val_if_fail (callback != NULL, NULL);

  return tp_proxy_signal_connection_v0_new ((TpProxy *) proxy,
      MC_IFACE_QUARK_NMC4, "PresenceChanged",
      expected_types,
      G_CALLBACK (_mc_cli_nmc4_collect_args_of_presence_changed),
      _mc_cli_nmc4_invoke_callback_for_presence_changed,
      G_CALLBACK (callback), user_data, destroy,
      weak_object, error);
}

/**
 * mc_cli_nmc4_signal_callback_presence_status_actual:
 * @proxy: The proxy on which mc_cli_nmc4_connect_to_presence_status_actual ()
 *  was called
 * @arg_presence: <![CDATA[The actual presence]]>
 * @user_data: User-supplied data
 * @weak_object: User-supplied weakly referenced object
 *
 * Represents the signature of a callback for the signal PresenceStatusActual.
 */
static void
_mc_cli_nmc4_collect_args_of_presence_status_actual (DBusGProxy *proxy,
    guint arg_presence,
    TpProxySignalConnection *sc)
{
  GValueArray *args = g_value_array_new (1);
  GValue blank = { 0 };
  guint i;

  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 1; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, G_TYPE_UINT);
  g_value_set_uint (args->values + 0, arg_presence);

  tp_proxy_signal_connection_v0_take_results (sc, args);
}
static void
_mc_cli_nmc4_invoke_callback_for_presence_status_actual (TpProxy *tpproxy,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  mc_cli_nmc4_signal_callback_presence_status_actual callback =
      (mc_cli_nmc4_signal_callback_presence_status_actual) generic_callback;

  if (callback != NULL)
    callback (g_object_ref (tpproxy),
      g_value_get_uint (args->values + 0),
      user_data,
      weak_object);

  g_value_array_free (args);
  g_object_unref (tpproxy);
}
/**
 * mc_cli_nmc4_connect_to_presence_status_actual:
 * @proxy: A #TpProxy or subclass
 * @callback: Callback to be called when the signal is
 *   received
 * @user_data: User-supplied data for the callback
 * @destroy: Destructor for the user-supplied data, which
 *   will be called when this signal is disconnected, or
 *   before this function returns %NULL
 * @weak_object: A #GObject which will be weakly referenced; 
 *   if it is destroyed, this callback will automatically be
 *   disconnected
 * @error: If not %NULL, used to raise an error if %NULL is
 *   returned
 *
 * Connect a handler to the signal PresenceStatusActual.
 *
 * <![CDATA[Emitted when the actual presence has changed.         DEPRECATED]]>
 *
 * Returns: a #TpProxySignalConnection containing all of the
 * above, which can be used to disconnect the signal; or
 * %NULL if the proxy does not have the desired interface
 * or has become invalid.
 */
TpProxySignalConnection *
mc_cli_nmc4_connect_to_presence_status_actual (gpointer proxy,
    mc_cli_nmc4_signal_callback_presence_status_actual callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error)
{
  GType expected_types[2] = {
      G_TYPE_UINT,
      G_TYPE_INVALID };

  g_return_val_if_fail (TP_IS_PROXY (proxy), NULL);
  g_return_val_if_fail (callback != NULL, NULL);

  return tp_proxy_signal_connection_v0_new ((TpProxy *) proxy,
      MC_IFACE_QUARK_NMC4, "PresenceStatusActual",
      expected_types,
      G_CALLBACK (_mc_cli_nmc4_collect_args_of_presence_status_actual),
      _mc_cli_nmc4_invoke_callback_for_presence_status_actual,
      G_CALLBACK (callback), user_data, destroy,
      weak_object, error);
}

/**
 * mc_cli_nmc4_signal_callback_used_channels_count_changed:
 * @proxy: The proxy on which mc_cli_nmc4_connect_to_used_channels_count_changed ()
 *  was called
 * @arg_type: <![CDATA[D-Bus interface name representing the channel type]]>
 * @arg_count: <![CDATA[The number of channels of this type]]>
 * @user_data: User-supplied data
 * @weak_object: User-supplied weakly referenced object
 *
 * Represents the signature of a callback for the signal UsedChannelsCountChanged.
 */
static void
_mc_cli_nmc4_collect_args_of_used_channels_count_changed (DBusGProxy *proxy,
    const gchar *arg_type,
    guint arg_count,
    TpProxySignalConnection *sc)
{
  GValueArray *args = g_value_array_new (2);
  GValue blank = { 0 };
  guint i;

  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 2; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, G_TYPE_STRING);
  g_value_set_string (args->values + 0, arg_type);

  g_value_unset (args->values + 1);
  g_value_init (args->values + 1, G_TYPE_UINT);
  g_value_set_uint (args->values + 1, arg_count);

  tp_proxy_signal_connection_v0_take_results (sc, args);
}
static void
_mc_cli_nmc4_invoke_callback_for_used_channels_count_changed (TpProxy *tpproxy,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  mc_cli_nmc4_signal_callback_used_channels_count_changed callback =
      (mc_cli_nmc4_signal_callback_used_channels_count_changed) generic_callback;

  if (callback != NULL)
    callback (g_object_ref (tpproxy),
      g_value_get_string (args->values + 0),
      g_value_get_uint (args->values + 1),
      user_data,
      weak_object);

  g_value_array_free (args);
  g_object_unref (tpproxy);
}
/**
 * mc_cli_nmc4_connect_to_used_channels_count_changed:
 * @proxy: A #TpProxy or subclass
 * @callback: Callback to be called when the signal is
 *   received
 * @user_data: User-supplied data for the callback
 * @destroy: Destructor for the user-supplied data, which
 *   will be called when this signal is disconnected, or
 *   before this function returns %NULL
 * @weak_object: A #GObject which will be weakly referenced; 
 *   if it is destroyed, this callback will automatically be
 *   disconnected
 * @error: If not %NULL, used to raise an error if %NULL is
 *   returned
 *
 * Connect a handler to the signal UsedChannelsCountChanged.
 *
 * <![CDATA[Emitted when the number of channels of a specified type has changed.]]>
 *
 * Returns: a #TpProxySignalConnection containing all of the
 * above, which can be used to disconnect the signal; or
 * %NULL if the proxy does not have the desired interface
 * or has become invalid.
 */
TpProxySignalConnection *
mc_cli_nmc4_connect_to_used_channels_count_changed (gpointer proxy,
    mc_cli_nmc4_signal_callback_used_channels_count_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error)
{
  GType expected_types[3] = {
      G_TYPE_STRING,
      G_TYPE_UINT,
      G_TYPE_INVALID };

  g_return_val_if_fail (TP_IS_PROXY (proxy), NULL);
  g_return_val_if_fail (callback != NULL, NULL);

  return tp_proxy_signal_connection_v0_new ((TpProxy *) proxy,
      MC_IFACE_QUARK_NMC4, "UsedChannelsCountChanged",
      expected_types,
      G_CALLBACK (_mc_cli_nmc4_collect_args_of_used_channels_count_changed),
      _mc_cli_nmc4_invoke_callback_for_used_channels_count_changed,
      G_CALLBACK (callback), user_data, destroy,
      weak_object, error);
}

/**
 * mc_cli_nmc4_signal_callback_status_actual:
 * @proxy: The proxy on which mc_cli_nmc4_connect_to_status_actual ()
 *  was called
 * @arg_status: <![CDATA[The actual status, meaning:           <ul>             <li>disconnected - all accounts are disconnected</li>             <li>connecting - at least one account is connecting</li>             <li>connected - at least one account is connected, and no account is connecting</li>           </ul>]]>
 * @arg_presence: <![CDATA[The actual presence]]>
 * @user_data: User-supplied data
 * @weak_object: User-supplied weakly referenced object
 *
 * Represents the signature of a callback for the signal StatusActual.
 */
static void
_mc_cli_nmc4_collect_args_of_status_actual (DBusGProxy *proxy,
    guint arg_status,
    guint arg_presence,
    TpProxySignalConnection *sc)
{
  GValueArray *args = g_value_array_new (2);
  GValue blank = { 0 };
  guint i;

  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 2; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, G_TYPE_UINT);
  g_value_set_uint (args->values + 0, arg_status);

  g_value_unset (args->values + 1);
  g_value_init (args->values + 1, G_TYPE_UINT);
  g_value_set_uint (args->values + 1, arg_presence);

  tp_proxy_signal_connection_v0_take_results (sc, args);
}
static void
_mc_cli_nmc4_invoke_callback_for_status_actual (TpProxy *tpproxy,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  mc_cli_nmc4_signal_callback_status_actual callback =
      (mc_cli_nmc4_signal_callback_status_actual) generic_callback;

  if (callback != NULL)
    callback (g_object_ref (tpproxy),
      g_value_get_uint (args->values + 0),
      g_value_get_uint (args->values + 1),
      user_data,
      weak_object);

  g_value_array_free (args);
  g_object_unref (tpproxy);
}
/**
 * mc_cli_nmc4_connect_to_status_actual:
 * @proxy: A #TpProxy or subclass
 * @callback: Callback to be called when the signal is
 *   received
 * @user_data: User-supplied data for the callback
 * @destroy: Destructor for the user-supplied data, which
 *   will be called when this signal is disconnected, or
 *   before this function returns %NULL
 * @weak_object: A #GObject which will be weakly referenced; 
 *   if it is destroyed, this callback will automatically be
 *   disconnected
 * @error: If not %NULL, used to raise an error if %NULL is
 *   returned
 *
 * Connect a handler to the signal StatusActual.
 *
 * <![CDATA[Emitted when the global connection status changes.]]>
 *
 * Returns: a #TpProxySignalConnection containing all of the
 * above, which can be used to disconnect the signal; or
 * %NULL if the proxy does not have the desired interface
 * or has become invalid.
 */
TpProxySignalConnection *
mc_cli_nmc4_connect_to_status_actual (gpointer proxy,
    mc_cli_nmc4_signal_callback_status_actual callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error)
{
  GType expected_types[3] = {
      G_TYPE_UINT,
      G_TYPE_UINT,
      G_TYPE_INVALID };

  g_return_val_if_fail (TP_IS_PROXY (proxy), NULL);
  g_return_val_if_fail (callback != NULL, NULL);

  return tp_proxy_signal_connection_v0_new ((TpProxy *) proxy,
      MC_IFACE_QUARK_NMC4, "StatusActual",
      expected_types,
      G_CALLBACK (_mc_cli_nmc4_collect_args_of_status_actual),
      _mc_cli_nmc4_invoke_callback_for_status_actual,
      G_CALLBACK (callback), user_data, destroy,
      weak_object, error);
}

/**
 * mc_cli_nmc4_callback_for_set_presence:
 * @proxy: the proxy on which the call was made
 * @error: %NULL on success, or an error on failure
 * @user_data: user-supplied data
 * @weak_object: user-supplied object
 *
 * Signature of the callback called when a SetPresence method call
 * succeeds or fails.
 */
static void
_mc_cli_nmc4_collect_callback_set_presence (DBusGProxy *proxy,
    DBusGProxyCall *call,
    gpointer user_data)
{
  GError *error = NULL;

  dbus_g_proxy_end_call (proxy, call, &error,
      G_TYPE_INVALID);
  tp_proxy_pending_call_v0_take_results (user_data, error,NULL);
}
static void
_mc_cli_nmc4_invoke_callback_set_presence (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  mc_cli_nmc4_callback_for_set_presence callback = (mc_cli_nmc4_callback_for_set_presence) generic_callback;

  if (error != NULL)
    {
      callback ((TpProxy *) self,
          error, user_data, weak_object);
      g_error_free (error);
      return;
    }
  callback ((TpProxy *) self,
      error, user_data, weak_object);

  if (args != NULL)
    g_value_array_free (args);
}

/**
 * mc_cli_nmc4_call_set_presence:
 * @proxy: the #TpProxy
 * @timeout_ms: the timeout in milliseconds, or -1 to use the
 *   default
 * @in_presence: Used to pass an 'in' argument: <![CDATA[The presence to set]]>
 * @in_message: Used to pass an 'in' argument: <![CDATA[The presence message]]>
 * @callback: called when the method call succeeds or fails
 * @user_data: user-supplied data passed to the callback
 * @destroy: called with the user_data as argument, after the
 *   call has succeeded, failed or been cancelled
 * @weak_object: A #GObject which will be weakly referenced; 
 *   if it is destroyed, this callback will automatically be
 *   disconnected
 *
 * Start a SetPresence method call.
 *
 * <![CDATA[Request a presence.]]>
 *
 * Returns: a #TpProxyPendingCall representing the call in
 *  progress. It is borrowed from the object, and will become
 *  invalid when the callback is called, the call is
 *  cancelled or the #TpProxy becomes invalid.
 */
TpProxyPendingCall *
mc_cli_nmc4_call_set_presence (gpointer proxy,
    gint timeout_ms,
    guint in_presence,
    const gchar *in_message,
    mc_cli_nmc4_callback_for_set_presence callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object)
{
  GError *error = NULL;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  DBusGProxy *iface;

  g_return_val_if_fail (TP_IS_PROXY (proxy), NULL);

  iface = tp_proxy_borrow_interface_by_id (
      (TpProxy *) proxy,
      interface, &error);

  if (iface == NULL)
    {
      if (callback != NULL)
        callback (proxy,
            error, user_data, weak_object);
      g_error_free (error);
      return NULL;
    }

  if (callback == NULL)
    {
      dbus_g_proxy_call_no_reply (iface, "SetPresence",
          G_TYPE_UINT, in_presence,
          G_TYPE_STRING, in_message,
          G_TYPE_INVALID);
      return NULL;
    }
  else
    {
      TpProxyPendingCall *data;

      data = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
          interface, "SetPresence", iface,
          _mc_cli_nmc4_invoke_callback_set_presence,
          G_CALLBACK (callback), user_data, destroy,
          weak_object, FALSE);
      tp_proxy_pending_call_v0_take_pending_call (data,
          dbus_g_proxy_begin_call_with_timeout (iface,
              "SetPresence",
              _mc_cli_nmc4_collect_callback_set_presence,
              data,
              tp_proxy_pending_call_v0_completed,
              timeout_ms,
              G_TYPE_UINT, in_presence,
              G_TYPE_STRING, in_message,
              G_TYPE_INVALID));

      return data;
    }
}

typedef struct {
    GMainLoop *loop;
    GError **error;
    gboolean success:1;
    gboolean completed:1;
} _mc_cli_nmc4_run_state_set_presence;
static void
_mc_cli_nmc4_finish_running_set_presence (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback unused,
    gpointer user_data,
    GObject *unused2)
{
  _mc_cli_nmc4_run_state_set_presence *state = user_data;

  state->success = (error == NULL);
  state->completed = TRUE;
  g_main_loop_quit (state->loop);

  if (error != NULL)
    {
      if (state->error != NULL)
        *state->error = error;
      else
        g_error_free (error);

      return;
    }

  if (args != NULL)
    g_value_array_free (args);
}

/**
 * mc_cli_nmc4_run_set_presence:
 * @proxy: A #TpProxy or subclass
 * @timeout_ms: Timeout in milliseconds, or -1 for default
 * @in_presence: Used to pass an 'in' argument: <![CDATA[The presence to set]]>
 * @in_message: Used to pass an 'in' argument: <![CDATA[The presence message]]>
 * @error: If not %NULL, used to return errors if %FALSE 
 *  is returned
 * @loop: If not %NULL, set before re-entering 
 *  the main loop, to point to a #GMainLoop 
 *  which can be used to cancel this call with 
 *  g_main_loop_quit(), causing a return of 
 *  %FALSE with @error set to %TP_DBUS_ERROR_CANCELLED
 *
 * Call the method SetPresence and run the main loop
 * until it returns. Before calling this method, you must
 * add a reference to any borrowed objects you need to keep,
 * and generally ensure that everything is in a consistent
 * state.
 *
 * <![CDATA[Request a presence.]]>
 *
 * Returns: TRUE on success, FALSE and sets @error on error
 */
gboolean
mc_cli_nmc4_run_set_presence (gpointer proxy,
    gint timeout_ms,
    guint in_presence,
    const gchar *in_message,
    GError **error,
    GMainLoop **loop)
{
  DBusGProxy *iface;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  TpProxyPendingCall *pc;
  _mc_cli_nmc4_run_state_set_presence state = {
      NULL /* loop */, error,
      FALSE /* completed */, FALSE /* success */ };

  g_return_val_if_fail (TP_IS_PROXY (proxy), FALSE);

  iface = tp_proxy_borrow_interface_by_id
       ((TpProxy *) proxy, interface, error);

  if (iface == NULL)
    return FALSE;

  state.loop = g_main_loop_new (NULL, FALSE);

  pc = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
      interface, "SetPresence", iface,
      _mc_cli_nmc4_finish_running_set_presence,
      NULL, &state, NULL, NULL, TRUE);

  if (loop != NULL)
    *loop = state.loop;

  tp_proxy_pending_call_v0_take_pending_call (pc,
      dbus_g_proxy_begin_call_with_timeout (iface,
          "SetPresence",
          _mc_cli_nmc4_collect_callback_set_presence,
          pc,
          tp_proxy_pending_call_v0_completed,
          timeout_ms,
              G_TYPE_UINT, in_presence,
              G_TYPE_STRING, in_message,
          G_TYPE_INVALID));

  if (!state.completed)
    g_main_loop_run (state.loop);

  if (!state.completed)
    tp_proxy_pending_call_cancel (pc);

  if (loop != NULL)
    *loop = NULL;

  g_main_loop_unref (state.loop);

  return state.success;
}


/**
 * mc_cli_nmc4_callback_for_get_presence:
 * @proxy: the proxy on which the call was made
 * @out0: Used to return an 'out' argument if @error is %NULL: <![CDATA[The presence]]>
 * @error: %NULL on success, or an error on failure
 * @user_data: user-supplied data
 * @weak_object: user-supplied object
 *
 * Signature of the callback called when a GetPresence method call
 * succeeds or fails.
 */
static void
_mc_cli_nmc4_collect_callback_get_presence (DBusGProxy *proxy,
    DBusGProxyCall *call,
    gpointer user_data)
{
  GError *error = NULL;
  GValueArray *args;
  GValue blank = { 0 };
  guint i;
  guint out0;

  dbus_g_proxy_end_call (proxy, call, &error,
      G_TYPE_UINT, &out0,
      G_TYPE_INVALID);

  if (error != NULL)
    {
      tp_proxy_pending_call_v0_take_results (user_data, error,
          NULL);
      return;
    }

  args = g_value_array_new (1);
  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 1; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, G_TYPE_UINT);
  g_value_set_uint (args->values + 0, out0);
  tp_proxy_pending_call_v0_take_results (user_data, NULL, args);
}
static void
_mc_cli_nmc4_invoke_callback_get_presence (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  mc_cli_nmc4_callback_for_get_presence callback = (mc_cli_nmc4_callback_for_get_presence) generic_callback;

  if (error != NULL)
    {
      callback ((TpProxy *) self,
          0,
          error, user_data, weak_object);
      g_error_free (error);
      return;
    }
  callback ((TpProxy *) self,
      g_value_get_uint (args->values + 0),
      error, user_data, weak_object);

  g_value_array_free (args);
}

/**
 * mc_cli_nmc4_call_get_presence:
 * @proxy: the #TpProxy
 * @timeout_ms: the timeout in milliseconds, or -1 to use the
 *   default
 * @callback: called when the method call succeeds or fails
 * @user_data: user-supplied data passed to the callback
 * @destroy: called with the user_data as argument, after the
 *   call has succeeded, failed or been cancelled
 * @weak_object: A #GObject which will be weakly referenced; 
 *   if it is destroyed, this callback will automatically be
 *   disconnected
 *
 * Start a GetPresence method call.
 *
 * <![CDATA[Gets the last requested presence.]]>
 *
 * Returns: a #TpProxyPendingCall representing the call in
 *  progress. It is borrowed from the object, and will become
 *  invalid when the callback is called, the call is
 *  cancelled or the #TpProxy becomes invalid.
 */
TpProxyPendingCall *
mc_cli_nmc4_call_get_presence (gpointer proxy,
    gint timeout_ms,
    mc_cli_nmc4_callback_for_get_presence callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object)
{
  GError *error = NULL;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  DBusGProxy *iface;

  g_return_val_if_fail (TP_IS_PROXY (proxy), NULL);

  iface = tp_proxy_borrow_interface_by_id (
      (TpProxy *) proxy,
      interface, &error);

  if (iface == NULL)
    {
      if (callback != NULL)
        callback (proxy,
            0,
            error, user_data, weak_object);
      g_error_free (error);
      return NULL;
    }

  if (callback == NULL)
    {
      dbus_g_proxy_call_no_reply (iface, "GetPresence",
          G_TYPE_INVALID);
      return NULL;
    }
  else
    {
      TpProxyPendingCall *data;

      data = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
          interface, "GetPresence", iface,
          _mc_cli_nmc4_invoke_callback_get_presence,
          G_CALLBACK (callback), user_data, destroy,
          weak_object, FALSE);
      tp_proxy_pending_call_v0_take_pending_call (data,
          dbus_g_proxy_begin_call_with_timeout (iface,
              "GetPresence",
              _mc_cli_nmc4_collect_callback_get_presence,
              data,
              tp_proxy_pending_call_v0_completed,
              timeout_ms,
              G_TYPE_INVALID));

      return data;
    }
}

typedef struct {
    GMainLoop *loop;
    GError **error;
    guint *out0;
    gboolean success:1;
    gboolean completed:1;
} _mc_cli_nmc4_run_state_get_presence;
static void
_mc_cli_nmc4_finish_running_get_presence (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback unused,
    gpointer user_data,
    GObject *unused2)
{
  _mc_cli_nmc4_run_state_get_presence *state = user_data;

  state->success = (error == NULL);
  state->completed = TRUE;
  g_main_loop_quit (state->loop);

  if (error != NULL)
    {
      if (state->error != NULL)
        *state->error = error;
      else
        g_error_free (error);

      return;
    }

  if (state->out0 != NULL)
    *state->out0 = g_value_get_uint (args->values + 0);

  g_value_array_free (args);
}

/**
 * mc_cli_nmc4_run_get_presence:
 * @proxy: A #TpProxy or subclass
 * @timeout_ms: Timeout in milliseconds, or -1 for default
 * @out0: Used to return an 'out' argument if %TRUE is returned: <![CDATA[The presence]]>
 * @error: If not %NULL, used to return errors if %FALSE 
 *  is returned
 * @loop: If not %NULL, set before re-entering 
 *  the main loop, to point to a #GMainLoop 
 *  which can be used to cancel this call with 
 *  g_main_loop_quit(), causing a return of 
 *  %FALSE with @error set to %TP_DBUS_ERROR_CANCELLED
 *
 * Call the method GetPresence and run the main loop
 * until it returns. Before calling this method, you must
 * add a reference to any borrowed objects you need to keep,
 * and generally ensure that everything is in a consistent
 * state.
 *
 * <![CDATA[Gets the last requested presence.]]>
 *
 * Returns: TRUE on success, FALSE and sets @error on error
 */
gboolean
mc_cli_nmc4_run_get_presence (gpointer proxy,
    gint timeout_ms,
    guint *out0,
    GError **error,
    GMainLoop **loop)
{
  DBusGProxy *iface;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  TpProxyPendingCall *pc;
  _mc_cli_nmc4_run_state_get_presence state = {
      NULL /* loop */, error,
    out0,
      FALSE /* completed */, FALSE /* success */ };

  g_return_val_if_fail (TP_IS_PROXY (proxy), FALSE);

  iface = tp_proxy_borrow_interface_by_id
       ((TpProxy *) proxy, interface, error);

  if (iface == NULL)
    return FALSE;

  state.loop = g_main_loop_new (NULL, FALSE);

  pc = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
      interface, "GetPresence", iface,
      _mc_cli_nmc4_finish_running_get_presence,
      NULL, &state, NULL, NULL, TRUE);

  if (loop != NULL)
    *loop = state.loop;

  tp_proxy_pending_call_v0_take_pending_call (pc,
      dbus_g_proxy_begin_call_with_timeout (iface,
          "GetPresence",
          _mc_cli_nmc4_collect_callback_get_presence,
          pc,
          tp_proxy_pending_call_v0_completed,
          timeout_ms,
          G_TYPE_INVALID));

  if (!state.completed)
    g_main_loop_run (state.loop);

  if (!state.completed)
    tp_proxy_pending_call_cancel (pc);

  if (loop != NULL)
    *loop = NULL;

  g_main_loop_unref (state.loop);

  return state.success;
}


/**
 * mc_cli_nmc4_callback_for_get_presence_message:
 * @proxy: the proxy on which the call was made
 * @out0: Used to return an 'out' argument if @error is %NULL: <![CDATA[The presence message]]>
 * @error: %NULL on success, or an error on failure
 * @user_data: user-supplied data
 * @weak_object: user-supplied object
 *
 * Signature of the callback called when a GetPresenceMessage method call
 * succeeds or fails.
 */
static void
_mc_cli_nmc4_collect_callback_get_presence_message (DBusGProxy *proxy,
    DBusGProxyCall *call,
    gpointer user_data)
{
  GError *error = NULL;
  GValueArray *args;
  GValue blank = { 0 };
  guint i;
  gchar *out0;

  dbus_g_proxy_end_call (proxy, call, &error,
      G_TYPE_STRING, &out0,
      G_TYPE_INVALID);

  if (error != NULL)
    {
      tp_proxy_pending_call_v0_take_results (user_data, error,
          NULL);
      return;
    }

  args = g_value_array_new (1);
  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 1; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, G_TYPE_STRING);
  g_value_take_string (args->values + 0, out0);
  tp_proxy_pending_call_v0_take_results (user_data, NULL, args);
}
static void
_mc_cli_nmc4_invoke_callback_get_presence_message (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  mc_cli_nmc4_callback_for_get_presence_message callback = (mc_cli_nmc4_callback_for_get_presence_message) generic_callback;

  if (error != NULL)
    {
      callback ((TpProxy *) self,
          NULL,
          error, user_data, weak_object);
      g_error_free (error);
      return;
    }
  callback ((TpProxy *) self,
      g_value_get_string (args->values + 0),
      error, user_data, weak_object);

  g_value_array_free (args);
}

/**
 * mc_cli_nmc4_call_get_presence_message:
 * @proxy: the #TpProxy
 * @timeout_ms: the timeout in milliseconds, or -1 to use the
 *   default
 * @callback: called when the method call succeeds or fails
 * @user_data: user-supplied data passed to the callback
 * @destroy: called with the user_data as argument, after the
 *   call has succeeded, failed or been cancelled
 * @weak_object: A #GObject which will be weakly referenced; 
 *   if it is destroyed, this callback will automatically be
 *   disconnected
 *
 * Start a GetPresenceMessage method call.
 *
 * <![CDATA[Gets the last requested presence message.]]>
 *
 * Returns: a #TpProxyPendingCall representing the call in
 *  progress. It is borrowed from the object, and will become
 *  invalid when the callback is called, the call is
 *  cancelled or the #TpProxy becomes invalid.
 */
TpProxyPendingCall *
mc_cli_nmc4_call_get_presence_message (gpointer proxy,
    gint timeout_ms,
    mc_cli_nmc4_callback_for_get_presence_message callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object)
{
  GError *error = NULL;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  DBusGProxy *iface;

  g_return_val_if_fail (TP_IS_PROXY (proxy), NULL);

  iface = tp_proxy_borrow_interface_by_id (
      (TpProxy *) proxy,
      interface, &error);

  if (iface == NULL)
    {
      if (callback != NULL)
        callback (proxy,
            NULL,
            error, user_data, weak_object);
      g_error_free (error);
      return NULL;
    }

  if (callback == NULL)
    {
      dbus_g_proxy_call_no_reply (iface, "GetPresenceMessage",
          G_TYPE_INVALID);
      return NULL;
    }
  else
    {
      TpProxyPendingCall *data;

      data = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
          interface, "GetPresenceMessage", iface,
          _mc_cli_nmc4_invoke_callback_get_presence_message,
          G_CALLBACK (callback), user_data, destroy,
          weak_object, FALSE);
      tp_proxy_pending_call_v0_take_pending_call (data,
          dbus_g_proxy_begin_call_with_timeout (iface,
              "GetPresenceMessage",
              _mc_cli_nmc4_collect_callback_get_presence_message,
              data,
              tp_proxy_pending_call_v0_completed,
              timeout_ms,
              G_TYPE_INVALID));

      return data;
    }
}

typedef struct {
    GMainLoop *loop;
    GError **error;
    gchar **out0;
    gboolean success:1;
    gboolean completed:1;
} _mc_cli_nmc4_run_state_get_presence_message;
static void
_mc_cli_nmc4_finish_running_get_presence_message (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback unused,
    gpointer user_data,
    GObject *unused2)
{
  _mc_cli_nmc4_run_state_get_presence_message *state = user_data;

  state->success = (error == NULL);
  state->completed = TRUE;
  g_main_loop_quit (state->loop);

  if (error != NULL)
    {
      if (state->error != NULL)
        *state->error = error;
      else
        g_error_free (error);

      return;
    }

  if (state->out0 != NULL)
    *state->out0 = g_value_dup_string (args->values + 0);

  g_value_array_free (args);
}

/**
 * mc_cli_nmc4_run_get_presence_message:
 * @proxy: A #TpProxy or subclass
 * @timeout_ms: Timeout in milliseconds, or -1 for default
 * @out0: Used to return an 'out' argument if %TRUE is returned: <![CDATA[The presence message]]>
 * @error: If not %NULL, used to return errors if %FALSE 
 *  is returned
 * @loop: If not %NULL, set before re-entering 
 *  the main loop, to point to a #GMainLoop 
 *  which can be used to cancel this call with 
 *  g_main_loop_quit(), causing a return of 
 *  %FALSE with @error set to %TP_DBUS_ERROR_CANCELLED
 *
 * Call the method GetPresenceMessage and run the main loop
 * until it returns. Before calling this method, you must
 * add a reference to any borrowed objects you need to keep,
 * and generally ensure that everything is in a consistent
 * state.
 *
 * <![CDATA[Gets the last requested presence message.]]>
 *
 * Returns: TRUE on success, FALSE and sets @error on error
 */
gboolean
mc_cli_nmc4_run_get_presence_message (gpointer proxy,
    gint timeout_ms,
    gchar **out0,
    GError **error,
    GMainLoop **loop)
{
  DBusGProxy *iface;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  TpProxyPendingCall *pc;
  _mc_cli_nmc4_run_state_get_presence_message state = {
      NULL /* loop */, error,
    out0,
      FALSE /* completed */, FALSE /* success */ };

  g_return_val_if_fail (TP_IS_PROXY (proxy), FALSE);

  iface = tp_proxy_borrow_interface_by_id
       ((TpProxy *) proxy, interface, error);

  if (iface == NULL)
    return FALSE;

  state.loop = g_main_loop_new (NULL, FALSE);

  pc = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
      interface, "GetPresenceMessage", iface,
      _mc_cli_nmc4_finish_running_get_presence_message,
      NULL, &state, NULL, NULL, TRUE);

  if (loop != NULL)
    *loop = state.loop;

  tp_proxy_pending_call_v0_take_pending_call (pc,
      dbus_g_proxy_begin_call_with_timeout (iface,
          "GetPresenceMessage",
          _mc_cli_nmc4_collect_callback_get_presence_message,
          pc,
          tp_proxy_pending_call_v0_completed,
          timeout_ms,
          G_TYPE_INVALID));

  if (!state.completed)
    g_main_loop_run (state.loop);

  if (!state.completed)
    tp_proxy_pending_call_cancel (pc);

  if (loop != NULL)
    *loop = NULL;

  g_main_loop_unref (state.loop);

  return state.success;
}


/**
 * mc_cli_nmc4_callback_for_get_presence_actual:
 * @proxy: the proxy on which the call was made
 * @out0: Used to return an 'out' argument if @error is %NULL: <![CDATA[The presence]]>
 * @error: %NULL on success, or an error on failure
 * @user_data: user-supplied data
 * @weak_object: user-supplied object
 *
 * Signature of the callback called when a GetPresenceActual method call
 * succeeds or fails.
 */
static void
_mc_cli_nmc4_collect_callback_get_presence_actual (DBusGProxy *proxy,
    DBusGProxyCall *call,
    gpointer user_data)
{
  GError *error = NULL;
  GValueArray *args;
  GValue blank = { 0 };
  guint i;
  guint out0;

  dbus_g_proxy_end_call (proxy, call, &error,
      G_TYPE_UINT, &out0,
      G_TYPE_INVALID);

  if (error != NULL)
    {
      tp_proxy_pending_call_v0_take_results (user_data, error,
          NULL);
      return;
    }

  args = g_value_array_new (1);
  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 1; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, G_TYPE_UINT);
  g_value_set_uint (args->values + 0, out0);
  tp_proxy_pending_call_v0_take_results (user_data, NULL, args);
}
static void
_mc_cli_nmc4_invoke_callback_get_presence_actual (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  mc_cli_nmc4_callback_for_get_presence_actual callback = (mc_cli_nmc4_callback_for_get_presence_actual) generic_callback;

  if (error != NULL)
    {
      callback ((TpProxy *) self,
          0,
          error, user_data, weak_object);
      g_error_free (error);
      return;
    }
  callback ((TpProxy *) self,
      g_value_get_uint (args->values + 0),
      error, user_data, weak_object);

  g_value_array_free (args);
}

/**
 * mc_cli_nmc4_call_get_presence_actual:
 * @proxy: the #TpProxy
 * @timeout_ms: the timeout in milliseconds, or -1 to use the
 *   default
 * @callback: called when the method call succeeds or fails
 * @user_data: user-supplied data passed to the callback
 * @destroy: called with the user_data as argument, after the
 *   call has succeeded, failed or been cancelled
 * @weak_object: A #GObject which will be weakly referenced; 
 *   if it is destroyed, this callback will automatically be
 *   disconnected
 *
 * Start a GetPresenceActual method call.
 *
 * <![CDATA[Gets the actual presence.]]>
 *
 * Returns: a #TpProxyPendingCall representing the call in
 *  progress. It is borrowed from the object, and will become
 *  invalid when the callback is called, the call is
 *  cancelled or the #TpProxy becomes invalid.
 */
TpProxyPendingCall *
mc_cli_nmc4_call_get_presence_actual (gpointer proxy,
    gint timeout_ms,
    mc_cli_nmc4_callback_for_get_presence_actual callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object)
{
  GError *error = NULL;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  DBusGProxy *iface;

  g_return_val_if_fail (TP_IS_PROXY (proxy), NULL);

  iface = tp_proxy_borrow_interface_by_id (
      (TpProxy *) proxy,
      interface, &error);

  if (iface == NULL)
    {
      if (callback != NULL)
        callback (proxy,
            0,
            error, user_data, weak_object);
      g_error_free (error);
      return NULL;
    }

  if (callback == NULL)
    {
      dbus_g_proxy_call_no_reply (iface, "GetPresenceActual",
          G_TYPE_INVALID);
      return NULL;
    }
  else
    {
      TpProxyPendingCall *data;

      data = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
          interface, "GetPresenceActual", iface,
          _mc_cli_nmc4_invoke_callback_get_presence_actual,
          G_CALLBACK (callback), user_data, destroy,
          weak_object, FALSE);
      tp_proxy_pending_call_v0_take_pending_call (data,
          dbus_g_proxy_begin_call_with_timeout (iface,
              "GetPresenceActual",
              _mc_cli_nmc4_collect_callback_get_presence_actual,
              data,
              tp_proxy_pending_call_v0_completed,
              timeout_ms,
              G_TYPE_INVALID));

      return data;
    }
}

typedef struct {
    GMainLoop *loop;
    GError **error;
    guint *out0;
    gboolean success:1;
    gboolean completed:1;
} _mc_cli_nmc4_run_state_get_presence_actual;
static void
_mc_cli_nmc4_finish_running_get_presence_actual (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback unused,
    gpointer user_data,
    GObject *unused2)
{
  _mc_cli_nmc4_run_state_get_presence_actual *state = user_data;

  state->success = (error == NULL);
  state->completed = TRUE;
  g_main_loop_quit (state->loop);

  if (error != NULL)
    {
      if (state->error != NULL)
        *state->error = error;
      else
        g_error_free (error);

      return;
    }

  if (state->out0 != NULL)
    *state->out0 = g_value_get_uint (args->values + 0);

  g_value_array_free (args);
}

/**
 * mc_cli_nmc4_run_get_presence_actual:
 * @proxy: A #TpProxy or subclass
 * @timeout_ms: Timeout in milliseconds, or -1 for default
 * @out0: Used to return an 'out' argument if %TRUE is returned: <![CDATA[The presence]]>
 * @error: If not %NULL, used to return errors if %FALSE 
 *  is returned
 * @loop: If not %NULL, set before re-entering 
 *  the main loop, to point to a #GMainLoop 
 *  which can be used to cancel this call with 
 *  g_main_loop_quit(), causing a return of 
 *  %FALSE with @error set to %TP_DBUS_ERROR_CANCELLED
 *
 * Call the method GetPresenceActual and run the main loop
 * until it returns. Before calling this method, you must
 * add a reference to any borrowed objects you need to keep,
 * and generally ensure that everything is in a consistent
 * state.
 *
 * <![CDATA[Gets the actual presence.]]>
 *
 * Returns: TRUE on success, FALSE and sets @error on error
 */
gboolean
mc_cli_nmc4_run_get_presence_actual (gpointer proxy,
    gint timeout_ms,
    guint *out0,
    GError **error,
    GMainLoop **loop)
{
  DBusGProxy *iface;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  TpProxyPendingCall *pc;
  _mc_cli_nmc4_run_state_get_presence_actual state = {
      NULL /* loop */, error,
    out0,
      FALSE /* completed */, FALSE /* success */ };

  g_return_val_if_fail (TP_IS_PROXY (proxy), FALSE);

  iface = tp_proxy_borrow_interface_by_id
       ((TpProxy *) proxy, interface, error);

  if (iface == NULL)
    return FALSE;

  state.loop = g_main_loop_new (NULL, FALSE);

  pc = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
      interface, "GetPresenceActual", iface,
      _mc_cli_nmc4_finish_running_get_presence_actual,
      NULL, &state, NULL, NULL, TRUE);

  if (loop != NULL)
    *loop = state.loop;

  tp_proxy_pending_call_v0_take_pending_call (pc,
      dbus_g_proxy_begin_call_with_timeout (iface,
          "GetPresenceActual",
          _mc_cli_nmc4_collect_callback_get_presence_actual,
          pc,
          tp_proxy_pending_call_v0_completed,
          timeout_ms,
          G_TYPE_INVALID));

  if (!state.completed)
    g_main_loop_run (state.loop);

  if (!state.completed)
    tp_proxy_pending_call_cancel (pc);

  if (loop != NULL)
    *loop = NULL;

  g_main_loop_unref (state.loop);

  return state.success;
}


/**
 * mc_cli_nmc4_callback_for_get_presence_message_actual:
 * @proxy: the proxy on which the call was made
 * @out0: Used to return an 'out' argument if @error is %NULL: <![CDATA[The presence message]]>
 * @error: %NULL on success, or an error on failure
 * @user_data: user-supplied data
 * @weak_object: user-supplied object
 *
 * Signature of the callback called when a GetPresenceMessageActual method call
 * succeeds or fails.
 */
static void
_mc_cli_nmc4_collect_callback_get_presence_message_actual (DBusGProxy *proxy,
    DBusGProxyCall *call,
    gpointer user_data)
{
  GError *error = NULL;
  GValueArray *args;
  GValue blank = { 0 };
  guint i;
  gchar *out0;

  dbus_g_proxy_end_call (proxy, call, &error,
      G_TYPE_STRING, &out0,
      G_TYPE_INVALID);

  if (error != NULL)
    {
      tp_proxy_pending_call_v0_take_results (user_data, error,
          NULL);
      return;
    }

  args = g_value_array_new (1);
  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 1; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, G_TYPE_STRING);
  g_value_take_string (args->values + 0, out0);
  tp_proxy_pending_call_v0_take_results (user_data, NULL, args);
}
static void
_mc_cli_nmc4_invoke_callback_get_presence_message_actual (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  mc_cli_nmc4_callback_for_get_presence_message_actual callback = (mc_cli_nmc4_callback_for_get_presence_message_actual) generic_callback;

  if (error != NULL)
    {
      callback ((TpProxy *) self,
          NULL,
          error, user_data, weak_object);
      g_error_free (error);
      return;
    }
  callback ((TpProxy *) self,
      g_value_get_string (args->values + 0),
      error, user_data, weak_object);

  g_value_array_free (args);
}

/**
 * mc_cli_nmc4_call_get_presence_message_actual:
 * @proxy: the #TpProxy
 * @timeout_ms: the timeout in milliseconds, or -1 to use the
 *   default
 * @callback: called when the method call succeeds or fails
 * @user_data: user-supplied data passed to the callback
 * @destroy: called with the user_data as argument, after the
 *   call has succeeded, failed or been cancelled
 * @weak_object: A #GObject which will be weakly referenced; 
 *   if it is destroyed, this callback will automatically be
 *   disconnected
 *
 * Start a GetPresenceMessageActual method call.
 *
 * <![CDATA[Gets the actual presence message.]]>
 *
 * Returns: a #TpProxyPendingCall representing the call in
 *  progress. It is borrowed from the object, and will become
 *  invalid when the callback is called, the call is
 *  cancelled or the #TpProxy becomes invalid.
 */
TpProxyPendingCall *
mc_cli_nmc4_call_get_presence_message_actual (gpointer proxy,
    gint timeout_ms,
    mc_cli_nmc4_callback_for_get_presence_message_actual callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object)
{
  GError *error = NULL;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  DBusGProxy *iface;

  g_return_val_if_fail (TP_IS_PROXY (proxy), NULL);

  iface = tp_proxy_borrow_interface_by_id (
      (TpProxy *) proxy,
      interface, &error);

  if (iface == NULL)
    {
      if (callback != NULL)
        callback (proxy,
            NULL,
            error, user_data, weak_object);
      g_error_free (error);
      return NULL;
    }

  if (callback == NULL)
    {
      dbus_g_proxy_call_no_reply (iface, "GetPresenceMessageActual",
          G_TYPE_INVALID);
      return NULL;
    }
  else
    {
      TpProxyPendingCall *data;

      data = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
          interface, "GetPresenceMessageActual", iface,
          _mc_cli_nmc4_invoke_callback_get_presence_message_actual,
          G_CALLBACK (callback), user_data, destroy,
          weak_object, FALSE);
      tp_proxy_pending_call_v0_take_pending_call (data,
          dbus_g_proxy_begin_call_with_timeout (iface,
              "GetPresenceMessageActual",
              _mc_cli_nmc4_collect_callback_get_presence_message_actual,
              data,
              tp_proxy_pending_call_v0_completed,
              timeout_ms,
              G_TYPE_INVALID));

      return data;
    }
}

typedef struct {
    GMainLoop *loop;
    GError **error;
    gchar **out0;
    gboolean success:1;
    gboolean completed:1;
} _mc_cli_nmc4_run_state_get_presence_message_actual;
static void
_mc_cli_nmc4_finish_running_get_presence_message_actual (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback unused,
    gpointer user_data,
    GObject *unused2)
{
  _mc_cli_nmc4_run_state_get_presence_message_actual *state = user_data;

  state->success = (error == NULL);
  state->completed = TRUE;
  g_main_loop_quit (state->loop);

  if (error != NULL)
    {
      if (state->error != NULL)
        *state->error = error;
      else
        g_error_free (error);

      return;
    }

  if (state->out0 != NULL)
    *state->out0 = g_value_dup_string (args->values + 0);

  g_value_array_free (args);
}

/**
 * mc_cli_nmc4_run_get_presence_message_actual:
 * @proxy: A #TpProxy or subclass
 * @timeout_ms: Timeout in milliseconds, or -1 for default
 * @out0: Used to return an 'out' argument if %TRUE is returned: <![CDATA[The presence message]]>
 * @error: If not %NULL, used to return errors if %FALSE 
 *  is returned
 * @loop: If not %NULL, set before re-entering 
 *  the main loop, to point to a #GMainLoop 
 *  which can be used to cancel this call with 
 *  g_main_loop_quit(), causing a return of 
 *  %FALSE with @error set to %TP_DBUS_ERROR_CANCELLED
 *
 * Call the method GetPresenceMessageActual and run the main loop
 * until it returns. Before calling this method, you must
 * add a reference to any borrowed objects you need to keep,
 * and generally ensure that everything is in a consistent
 * state.
 *
 * <![CDATA[Gets the actual presence message.]]>
 *
 * Returns: TRUE on success, FALSE and sets @error on error
 */
gboolean
mc_cli_nmc4_run_get_presence_message_actual (gpointer proxy,
    gint timeout_ms,
    gchar **out0,
    GError **error,
    GMainLoop **loop)
{
  DBusGProxy *iface;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  TpProxyPendingCall *pc;
  _mc_cli_nmc4_run_state_get_presence_message_actual state = {
      NULL /* loop */, error,
    out0,
      FALSE /* completed */, FALSE /* success */ };

  g_return_val_if_fail (TP_IS_PROXY (proxy), FALSE);

  iface = tp_proxy_borrow_interface_by_id
       ((TpProxy *) proxy, interface, error);

  if (iface == NULL)
    return FALSE;

  state.loop = g_main_loop_new (NULL, FALSE);

  pc = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
      interface, "GetPresenceMessageActual", iface,
      _mc_cli_nmc4_finish_running_get_presence_message_actual,
      NULL, &state, NULL, NULL, TRUE);

  if (loop != NULL)
    *loop = state.loop;

  tp_proxy_pending_call_v0_take_pending_call (pc,
      dbus_g_proxy_begin_call_with_timeout (iface,
          "GetPresenceMessageActual",
          _mc_cli_nmc4_collect_callback_get_presence_message_actual,
          pc,
          tp_proxy_pending_call_v0_completed,
          timeout_ms,
          G_TYPE_INVALID));

  if (!state.completed)
    g_main_loop_run (state.loop);

  if (!state.completed)
    tp_proxy_pending_call_cancel (pc);

  if (loop != NULL)
    *loop = NULL;

  g_main_loop_unref (state.loop);

  return state.success;
}


/**
 * mc_cli_nmc4_callback_for_request_channel:
 * @proxy: the proxy on which the call was made
 * @error: %NULL on success, or an error on failure
 * @user_data: user-supplied data
 * @weak_object: user-supplied object
 *
 * Signature of the callback called when a RequestChannel method call
 * succeeds or fails.
 */
static void
_mc_cli_nmc4_collect_callback_request_channel (DBusGProxy *proxy,
    DBusGProxyCall *call,
    gpointer user_data)
{
  GError *error = NULL;

  dbus_g_proxy_end_call (proxy, call, &error,
      G_TYPE_INVALID);
  tp_proxy_pending_call_v0_take_results (user_data, error,NULL);
}
static void
_mc_cli_nmc4_invoke_callback_request_channel (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  mc_cli_nmc4_callback_for_request_channel callback = (mc_cli_nmc4_callback_for_request_channel) generic_callback;

  if (error != NULL)
    {
      callback ((TpProxy *) self,
          error, user_data, weak_object);
      g_error_free (error);
      return;
    }
  callback ((TpProxy *) self,
      error, user_data, weak_object);

  if (args != NULL)
    g_value_array_free (args);
}

/**
 * mc_cli_nmc4_call_request_channel:
 * @proxy: the #TpProxy
 * @timeout_ms: the timeout in milliseconds, or -1 to use the
 *   default
 * @in_account_name: Used to pass an 'in' argument: <![CDATA[Account requesting the channel.]]>
 * @in_type: Used to pass an 'in' argument: <![CDATA[D-Bus interface name representing the channel type]]>
 * @in_handle: Used to pass an 'in' argument: <![CDATA[A nonzero integer handle representing a contact, room,           list, etc.]]>
 * @in_handle_type: Used to pass an 'in' argument: <![CDATA[A integer representing the channel type]]>
 * @in_serial: Used to pass an 'in' argument: <![CDATA[A integer representing an operation ID, which can then be           used for cancelling the request]]>
 * @callback: called when the method call succeeds or fails
 * @user_data: user-supplied data passed to the callback
 * @destroy: called with the user_data as argument, after the
 *   call has succeeded, failed or been cancelled
 * @weak_object: A #GObject which will be weakly referenced; 
 *   if it is destroyed, this callback will automatically be
 *   disconnected
 *
 * Start a RequestChannel method call.
 *
 * <![CDATA[Requests a channel.]]>
 *
 * Returns: a #TpProxyPendingCall representing the call in
 *  progress. It is borrowed from the object, and will become
 *  invalid when the callback is called, the call is
 *  cancelled or the #TpProxy becomes invalid.
 */
TpProxyPendingCall *
mc_cli_nmc4_call_request_channel (gpointer proxy,
    gint timeout_ms,
    const gchar *in_account_name,
    const gchar *in_type,
    guint in_handle,
    gint in_handle_type,
    guint in_serial,
    mc_cli_nmc4_callback_for_request_channel callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object)
{
  GError *error = NULL;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  DBusGProxy *iface;

  g_return_val_if_fail (TP_IS_PROXY (proxy), NULL);

  iface = tp_proxy_borrow_interface_by_id (
      (TpProxy *) proxy,
      interface, &error);

  if (iface == NULL)
    {
      if (callback != NULL)
        callback (proxy,
            error, user_data, weak_object);
      g_error_free (error);
      return NULL;
    }

  if (callback == NULL)
    {
      dbus_g_proxy_call_no_reply (iface, "RequestChannel",
          G_TYPE_STRING, in_account_name,
          G_TYPE_STRING, in_type,
          G_TYPE_UINT, in_handle,
          G_TYPE_INT, in_handle_type,
          G_TYPE_UINT, in_serial,
          G_TYPE_INVALID);
      return NULL;
    }
  else
    {
      TpProxyPendingCall *data;

      data = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
          interface, "RequestChannel", iface,
          _mc_cli_nmc4_invoke_callback_request_channel,
          G_CALLBACK (callback), user_data, destroy,
          weak_object, FALSE);
      tp_proxy_pending_call_v0_take_pending_call (data,
          dbus_g_proxy_begin_call_with_timeout (iface,
              "RequestChannel",
              _mc_cli_nmc4_collect_callback_request_channel,
              data,
              tp_proxy_pending_call_v0_completed,
              timeout_ms,
              G_TYPE_STRING, in_account_name,
              G_TYPE_STRING, in_type,
              G_TYPE_UINT, in_handle,
              G_TYPE_INT, in_handle_type,
              G_TYPE_UINT, in_serial,
              G_TYPE_INVALID));

      return data;
    }
}

typedef struct {
    GMainLoop *loop;
    GError **error;
    gboolean success:1;
    gboolean completed:1;
} _mc_cli_nmc4_run_state_request_channel;
static void
_mc_cli_nmc4_finish_running_request_channel (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback unused,
    gpointer user_data,
    GObject *unused2)
{
  _mc_cli_nmc4_run_state_request_channel *state = user_data;

  state->success = (error == NULL);
  state->completed = TRUE;
  g_main_loop_quit (state->loop);

  if (error != NULL)
    {
      if (state->error != NULL)
        *state->error = error;
      else
        g_error_free (error);

      return;
    }

  if (args != NULL)
    g_value_array_free (args);
}

/**
 * mc_cli_nmc4_run_request_channel:
 * @proxy: A #TpProxy or subclass
 * @timeout_ms: Timeout in milliseconds, or -1 for default
 * @in_account_name: Used to pass an 'in' argument: <![CDATA[Account requesting the channel.]]>
 * @in_type: Used to pass an 'in' argument: <![CDATA[D-Bus interface name representing the channel type]]>
 * @in_handle: Used to pass an 'in' argument: <![CDATA[A nonzero integer handle representing a contact, room,           list, etc.]]>
 * @in_handle_type: Used to pass an 'in' argument: <![CDATA[A integer representing the channel type]]>
 * @in_serial: Used to pass an 'in' argument: <![CDATA[A integer representing an operation ID, which can then be           used for cancelling the request]]>
 * @error: If not %NULL, used to return errors if %FALSE 
 *  is returned
 * @loop: If not %NULL, set before re-entering 
 *  the main loop, to point to a #GMainLoop 
 *  which can be used to cancel this call with 
 *  g_main_loop_quit(), causing a return of 
 *  %FALSE with @error set to %TP_DBUS_ERROR_CANCELLED
 *
 * Call the method RequestChannel and run the main loop
 * until it returns. Before calling this method, you must
 * add a reference to any borrowed objects you need to keep,
 * and generally ensure that everything is in a consistent
 * state.
 *
 * <![CDATA[Requests a channel.]]>
 *
 * Returns: TRUE on success, FALSE and sets @error on error
 */
gboolean
mc_cli_nmc4_run_request_channel (gpointer proxy,
    gint timeout_ms,
    const gchar *in_account_name,
    const gchar *in_type,
    guint in_handle,
    gint in_handle_type,
    guint in_serial,
    GError **error,
    GMainLoop **loop)
{
  DBusGProxy *iface;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  TpProxyPendingCall *pc;
  _mc_cli_nmc4_run_state_request_channel state = {
      NULL /* loop */, error,
      FALSE /* completed */, FALSE /* success */ };

  g_return_val_if_fail (TP_IS_PROXY (proxy), FALSE);

  iface = tp_proxy_borrow_interface_by_id
       ((TpProxy *) proxy, interface, error);

  if (iface == NULL)
    return FALSE;

  state.loop = g_main_loop_new (NULL, FALSE);

  pc = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
      interface, "RequestChannel", iface,
      _mc_cli_nmc4_finish_running_request_channel,
      NULL, &state, NULL, NULL, TRUE);

  if (loop != NULL)
    *loop = state.loop;

  tp_proxy_pending_call_v0_take_pending_call (pc,
      dbus_g_proxy_begin_call_with_timeout (iface,
          "RequestChannel",
          _mc_cli_nmc4_collect_callback_request_channel,
          pc,
          tp_proxy_pending_call_v0_completed,
          timeout_ms,
              G_TYPE_STRING, in_account_name,
              G_TYPE_STRING, in_type,
              G_TYPE_UINT, in_handle,
              G_TYPE_INT, in_handle_type,
              G_TYPE_UINT, in_serial,
          G_TYPE_INVALID));

  if (!state.completed)
    g_main_loop_run (state.loop);

  if (!state.completed)
    tp_proxy_pending_call_cancel (pc);

  if (loop != NULL)
    *loop = NULL;

  g_main_loop_unref (state.loop);

  return state.success;
}


/**
 * mc_cli_nmc4_callback_for_request_channel_with_string_handle:
 * @proxy: the proxy on which the call was made
 * @error: %NULL on success, or an error on failure
 * @user_data: user-supplied data
 * @weak_object: user-supplied object
 *
 * Signature of the callback called when a RequestChannelWithStringHandle method call
 * succeeds or fails.
 */
static void
_mc_cli_nmc4_collect_callback_request_channel_with_string_handle (DBusGProxy *proxy,
    DBusGProxyCall *call,
    gpointer user_data)
{
  GError *error = NULL;

  dbus_g_proxy_end_call (proxy, call, &error,
      G_TYPE_INVALID);
  tp_proxy_pending_call_v0_take_results (user_data, error,NULL);
}
static void
_mc_cli_nmc4_invoke_callback_request_channel_with_string_handle (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  mc_cli_nmc4_callback_for_request_channel_with_string_handle callback = (mc_cli_nmc4_callback_for_request_channel_with_string_handle) generic_callback;

  if (error != NULL)
    {
      callback ((TpProxy *) self,
          error, user_data, weak_object);
      g_error_free (error);
      return;
    }
  callback ((TpProxy *) self,
      error, user_data, weak_object);

  if (args != NULL)
    g_value_array_free (args);
}

/**
 * mc_cli_nmc4_call_request_channel_with_string_handle:
 * @proxy: the #TpProxy
 * @timeout_ms: the timeout in milliseconds, or -1 to use the
 *   default
 * @in_account_name: Used to pass an 'in' argument: <![CDATA[Account requesting the channel.]]>
 * @in_type: Used to pass an 'in' argument: <![CDATA[D-Bus interface name representing the channel type]]>
 * @in_handle: Used to pass an 'in' argument: <![CDATA[A string handle representing a contact, room, list,           etc.]]>
 * @in_handle_type: Used to pass an 'in' argument: <![CDATA[A integer representing the channel type]]>
 * @in_serial: Used to pass an 'in' argument: <![CDATA[A integer representing an operation ID, which can then be           used for cancelling the request]]>
 * @callback: called when the method call succeeds or fails
 * @user_data: user-supplied data passed to the callback
 * @destroy: called with the user_data as argument, after the
 *   call has succeeded, failed or been cancelled
 * @weak_object: A #GObject which will be weakly referenced; 
 *   if it is destroyed, this callback will automatically be
 *   disconnected
 *
 * Start a RequestChannelWithStringHandle method call.
 *
 * <![CDATA[Requests a channel by a string handle.]]>
 *
 * Returns: a #TpProxyPendingCall representing the call in
 *  progress. It is borrowed from the object, and will become
 *  invalid when the callback is called, the call is
 *  cancelled or the #TpProxy becomes invalid.
 */
TpProxyPendingCall *
mc_cli_nmc4_call_request_channel_with_string_handle (gpointer proxy,
    gint timeout_ms,
    const gchar *in_account_name,
    const gchar *in_type,
    const gchar *in_handle,
    gint in_handle_type,
    guint in_serial,
    mc_cli_nmc4_callback_for_request_channel_with_string_handle callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object)
{
  GError *error = NULL;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  DBusGProxy *iface;

  g_return_val_if_fail (TP_IS_PROXY (proxy), NULL);

  iface = tp_proxy_borrow_interface_by_id (
      (TpProxy *) proxy,
      interface, &error);

  if (iface == NULL)
    {
      if (callback != NULL)
        callback (proxy,
            error, user_data, weak_object);
      g_error_free (error);
      return NULL;
    }

  if (callback == NULL)
    {
      dbus_g_proxy_call_no_reply (iface, "RequestChannelWithStringHandle",
          G_TYPE_STRING, in_account_name,
          G_TYPE_STRING, in_type,
          G_TYPE_STRING, in_handle,
          G_TYPE_INT, in_handle_type,
          G_TYPE_UINT, in_serial,
          G_TYPE_INVALID);
      return NULL;
    }
  else
    {
      TpProxyPendingCall *data;

      data = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
          interface, "RequestChannelWithStringHandle", iface,
          _mc_cli_nmc4_invoke_callback_request_channel_with_string_handle,
          G_CALLBACK (callback), user_data, destroy,
          weak_object, FALSE);
      tp_proxy_pending_call_v0_take_pending_call (data,
          dbus_g_proxy_begin_call_with_timeout (iface,
              "RequestChannelWithStringHandle",
              _mc_cli_nmc4_collect_callback_request_channel_with_string_handle,
              data,
              tp_proxy_pending_call_v0_completed,
              timeout_ms,
              G_TYPE_STRING, in_account_name,
              G_TYPE_STRING, in_type,
              G_TYPE_STRING, in_handle,
              G_TYPE_INT, in_handle_type,
              G_TYPE_UINT, in_serial,
              G_TYPE_INVALID));

      return data;
    }
}

typedef struct {
    GMainLoop *loop;
    GError **error;
    gboolean success:1;
    gboolean completed:1;
} _mc_cli_nmc4_run_state_request_channel_with_string_handle;
static void
_mc_cli_nmc4_finish_running_request_channel_with_string_handle (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback unused,
    gpointer user_data,
    GObject *unused2)
{
  _mc_cli_nmc4_run_state_request_channel_with_string_handle *state = user_data;

  state->success = (error == NULL);
  state->completed = TRUE;
  g_main_loop_quit (state->loop);

  if (error != NULL)
    {
      if (state->error != NULL)
        *state->error = error;
      else
        g_error_free (error);

      return;
    }

  if (args != NULL)
    g_value_array_free (args);
}

/**
 * mc_cli_nmc4_run_request_channel_with_string_handle:
 * @proxy: A #TpProxy or subclass
 * @timeout_ms: Timeout in milliseconds, or -1 for default
 * @in_account_name: Used to pass an 'in' argument: <![CDATA[Account requesting the channel.]]>
 * @in_type: Used to pass an 'in' argument: <![CDATA[D-Bus interface name representing the channel type]]>
 * @in_handle: Used to pass an 'in' argument: <![CDATA[A string handle representing a contact, room, list,           etc.]]>
 * @in_handle_type: Used to pass an 'in' argument: <![CDATA[A integer representing the channel type]]>
 * @in_serial: Used to pass an 'in' argument: <![CDATA[A integer representing an operation ID, which can then be           used for cancelling the request]]>
 * @error: If not %NULL, used to return errors if %FALSE 
 *  is returned
 * @loop: If not %NULL, set before re-entering 
 *  the main loop, to point to a #GMainLoop 
 *  which can be used to cancel this call with 
 *  g_main_loop_quit(), causing a return of 
 *  %FALSE with @error set to %TP_DBUS_ERROR_CANCELLED
 *
 * Call the method RequestChannelWithStringHandle and run the main loop
 * until it returns. Before calling this method, you must
 * add a reference to any borrowed objects you need to keep,
 * and generally ensure that everything is in a consistent
 * state.
 *
 * <![CDATA[Requests a channel by a string handle.]]>
 *
 * Returns: TRUE on success, FALSE and sets @error on error
 */
gboolean
mc_cli_nmc4_run_request_channel_with_string_handle (gpointer proxy,
    gint timeout_ms,
    const gchar *in_account_name,
    const gchar *in_type,
    const gchar *in_handle,
    gint in_handle_type,
    guint in_serial,
    GError **error,
    GMainLoop **loop)
{
  DBusGProxy *iface;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  TpProxyPendingCall *pc;
  _mc_cli_nmc4_run_state_request_channel_with_string_handle state = {
      NULL /* loop */, error,
      FALSE /* completed */, FALSE /* success */ };

  g_return_val_if_fail (TP_IS_PROXY (proxy), FALSE);

  iface = tp_proxy_borrow_interface_by_id
       ((TpProxy *) proxy, interface, error);

  if (iface == NULL)
    return FALSE;

  state.loop = g_main_loop_new (NULL, FALSE);

  pc = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
      interface, "RequestChannelWithStringHandle", iface,
      _mc_cli_nmc4_finish_running_request_channel_with_string_handle,
      NULL, &state, NULL, NULL, TRUE);

  if (loop != NULL)
    *loop = state.loop;

  tp_proxy_pending_call_v0_take_pending_call (pc,
      dbus_g_proxy_begin_call_with_timeout (iface,
          "RequestChannelWithStringHandle",
          _mc_cli_nmc4_collect_callback_request_channel_with_string_handle,
          pc,
          tp_proxy_pending_call_v0_completed,
          timeout_ms,
              G_TYPE_STRING, in_account_name,
              G_TYPE_STRING, in_type,
              G_TYPE_STRING, in_handle,
              G_TYPE_INT, in_handle_type,
              G_TYPE_UINT, in_serial,
          G_TYPE_INVALID));

  if (!state.completed)
    g_main_loop_run (state.loop);

  if (!state.completed)
    tp_proxy_pending_call_cancel (pc);

  if (loop != NULL)
    *loop = NULL;

  g_main_loop_unref (state.loop);

  return state.success;
}


/**
 * mc_cli_nmc4_callback_for_cancel_channel_request:
 * @proxy: the proxy on which the call was made
 * @error: %NULL on success, or an error on failure
 * @user_data: user-supplied data
 * @weak_object: user-supplied object
 *
 * Signature of the callback called when a CancelChannelRequest method call
 * succeeds or fails.
 */
static void
_mc_cli_nmc4_collect_callback_cancel_channel_request (DBusGProxy *proxy,
    DBusGProxyCall *call,
    gpointer user_data)
{
  GError *error = NULL;

  dbus_g_proxy_end_call (proxy, call, &error,
      G_TYPE_INVALID);
  tp_proxy_pending_call_v0_take_results (user_data, error,NULL);
}
static void
_mc_cli_nmc4_invoke_callback_cancel_channel_request (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  mc_cli_nmc4_callback_for_cancel_channel_request callback = (mc_cli_nmc4_callback_for_cancel_channel_request) generic_callback;

  if (error != NULL)
    {
      callback ((TpProxy *) self,
          error, user_data, weak_object);
      g_error_free (error);
      return;
    }
  callback ((TpProxy *) self,
      error, user_data, weak_object);

  if (args != NULL)
    g_value_array_free (args);
}

/**
 * mc_cli_nmc4_call_cancel_channel_request:
 * @proxy: the #TpProxy
 * @timeout_ms: the timeout in milliseconds, or -1 to use the
 *   default
 * @in_operation_id: Used to pass an 'in' argument: <![CDATA[The operation ID which identifies the channel request;           this is the same integet that was passed when making the           request]]>
 * @callback: called when the method call succeeds or fails
 * @user_data: user-supplied data passed to the callback
 * @destroy: called with the user_data as argument, after the
 *   call has succeeded, failed or been cancelled
 * @weak_object: A #GObject which will be weakly referenced; 
 *   if it is destroyed, this callback will automatically be
 *   disconnected
 *
 * Start a CancelChannelRequest method call.
 *
 * <![CDATA[Cancel a channel request.]]>
 *
 * Returns: a #TpProxyPendingCall representing the call in
 *  progress. It is borrowed from the object, and will become
 *  invalid when the callback is called, the call is
 *  cancelled or the #TpProxy becomes invalid.
 */
TpProxyPendingCall *
mc_cli_nmc4_call_cancel_channel_request (gpointer proxy,
    gint timeout_ms,
    guint in_operation_id,
    mc_cli_nmc4_callback_for_cancel_channel_request callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object)
{
  GError *error = NULL;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  DBusGProxy *iface;

  g_return_val_if_fail (TP_IS_PROXY (proxy), NULL);

  iface = tp_proxy_borrow_interface_by_id (
      (TpProxy *) proxy,
      interface, &error);

  if (iface == NULL)
    {
      if (callback != NULL)
        callback (proxy,
            error, user_data, weak_object);
      g_error_free (error);
      return NULL;
    }

  if (callback == NULL)
    {
      dbus_g_proxy_call_no_reply (iface, "CancelChannelRequest",
          G_TYPE_UINT, in_operation_id,
          G_TYPE_INVALID);
      return NULL;
    }
  else
    {
      TpProxyPendingCall *data;

      data = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
          interface, "CancelChannelRequest", iface,
          _mc_cli_nmc4_invoke_callback_cancel_channel_request,
          G_CALLBACK (callback), user_data, destroy,
          weak_object, FALSE);
      tp_proxy_pending_call_v0_take_pending_call (data,
          dbus_g_proxy_begin_call_with_timeout (iface,
              "CancelChannelRequest",
              _mc_cli_nmc4_collect_callback_cancel_channel_request,
              data,
              tp_proxy_pending_call_v0_completed,
              timeout_ms,
              G_TYPE_UINT, in_operation_id,
              G_TYPE_INVALID));

      return data;
    }
}

typedef struct {
    GMainLoop *loop;
    GError **error;
    gboolean success:1;
    gboolean completed:1;
} _mc_cli_nmc4_run_state_cancel_channel_request;
static void
_mc_cli_nmc4_finish_running_cancel_channel_request (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback unused,
    gpointer user_data,
    GObject *unused2)
{
  _mc_cli_nmc4_run_state_cancel_channel_request *state = user_data;

  state->success = (error == NULL);
  state->completed = TRUE;
  g_main_loop_quit (state->loop);

  if (error != NULL)
    {
      if (state->error != NULL)
        *state->error = error;
      else
        g_error_free (error);

      return;
    }

  if (args != NULL)
    g_value_array_free (args);
}

/**
 * mc_cli_nmc4_run_cancel_channel_request:
 * @proxy: A #TpProxy or subclass
 * @timeout_ms: Timeout in milliseconds, or -1 for default
 * @in_operation_id: Used to pass an 'in' argument: <![CDATA[The operation ID which identifies the channel request;           this is the same integet that was passed when making the           request]]>
 * @error: If not %NULL, used to return errors if %FALSE 
 *  is returned
 * @loop: If not %NULL, set before re-entering 
 *  the main loop, to point to a #GMainLoop 
 *  which can be used to cancel this call with 
 *  g_main_loop_quit(), causing a return of 
 *  %FALSE with @error set to %TP_DBUS_ERROR_CANCELLED
 *
 * Call the method CancelChannelRequest and run the main loop
 * until it returns. Before calling this method, you must
 * add a reference to any borrowed objects you need to keep,
 * and generally ensure that everything is in a consistent
 * state.
 *
 * <![CDATA[Cancel a channel request.]]>
 *
 * Returns: TRUE on success, FALSE and sets @error on error
 */
gboolean
mc_cli_nmc4_run_cancel_channel_request (gpointer proxy,
    gint timeout_ms,
    guint in_operation_id,
    GError **error,
    GMainLoop **loop)
{
  DBusGProxy *iface;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  TpProxyPendingCall *pc;
  _mc_cli_nmc4_run_state_cancel_channel_request state = {
      NULL /* loop */, error,
      FALSE /* completed */, FALSE /* success */ };

  g_return_val_if_fail (TP_IS_PROXY (proxy), FALSE);

  iface = tp_proxy_borrow_interface_by_id
       ((TpProxy *) proxy, interface, error);

  if (iface == NULL)
    return FALSE;

  state.loop = g_main_loop_new (NULL, FALSE);

  pc = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
      interface, "CancelChannelRequest", iface,
      _mc_cli_nmc4_finish_running_cancel_channel_request,
      NULL, &state, NULL, NULL, TRUE);

  if (loop != NULL)
    *loop = state.loop;

  tp_proxy_pending_call_v0_take_pending_call (pc,
      dbus_g_proxy_begin_call_with_timeout (iface,
          "CancelChannelRequest",
          _mc_cli_nmc4_collect_callback_cancel_channel_request,
          pc,
          tp_proxy_pending_call_v0_completed,
          timeout_ms,
              G_TYPE_UINT, in_operation_id,
          G_TYPE_INVALID));

  if (!state.completed)
    g_main_loop_run (state.loop);

  if (!state.completed)
    tp_proxy_pending_call_cancel (pc);

  if (loop != NULL)
    *loop = NULL;

  g_main_loop_unref (state.loop);

  return state.success;
}


/**
 * mc_cli_nmc4_callback_for_connect_all_with_default_presence:
 * @proxy: the proxy on which the call was made
 * @error: %NULL on success, or an error on failure
 * @user_data: user-supplied data
 * @weak_object: user-supplied object
 *
 * Signature of the callback called when a ConnectAllWithDefaultPresence method call
 * succeeds or fails.
 */
static void
_mc_cli_nmc4_collect_callback_connect_all_with_default_presence (DBusGProxy *proxy,
    DBusGProxyCall *call,
    gpointer user_data)
{
  GError *error = NULL;

  dbus_g_proxy_end_call (proxy, call, &error,
      G_TYPE_INVALID);
  tp_proxy_pending_call_v0_take_results (user_data, error,NULL);
}
static void
_mc_cli_nmc4_invoke_callback_connect_all_with_default_presence (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  mc_cli_nmc4_callback_for_connect_all_with_default_presence callback = (mc_cli_nmc4_callback_for_connect_all_with_default_presence) generic_callback;

  if (error != NULL)
    {
      callback ((TpProxy *) self,
          error, user_data, weak_object);
      g_error_free (error);
      return;
    }
  callback ((TpProxy *) self,
      error, user_data, weak_object);

  if (args != NULL)
    g_value_array_free (args);
}

/**
 * mc_cli_nmc4_call_connect_all_with_default_presence:
 * @proxy: the #TpProxy
 * @timeout_ms: the timeout in milliseconds, or -1 to use the
 *   default
 * @callback: called when the method call succeeds or fails
 * @user_data: user-supplied data passed to the callback
 * @destroy: called with the user_data as argument, after the
 *   call has succeeded, failed or been cancelled
 * @weak_object: A #GObject which will be weakly referenced; 
 *   if it is destroyed, this callback will automatically be
 *   disconnected
 *
 * Start a ConnectAllWithDefaultPresence method call.
 *
 * <![CDATA[Request all accounts to go online with the default presence.]]>
 *
 * Returns: a #TpProxyPendingCall representing the call in
 *  progress. It is borrowed from the object, and will become
 *  invalid when the callback is called, the call is
 *  cancelled or the #TpProxy becomes invalid.
 */
TpProxyPendingCall *
mc_cli_nmc4_call_connect_all_with_default_presence (gpointer proxy,
    gint timeout_ms,
    mc_cli_nmc4_callback_for_connect_all_with_default_presence callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object)
{
  GError *error = NULL;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  DBusGProxy *iface;

  g_return_val_if_fail (TP_IS_PROXY (proxy), NULL);

  iface = tp_proxy_borrow_interface_by_id (
      (TpProxy *) proxy,
      interface, &error);

  if (iface == NULL)
    {
      if (callback != NULL)
        callback (proxy,
            error, user_data, weak_object);
      g_error_free (error);
      return NULL;
    }

  if (callback == NULL)
    {
      dbus_g_proxy_call_no_reply (iface, "ConnectAllWithDefaultPresence",
          G_TYPE_INVALID);
      return NULL;
    }
  else
    {
      TpProxyPendingCall *data;

      data = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
          interface, "ConnectAllWithDefaultPresence", iface,
          _mc_cli_nmc4_invoke_callback_connect_all_with_default_presence,
          G_CALLBACK (callback), user_data, destroy,
          weak_object, FALSE);
      tp_proxy_pending_call_v0_take_pending_call (data,
          dbus_g_proxy_begin_call_with_timeout (iface,
              "ConnectAllWithDefaultPresence",
              _mc_cli_nmc4_collect_callback_connect_all_with_default_presence,
              data,
              tp_proxy_pending_call_v0_completed,
              timeout_ms,
              G_TYPE_INVALID));

      return data;
    }
}

typedef struct {
    GMainLoop *loop;
    GError **error;
    gboolean success:1;
    gboolean completed:1;
} _mc_cli_nmc4_run_state_connect_all_with_default_presence;
static void
_mc_cli_nmc4_finish_running_connect_all_with_default_presence (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback unused,
    gpointer user_data,
    GObject *unused2)
{
  _mc_cli_nmc4_run_state_connect_all_with_default_presence *state = user_data;

  state->success = (error == NULL);
  state->completed = TRUE;
  g_main_loop_quit (state->loop);

  if (error != NULL)
    {
      if (state->error != NULL)
        *state->error = error;
      else
        g_error_free (error);

      return;
    }

  if (args != NULL)
    g_value_array_free (args);
}

/**
 * mc_cli_nmc4_run_connect_all_with_default_presence:
 * @proxy: A #TpProxy or subclass
 * @timeout_ms: Timeout in milliseconds, or -1 for default
 * @error: If not %NULL, used to return errors if %FALSE 
 *  is returned
 * @loop: If not %NULL, set before re-entering 
 *  the main loop, to point to a #GMainLoop 
 *  which can be used to cancel this call with 
 *  g_main_loop_quit(), causing a return of 
 *  %FALSE with @error set to %TP_DBUS_ERROR_CANCELLED
 *
 * Call the method ConnectAllWithDefaultPresence and run the main loop
 * until it returns. Before calling this method, you must
 * add a reference to any borrowed objects you need to keep,
 * and generally ensure that everything is in a consistent
 * state.
 *
 * <![CDATA[Request all accounts to go online with the default presence.]]>
 *
 * Returns: TRUE on success, FALSE and sets @error on error
 */
gboolean
mc_cli_nmc4_run_connect_all_with_default_presence (gpointer proxy,
    gint timeout_ms,
    GError **error,
    GMainLoop **loop)
{
  DBusGProxy *iface;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  TpProxyPendingCall *pc;
  _mc_cli_nmc4_run_state_connect_all_with_default_presence state = {
      NULL /* loop */, error,
      FALSE /* completed */, FALSE /* success */ };

  g_return_val_if_fail (TP_IS_PROXY (proxy), FALSE);

  iface = tp_proxy_borrow_interface_by_id
       ((TpProxy *) proxy, interface, error);

  if (iface == NULL)
    return FALSE;

  state.loop = g_main_loop_new (NULL, FALSE);

  pc = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
      interface, "ConnectAllWithDefaultPresence", iface,
      _mc_cli_nmc4_finish_running_connect_all_with_default_presence,
      NULL, &state, NULL, NULL, TRUE);

  if (loop != NULL)
    *loop = state.loop;

  tp_proxy_pending_call_v0_take_pending_call (pc,
      dbus_g_proxy_begin_call_with_timeout (iface,
          "ConnectAllWithDefaultPresence",
          _mc_cli_nmc4_collect_callback_connect_all_with_default_presence,
          pc,
          tp_proxy_pending_call_v0_completed,
          timeout_ms,
          G_TYPE_INVALID));

  if (!state.completed)
    g_main_loop_run (state.loop);

  if (!state.completed)
    tp_proxy_pending_call_cancel (pc);

  if (loop != NULL)
    *loop = NULL;

  g_main_loop_unref (state.loop);

  return state.success;
}


/**
 * mc_cli_nmc4_callback_for_get_connection_status:
 * @proxy: the proxy on which the call was made
 * @out0: Used to return an 'out' argument if @error is %NULL: <![CDATA[Status of the connection]]>
 * @error: %NULL on success, or an error on failure
 * @user_data: user-supplied data
 * @weak_object: user-supplied object
 *
 * Signature of the callback called when a GetConnectionStatus method call
 * succeeds or fails.
 */
static void
_mc_cli_nmc4_collect_callback_get_connection_status (DBusGProxy *proxy,
    DBusGProxyCall *call,
    gpointer user_data)
{
  GError *error = NULL;
  GValueArray *args;
  GValue blank = { 0 };
  guint i;
  guint out0;

  dbus_g_proxy_end_call (proxy, call, &error,
      G_TYPE_UINT, &out0,
      G_TYPE_INVALID);

  if (error != NULL)
    {
      tp_proxy_pending_call_v0_take_results (user_data, error,
          NULL);
      return;
    }

  args = g_value_array_new (1);
  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 1; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, G_TYPE_UINT);
  g_value_set_uint (args->values + 0, out0);
  tp_proxy_pending_call_v0_take_results (user_data, NULL, args);
}
static void
_mc_cli_nmc4_invoke_callback_get_connection_status (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  mc_cli_nmc4_callback_for_get_connection_status callback = (mc_cli_nmc4_callback_for_get_connection_status) generic_callback;

  if (error != NULL)
    {
      callback ((TpProxy *) self,
          0,
          error, user_data, weak_object);
      g_error_free (error);
      return;
    }
  callback ((TpProxy *) self,
      g_value_get_uint (args->values + 0),
      error, user_data, weak_object);

  g_value_array_free (args);
}

/**
 * mc_cli_nmc4_call_get_connection_status:
 * @proxy: the #TpProxy
 * @timeout_ms: the timeout in milliseconds, or -1 to use the
 *   default
 * @in_account_name: Used to pass an 'in' argument: <![CDATA[The account]]>
 * @callback: called when the method call succeeds or fails
 * @user_data: user-supplied data passed to the callback
 * @destroy: called with the user_data as argument, after the
 *   call has succeeded, failed or been cancelled
 * @weak_object: A #GObject which will be weakly referenced; 
 *   if it is destroyed, this callback will automatically be
 *   disconnected
 *
 * Start a GetConnectionStatus method call.
 *
 * <![CDATA[Get the status of the connection.]]>
 *
 * Returns: a #TpProxyPendingCall representing the call in
 *  progress. It is borrowed from the object, and will become
 *  invalid when the callback is called, the call is
 *  cancelled or the #TpProxy becomes invalid.
 */
TpProxyPendingCall *
mc_cli_nmc4_call_get_connection_status (gpointer proxy,
    gint timeout_ms,
    const gchar *in_account_name,
    mc_cli_nmc4_callback_for_get_connection_status callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object)
{
  GError *error = NULL;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  DBusGProxy *iface;

  g_return_val_if_fail (TP_IS_PROXY (proxy), NULL);

  iface = tp_proxy_borrow_interface_by_id (
      (TpProxy *) proxy,
      interface, &error);

  if (iface == NULL)
    {
      if (callback != NULL)
        callback (proxy,
            0,
            error, user_data, weak_object);
      g_error_free (error);
      return NULL;
    }

  if (callback == NULL)
    {
      dbus_g_proxy_call_no_reply (iface, "GetConnectionStatus",
          G_TYPE_STRING, in_account_name,
          G_TYPE_INVALID);
      return NULL;
    }
  else
    {
      TpProxyPendingCall *data;

      data = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
          interface, "GetConnectionStatus", iface,
          _mc_cli_nmc4_invoke_callback_get_connection_status,
          G_CALLBACK (callback), user_data, destroy,
          weak_object, FALSE);
      tp_proxy_pending_call_v0_take_pending_call (data,
          dbus_g_proxy_begin_call_with_timeout (iface,
              "GetConnectionStatus",
              _mc_cli_nmc4_collect_callback_get_connection_status,
              data,
              tp_proxy_pending_call_v0_completed,
              timeout_ms,
              G_TYPE_STRING, in_account_name,
              G_TYPE_INVALID));

      return data;
    }
}

typedef struct {
    GMainLoop *loop;
    GError **error;
    guint *out0;
    gboolean success:1;
    gboolean completed:1;
} _mc_cli_nmc4_run_state_get_connection_status;
static void
_mc_cli_nmc4_finish_running_get_connection_status (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback unused,
    gpointer user_data,
    GObject *unused2)
{
  _mc_cli_nmc4_run_state_get_connection_status *state = user_data;

  state->success = (error == NULL);
  state->completed = TRUE;
  g_main_loop_quit (state->loop);

  if (error != NULL)
    {
      if (state->error != NULL)
        *state->error = error;
      else
        g_error_free (error);

      return;
    }

  if (state->out0 != NULL)
    *state->out0 = g_value_get_uint (args->values + 0);

  g_value_array_free (args);
}

/**
 * mc_cli_nmc4_run_get_connection_status:
 * @proxy: A #TpProxy or subclass
 * @timeout_ms: Timeout in milliseconds, or -1 for default
 * @in_account_name: Used to pass an 'in' argument: <![CDATA[The account]]>
 * @out0: Used to return an 'out' argument if %TRUE is returned: <![CDATA[Status of the connection]]>
 * @error: If not %NULL, used to return errors if %FALSE 
 *  is returned
 * @loop: If not %NULL, set before re-entering 
 *  the main loop, to point to a #GMainLoop 
 *  which can be used to cancel this call with 
 *  g_main_loop_quit(), causing a return of 
 *  %FALSE with @error set to %TP_DBUS_ERROR_CANCELLED
 *
 * Call the method GetConnectionStatus and run the main loop
 * until it returns. Before calling this method, you must
 * add a reference to any borrowed objects you need to keep,
 * and generally ensure that everything is in a consistent
 * state.
 *
 * <![CDATA[Get the status of the connection.]]>
 *
 * Returns: TRUE on success, FALSE and sets @error on error
 */
gboolean
mc_cli_nmc4_run_get_connection_status (gpointer proxy,
    gint timeout_ms,
    const gchar *in_account_name,
    guint *out0,
    GError **error,
    GMainLoop **loop)
{
  DBusGProxy *iface;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  TpProxyPendingCall *pc;
  _mc_cli_nmc4_run_state_get_connection_status state = {
      NULL /* loop */, error,
    out0,
      FALSE /* completed */, FALSE /* success */ };

  g_return_val_if_fail (TP_IS_PROXY (proxy), FALSE);

  iface = tp_proxy_borrow_interface_by_id
       ((TpProxy *) proxy, interface, error);

  if (iface == NULL)
    return FALSE;

  state.loop = g_main_loop_new (NULL, FALSE);

  pc = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
      interface, "GetConnectionStatus", iface,
      _mc_cli_nmc4_finish_running_get_connection_status,
      NULL, &state, NULL, NULL, TRUE);

  if (loop != NULL)
    *loop = state.loop;

  tp_proxy_pending_call_v0_take_pending_call (pc,
      dbus_g_proxy_begin_call_with_timeout (iface,
          "GetConnectionStatus",
          _mc_cli_nmc4_collect_callback_get_connection_status,
          pc,
          tp_proxy_pending_call_v0_completed,
          timeout_ms,
              G_TYPE_STRING, in_account_name,
          G_TYPE_INVALID));

  if (!state.completed)
    g_main_loop_run (state.loop);

  if (!state.completed)
    tp_proxy_pending_call_cancel (pc);

  if (loop != NULL)
    *loop = NULL;

  g_main_loop_unref (state.loop);

  return state.success;
}


/**
 * mc_cli_nmc4_callback_for_get_online_connections:
 * @proxy: the proxy on which the call was made
 * @out0: Used to return an 'out' argument if @error is %NULL: <![CDATA[The array of the online accounts]]>
 * @error: %NULL on success, or an error on failure
 * @user_data: user-supplied data
 * @weak_object: user-supplied object
 *
 * Signature of the callback called when a GetOnlineConnections method call
 * succeeds or fails.
 */
static void
_mc_cli_nmc4_collect_callback_get_online_connections (DBusGProxy *proxy,
    DBusGProxyCall *call,
    gpointer user_data)
{
  GError *error = NULL;
  GValueArray *args;
  GValue blank = { 0 };
  guint i;
  gchar **out0;

  dbus_g_proxy_end_call (proxy, call, &error,
      G_TYPE_STRV, &out0,
      G_TYPE_INVALID);

  if (error != NULL)
    {
      tp_proxy_pending_call_v0_take_results (user_data, error,
          NULL);
      return;
    }

  args = g_value_array_new (1);
  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 1; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, G_TYPE_STRV);
  g_value_take_boxed (args->values + 0, out0);
  tp_proxy_pending_call_v0_take_results (user_data, NULL, args);
}
static void
_mc_cli_nmc4_invoke_callback_get_online_connections (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  mc_cli_nmc4_callback_for_get_online_connections callback = (mc_cli_nmc4_callback_for_get_online_connections) generic_callback;

  if (error != NULL)
    {
      callback ((TpProxy *) self,
          NULL,
          error, user_data, weak_object);
      g_error_free (error);
      return;
    }
  callback ((TpProxy *) self,
      g_value_get_boxed (args->values + 0),
      error, user_data, weak_object);

  g_value_array_free (args);
}

/**
 * mc_cli_nmc4_call_get_online_connections:
 * @proxy: the #TpProxy
 * @timeout_ms: the timeout in milliseconds, or -1 to use the
 *   default
 * @callback: called when the method call succeeds or fails
 * @user_data: user-supplied data passed to the callback
 * @destroy: called with the user_data as argument, after the
 *   call has succeeded, failed or been cancelled
 * @weak_object: A #GObject which will be weakly referenced; 
 *   if it is destroyed, this callback will automatically be
 *   disconnected
 *
 * Start a GetOnlineConnections method call.
 *
 * <![CDATA[Get a list of the connected accounts.]]>
 *
 * Returns: a #TpProxyPendingCall representing the call in
 *  progress. It is borrowed from the object, and will become
 *  invalid when the callback is called, the call is
 *  cancelled or the #TpProxy becomes invalid.
 */
TpProxyPendingCall *
mc_cli_nmc4_call_get_online_connections (gpointer proxy,
    gint timeout_ms,
    mc_cli_nmc4_callback_for_get_online_connections callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object)
{
  GError *error = NULL;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  DBusGProxy *iface;

  g_return_val_if_fail (TP_IS_PROXY (proxy), NULL);

  iface = tp_proxy_borrow_interface_by_id (
      (TpProxy *) proxy,
      interface, &error);

  if (iface == NULL)
    {
      if (callback != NULL)
        callback (proxy,
            NULL,
            error, user_data, weak_object);
      g_error_free (error);
      return NULL;
    }

  if (callback == NULL)
    {
      dbus_g_proxy_call_no_reply (iface, "GetOnlineConnections",
          G_TYPE_INVALID);
      return NULL;
    }
  else
    {
      TpProxyPendingCall *data;

      data = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
          interface, "GetOnlineConnections", iface,
          _mc_cli_nmc4_invoke_callback_get_online_connections,
          G_CALLBACK (callback), user_data, destroy,
          weak_object, FALSE);
      tp_proxy_pending_call_v0_take_pending_call (data,
          dbus_g_proxy_begin_call_with_timeout (iface,
              "GetOnlineConnections",
              _mc_cli_nmc4_collect_callback_get_online_connections,
              data,
              tp_proxy_pending_call_v0_completed,
              timeout_ms,
              G_TYPE_INVALID));

      return data;
    }
}

typedef struct {
    GMainLoop *loop;
    GError **error;
    gchar ***out0;
    gboolean success:1;
    gboolean completed:1;
} _mc_cli_nmc4_run_state_get_online_connections;
static void
_mc_cli_nmc4_finish_running_get_online_connections (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback unused,
    gpointer user_data,
    GObject *unused2)
{
  _mc_cli_nmc4_run_state_get_online_connections *state = user_data;

  state->success = (error == NULL);
  state->completed = TRUE;
  g_main_loop_quit (state->loop);

  if (error != NULL)
    {
      if (state->error != NULL)
        *state->error = error;
      else
        g_error_free (error);

      return;
    }

  if (state->out0 != NULL)
    *state->out0 = g_value_dup_boxed (args->values + 0);

  g_value_array_free (args);
}

/**
 * mc_cli_nmc4_run_get_online_connections:
 * @proxy: A #TpProxy or subclass
 * @timeout_ms: Timeout in milliseconds, or -1 for default
 * @out0: Used to return an 'out' argument if %TRUE is returned: <![CDATA[The array of the online accounts]]>
 * @error: If not %NULL, used to return errors if %FALSE 
 *  is returned
 * @loop: If not %NULL, set before re-entering 
 *  the main loop, to point to a #GMainLoop 
 *  which can be used to cancel this call with 
 *  g_main_loop_quit(), causing a return of 
 *  %FALSE with @error set to %TP_DBUS_ERROR_CANCELLED
 *
 * Call the method GetOnlineConnections and run the main loop
 * until it returns. Before calling this method, you must
 * add a reference to any borrowed objects you need to keep,
 * and generally ensure that everything is in a consistent
 * state.
 *
 * <![CDATA[Get a list of the connected accounts.]]>
 *
 * Returns: TRUE on success, FALSE and sets @error on error
 */
gboolean
mc_cli_nmc4_run_get_online_connections (gpointer proxy,
    gint timeout_ms,
    gchar ***out0,
    GError **error,
    GMainLoop **loop)
{
  DBusGProxy *iface;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  TpProxyPendingCall *pc;
  _mc_cli_nmc4_run_state_get_online_connections state = {
      NULL /* loop */, error,
    out0,
      FALSE /* completed */, FALSE /* success */ };

  g_return_val_if_fail (TP_IS_PROXY (proxy), FALSE);

  iface = tp_proxy_borrow_interface_by_id
       ((TpProxy *) proxy, interface, error);

  if (iface == NULL)
    return FALSE;

  state.loop = g_main_loop_new (NULL, FALSE);

  pc = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
      interface, "GetOnlineConnections", iface,
      _mc_cli_nmc4_finish_running_get_online_connections,
      NULL, &state, NULL, NULL, TRUE);

  if (loop != NULL)
    *loop = state.loop;

  tp_proxy_pending_call_v0_take_pending_call (pc,
      dbus_g_proxy_begin_call_with_timeout (iface,
          "GetOnlineConnections",
          _mc_cli_nmc4_collect_callback_get_online_connections,
          pc,
          tp_proxy_pending_call_v0_completed,
          timeout_ms,
          G_TYPE_INVALID));

  if (!state.completed)
    g_main_loop_run (state.loop);

  if (!state.completed)
    tp_proxy_pending_call_cancel (pc);

  if (loop != NULL)
    *loop = NULL;

  g_main_loop_unref (state.loop);

  return state.success;
}


/**
 * mc_cli_nmc4_callback_for_get_connection:
 * @proxy: the proxy on which the call was made
 * @out0: Used to return an 'out' argument if @error is %NULL: <![CDATA[The D-Bus bus name of the Telepathy           connection]]>
 * @out1: Used to return an 'out' argument if @error is %NULL: <![CDATA[The D-Bus object path of the Telepathy           connection]]>
 * @error: %NULL on success, or an error on failure
 * @user_data: user-supplied data
 * @weak_object: user-supplied object
 *
 * Signature of the callback called when a GetConnection method call
 * succeeds or fails.
 */
static void
_mc_cli_nmc4_collect_callback_get_connection (DBusGProxy *proxy,
    DBusGProxyCall *call,
    gpointer user_data)
{
  GError *error = NULL;
  GValueArray *args;
  GValue blank = { 0 };
  guint i;
  gchar *out0;
  gchar *out1;

  dbus_g_proxy_end_call (proxy, call, &error,
      G_TYPE_STRING, &out0,
      DBUS_TYPE_G_OBJECT_PATH, &out1,
      G_TYPE_INVALID);

  if (error != NULL)
    {
      tp_proxy_pending_call_v0_take_results (user_data, error,
          NULL);
      return;
    }

  args = g_value_array_new (2);
  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 2; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, G_TYPE_STRING);
  g_value_take_string (args->values + 0, out0);

  g_value_unset (args->values + 1);
  g_value_init (args->values + 1, DBUS_TYPE_G_OBJECT_PATH);
  g_value_take_boxed (args->values + 1, out1);
  tp_proxy_pending_call_v0_take_results (user_data, NULL, args);
}
static void
_mc_cli_nmc4_invoke_callback_get_connection (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  mc_cli_nmc4_callback_for_get_connection callback = (mc_cli_nmc4_callback_for_get_connection) generic_callback;

  if (error != NULL)
    {
      callback ((TpProxy *) self,
          NULL,
          NULL,
          error, user_data, weak_object);
      g_error_free (error);
      return;
    }
  callback ((TpProxy *) self,
      g_value_get_string (args->values + 0),
      g_value_get_boxed (args->values + 1),
      error, user_data, weak_object);

  g_value_array_free (args);
}

/**
 * mc_cli_nmc4_call_get_connection:
 * @proxy: the #TpProxy
 * @timeout_ms: the timeout in milliseconds, or -1 to use the
 *   default
 * @in_account_name: Used to pass an 'in' argument: <![CDATA[The account]]>
 * @callback: called when the method call succeeds or fails
 * @user_data: user-supplied data passed to the callback
 * @destroy: called with the user_data as argument, after the
 *   call has succeeded, failed or been cancelled
 * @weak_object: A #GObject which will be weakly referenced; 
 *   if it is destroyed, this callback will automatically be
 *   disconnected
 *
 * Start a GetConnection method call.
 *
 * <![CDATA[Get the connection object of an account.]]>
 *
 * Returns: a #TpProxyPendingCall representing the call in
 *  progress. It is borrowed from the object, and will become
 *  invalid when the callback is called, the call is
 *  cancelled or the #TpProxy becomes invalid.
 */
TpProxyPendingCall *
mc_cli_nmc4_call_get_connection (gpointer proxy,
    gint timeout_ms,
    const gchar *in_account_name,
    mc_cli_nmc4_callback_for_get_connection callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object)
{
  GError *error = NULL;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  DBusGProxy *iface;

  g_return_val_if_fail (TP_IS_PROXY (proxy), NULL);

  iface = tp_proxy_borrow_interface_by_id (
      (TpProxy *) proxy,
      interface, &error);

  if (iface == NULL)
    {
      if (callback != NULL)
        callback (proxy,
            NULL,
            NULL,
            error, user_data, weak_object);
      g_error_free (error);
      return NULL;
    }

  if (callback == NULL)
    {
      dbus_g_proxy_call_no_reply (iface, "GetConnection",
          G_TYPE_STRING, in_account_name,
          G_TYPE_INVALID);
      return NULL;
    }
  else
    {
      TpProxyPendingCall *data;

      data = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
          interface, "GetConnection", iface,
          _mc_cli_nmc4_invoke_callback_get_connection,
          G_CALLBACK (callback), user_data, destroy,
          weak_object, FALSE);
      tp_proxy_pending_call_v0_take_pending_call (data,
          dbus_g_proxy_begin_call_with_timeout (iface,
              "GetConnection",
              _mc_cli_nmc4_collect_callback_get_connection,
              data,
              tp_proxy_pending_call_v0_completed,
              timeout_ms,
              G_TYPE_STRING, in_account_name,
              G_TYPE_INVALID));

      return data;
    }
}

typedef struct {
    GMainLoop *loop;
    GError **error;
    gchar **out0;
    gchar **out1;
    gboolean success:1;
    gboolean completed:1;
} _mc_cli_nmc4_run_state_get_connection;
static void
_mc_cli_nmc4_finish_running_get_connection (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback unused,
    gpointer user_data,
    GObject *unused2)
{
  _mc_cli_nmc4_run_state_get_connection *state = user_data;

  state->success = (error == NULL);
  state->completed = TRUE;
  g_main_loop_quit (state->loop);

  if (error != NULL)
    {
      if (state->error != NULL)
        *state->error = error;
      else
        g_error_free (error);

      return;
    }

  if (state->out0 != NULL)
    *state->out0 = g_value_dup_string (args->values + 0);

  if (state->out1 != NULL)
    *state->out1 = g_value_dup_boxed (args->values + 1);

  g_value_array_free (args);
}

/**
 * mc_cli_nmc4_run_get_connection:
 * @proxy: A #TpProxy or subclass
 * @timeout_ms: Timeout in milliseconds, or -1 for default
 * @in_account_name: Used to pass an 'in' argument: <![CDATA[The account]]>
 * @out0: Used to return an 'out' argument if %TRUE is returned: <![CDATA[The D-Bus bus name of the Telepathy           connection]]>
 * @out1: Used to return an 'out' argument if %TRUE is returned: <![CDATA[The D-Bus object path of the Telepathy           connection]]>
 * @error: If not %NULL, used to return errors if %FALSE 
 *  is returned
 * @loop: If not %NULL, set before re-entering 
 *  the main loop, to point to a #GMainLoop 
 *  which can be used to cancel this call with 
 *  g_main_loop_quit(), causing a return of 
 *  %FALSE with @error set to %TP_DBUS_ERROR_CANCELLED
 *
 * Call the method GetConnection and run the main loop
 * until it returns. Before calling this method, you must
 * add a reference to any borrowed objects you need to keep,
 * and generally ensure that everything is in a consistent
 * state.
 *
 * <![CDATA[Get the connection object of an account.]]>
 *
 * Returns: TRUE on success, FALSE and sets @error on error
 */
gboolean
mc_cli_nmc4_run_get_connection (gpointer proxy,
    gint timeout_ms,
    const gchar *in_account_name,
    gchar **out0,
    gchar **out1,
    GError **error,
    GMainLoop **loop)
{
  DBusGProxy *iface;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  TpProxyPendingCall *pc;
  _mc_cli_nmc4_run_state_get_connection state = {
      NULL /* loop */, error,
    out0,
    out1,
      FALSE /* completed */, FALSE /* success */ };

  g_return_val_if_fail (TP_IS_PROXY (proxy), FALSE);

  iface = tp_proxy_borrow_interface_by_id
       ((TpProxy *) proxy, interface, error);

  if (iface == NULL)
    return FALSE;

  state.loop = g_main_loop_new (NULL, FALSE);

  pc = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
      interface, "GetConnection", iface,
      _mc_cli_nmc4_finish_running_get_connection,
      NULL, &state, NULL, NULL, TRUE);

  if (loop != NULL)
    *loop = state.loop;

  tp_proxy_pending_call_v0_take_pending_call (pc,
      dbus_g_proxy_begin_call_with_timeout (iface,
          "GetConnection",
          _mc_cli_nmc4_collect_callback_get_connection,
          pc,
          tp_proxy_pending_call_v0_completed,
          timeout_ms,
              G_TYPE_STRING, in_account_name,
          G_TYPE_INVALID));

  if (!state.completed)
    g_main_loop_run (state.loop);

  if (!state.completed)
    tp_proxy_pending_call_cancel (pc);

  if (loop != NULL)
    *loop = NULL;

  g_main_loop_unref (state.loop);

  return state.success;
}


/**
 * mc_cli_nmc4_callback_for_get_account_for_connection:
 * @proxy: the proxy on which the call was made
 * @out0: Used to return an 'out' argument if @error is %NULL: <![CDATA[The account name]]>
 * @error: %NULL on success, or an error on failure
 * @user_data: user-supplied data
 * @weak_object: user-supplied object
 *
 * Signature of the callback called when a GetAccountForConnection method call
 * succeeds or fails.
 */
static void
_mc_cli_nmc4_collect_callback_get_account_for_connection (DBusGProxy *proxy,
    DBusGProxyCall *call,
    gpointer user_data)
{
  GError *error = NULL;
  GValueArray *args;
  GValue blank = { 0 };
  guint i;
  gchar *out0;

  dbus_g_proxy_end_call (proxy, call, &error,
      G_TYPE_STRING, &out0,
      G_TYPE_INVALID);

  if (error != NULL)
    {
      tp_proxy_pending_call_v0_take_results (user_data, error,
          NULL);
      return;
    }

  args = g_value_array_new (1);
  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 1; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, G_TYPE_STRING);
  g_value_take_string (args->values + 0, out0);
  tp_proxy_pending_call_v0_take_results (user_data, NULL, args);
}
static void
_mc_cli_nmc4_invoke_callback_get_account_for_connection (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  mc_cli_nmc4_callback_for_get_account_for_connection callback = (mc_cli_nmc4_callback_for_get_account_for_connection) generic_callback;

  if (error != NULL)
    {
      callback ((TpProxy *) self,
          NULL,
          error, user_data, weak_object);
      g_error_free (error);
      return;
    }
  callback ((TpProxy *) self,
      g_value_get_string (args->values + 0),
      error, user_data, weak_object);

  g_value_array_free (args);
}

/**
 * mc_cli_nmc4_call_get_account_for_connection:
 * @proxy: the #TpProxy
 * @timeout_ms: the timeout in milliseconds, or -1 to use the
 *   default
 * @in_object_path: Used to pass an 'in' argument: <![CDATA[The D-Bus object path of the Telepathy           connection]]>
 * @callback: called when the method call succeeds or fails
 * @user_data: user-supplied data passed to the callback
 * @destroy: called with the user_data as argument, after the
 *   call has succeeded, failed or been cancelled
 * @weak_object: A #GObject which will be weakly referenced; 
 *   if it is destroyed, this callback will automatically be
 *   disconnected
 *
 * Start a GetAccountForConnection method call.
 *
 * <![CDATA[Get the account for this Telepathy connection.]]>
 *
 * Returns: a #TpProxyPendingCall representing the call in
 *  progress. It is borrowed from the object, and will become
 *  invalid when the callback is called, the call is
 *  cancelled or the #TpProxy becomes invalid.
 */
TpProxyPendingCall *
mc_cli_nmc4_call_get_account_for_connection (gpointer proxy,
    gint timeout_ms,
    const gchar *in_object_path,
    mc_cli_nmc4_callback_for_get_account_for_connection callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object)
{
  GError *error = NULL;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  DBusGProxy *iface;

  g_return_val_if_fail (TP_IS_PROXY (proxy), NULL);

  iface = tp_proxy_borrow_interface_by_id (
      (TpProxy *) proxy,
      interface, &error);

  if (iface == NULL)
    {
      if (callback != NULL)
        callback (proxy,
            NULL,
            error, user_data, weak_object);
      g_error_free (error);
      return NULL;
    }

  if (callback == NULL)
    {
      dbus_g_proxy_call_no_reply (iface, "GetAccountForConnection",
          G_TYPE_STRING, in_object_path,
          G_TYPE_INVALID);
      return NULL;
    }
  else
    {
      TpProxyPendingCall *data;

      data = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
          interface, "GetAccountForConnection", iface,
          _mc_cli_nmc4_invoke_callback_get_account_for_connection,
          G_CALLBACK (callback), user_data, destroy,
          weak_object, FALSE);
      tp_proxy_pending_call_v0_take_pending_call (data,
          dbus_g_proxy_begin_call_with_timeout (iface,
              "GetAccountForConnection",
              _mc_cli_nmc4_collect_callback_get_account_for_connection,
              data,
              tp_proxy_pending_call_v0_completed,
              timeout_ms,
              G_TYPE_STRING, in_object_path,
              G_TYPE_INVALID));

      return data;
    }
}

typedef struct {
    GMainLoop *loop;
    GError **error;
    gchar **out0;
    gboolean success:1;
    gboolean completed:1;
} _mc_cli_nmc4_run_state_get_account_for_connection;
static void
_mc_cli_nmc4_finish_running_get_account_for_connection (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback unused,
    gpointer user_data,
    GObject *unused2)
{
  _mc_cli_nmc4_run_state_get_account_for_connection *state = user_data;

  state->success = (error == NULL);
  state->completed = TRUE;
  g_main_loop_quit (state->loop);

  if (error != NULL)
    {
      if (state->error != NULL)
        *state->error = error;
      else
        g_error_free (error);

      return;
    }

  if (state->out0 != NULL)
    *state->out0 = g_value_dup_string (args->values + 0);

  g_value_array_free (args);
}

/**
 * mc_cli_nmc4_run_get_account_for_connection:
 * @proxy: A #TpProxy or subclass
 * @timeout_ms: Timeout in milliseconds, or -1 for default
 * @in_object_path: Used to pass an 'in' argument: <![CDATA[The D-Bus object path of the Telepathy           connection]]>
 * @out0: Used to return an 'out' argument if %TRUE is returned: <![CDATA[The account name]]>
 * @error: If not %NULL, used to return errors if %FALSE 
 *  is returned
 * @loop: If not %NULL, set before re-entering 
 *  the main loop, to point to a #GMainLoop 
 *  which can be used to cancel this call with 
 *  g_main_loop_quit(), causing a return of 
 *  %FALSE with @error set to %TP_DBUS_ERROR_CANCELLED
 *
 * Call the method GetAccountForConnection and run the main loop
 * until it returns. Before calling this method, you must
 * add a reference to any borrowed objects you need to keep,
 * and generally ensure that everything is in a consistent
 * state.
 *
 * <![CDATA[Get the account for this Telepathy connection.]]>
 *
 * Returns: TRUE on success, FALSE and sets @error on error
 */
gboolean
mc_cli_nmc4_run_get_account_for_connection (gpointer proxy,
    gint timeout_ms,
    const gchar *in_object_path,
    gchar **out0,
    GError **error,
    GMainLoop **loop)
{
  DBusGProxy *iface;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  TpProxyPendingCall *pc;
  _mc_cli_nmc4_run_state_get_account_for_connection state = {
      NULL /* loop */, error,
    out0,
      FALSE /* completed */, FALSE /* success */ };

  g_return_val_if_fail (TP_IS_PROXY (proxy), FALSE);

  iface = tp_proxy_borrow_interface_by_id
       ((TpProxy *) proxy, interface, error);

  if (iface == NULL)
    return FALSE;

  state.loop = g_main_loop_new (NULL, FALSE);

  pc = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
      interface, "GetAccountForConnection", iface,
      _mc_cli_nmc4_finish_running_get_account_for_connection,
      NULL, &state, NULL, NULL, TRUE);

  if (loop != NULL)
    *loop = state.loop;

  tp_proxy_pending_call_v0_take_pending_call (pc,
      dbus_g_proxy_begin_call_with_timeout (iface,
          "GetAccountForConnection",
          _mc_cli_nmc4_collect_callback_get_account_for_connection,
          pc,
          tp_proxy_pending_call_v0_completed,
          timeout_ms,
              G_TYPE_STRING, in_object_path,
          G_TYPE_INVALID));

  if (!state.completed)
    g_main_loop_run (state.loop);

  if (!state.completed)
    tp_proxy_pending_call_cancel (pc);

  if (loop != NULL)
    *loop = NULL;

  g_main_loop_unref (state.loop);

  return state.success;
}


/**
 * mc_cli_nmc4_callback_for_get_used_channels_count:
 * @proxy: the proxy on which the call was made
 * @out0: Used to return an 'out' argument if @error is %NULL: <![CDATA[Number of channels]]>
 * @error: %NULL on success, or an error on failure
 * @user_data: user-supplied data
 * @weak_object: user-supplied object
 *
 * Signature of the callback called when a GetUsedChannelsCount method call
 * succeeds or fails.
 */
static void
_mc_cli_nmc4_collect_callback_get_used_channels_count (DBusGProxy *proxy,
    DBusGProxyCall *call,
    gpointer user_data)
{
  GError *error = NULL;
  GValueArray *args;
  GValue blank = { 0 };
  guint i;
  guint out0;

  dbus_g_proxy_end_call (proxy, call, &error,
      G_TYPE_UINT, &out0,
      G_TYPE_INVALID);

  if (error != NULL)
    {
      tp_proxy_pending_call_v0_take_results (user_data, error,
          NULL);
      return;
    }

  args = g_value_array_new (1);
  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 1; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, G_TYPE_UINT);
  g_value_set_uint (args->values + 0, out0);
  tp_proxy_pending_call_v0_take_results (user_data, NULL, args);
}
static void
_mc_cli_nmc4_invoke_callback_get_used_channels_count (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  mc_cli_nmc4_callback_for_get_used_channels_count callback = (mc_cli_nmc4_callback_for_get_used_channels_count) generic_callback;

  if (error != NULL)
    {
      callback ((TpProxy *) self,
          0,
          error, user_data, weak_object);
      g_error_free (error);
      return;
    }
  callback ((TpProxy *) self,
      g_value_get_uint (args->values + 0),
      error, user_data, weak_object);

  g_value_array_free (args);
}

/**
 * mc_cli_nmc4_call_get_used_channels_count:
 * @proxy: the #TpProxy
 * @timeout_ms: the timeout in milliseconds, or -1 to use the
 *   default
 * @in_type: Used to pass an 'in' argument: <![CDATA[D-Bus interface name representing the channel type]]>
 * @callback: called when the method call succeeds or fails
 * @user_data: user-supplied data passed to the callback
 * @destroy: called with the user_data as argument, after the
 *   call has succeeded, failed or been cancelled
 * @weak_object: A #GObject which will be weakly referenced; 
 *   if it is destroyed, this callback will automatically be
 *   disconnected
 *
 * Start a GetUsedChannelsCount method call.
 *
 * <![CDATA[Get the number of channels of the specified type.]]>
 *
 * Returns: a #TpProxyPendingCall representing the call in
 *  progress. It is borrowed from the object, and will become
 *  invalid when the callback is called, the call is
 *  cancelled or the #TpProxy becomes invalid.
 */
TpProxyPendingCall *
mc_cli_nmc4_call_get_used_channels_count (gpointer proxy,
    gint timeout_ms,
    const gchar *in_type,
    mc_cli_nmc4_callback_for_get_used_channels_count callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object)
{
  GError *error = NULL;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  DBusGProxy *iface;

  g_return_val_if_fail (TP_IS_PROXY (proxy), NULL);

  iface = tp_proxy_borrow_interface_by_id (
      (TpProxy *) proxy,
      interface, &error);

  if (iface == NULL)
    {
      if (callback != NULL)
        callback (proxy,
            0,
            error, user_data, weak_object);
      g_error_free (error);
      return NULL;
    }

  if (callback == NULL)
    {
      dbus_g_proxy_call_no_reply (iface, "GetUsedChannelsCount",
          G_TYPE_STRING, in_type,
          G_TYPE_INVALID);
      return NULL;
    }
  else
    {
      TpProxyPendingCall *data;

      data = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
          interface, "GetUsedChannelsCount", iface,
          _mc_cli_nmc4_invoke_callback_get_used_channels_count,
          G_CALLBACK (callback), user_data, destroy,
          weak_object, FALSE);
      tp_proxy_pending_call_v0_take_pending_call (data,
          dbus_g_proxy_begin_call_with_timeout (iface,
              "GetUsedChannelsCount",
              _mc_cli_nmc4_collect_callback_get_used_channels_count,
              data,
              tp_proxy_pending_call_v0_completed,
              timeout_ms,
              G_TYPE_STRING, in_type,
              G_TYPE_INVALID));

      return data;
    }
}

typedef struct {
    GMainLoop *loop;
    GError **error;
    guint *out0;
    gboolean success:1;
    gboolean completed:1;
} _mc_cli_nmc4_run_state_get_used_channels_count;
static void
_mc_cli_nmc4_finish_running_get_used_channels_count (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback unused,
    gpointer user_data,
    GObject *unused2)
{
  _mc_cli_nmc4_run_state_get_used_channels_count *state = user_data;

  state->success = (error == NULL);
  state->completed = TRUE;
  g_main_loop_quit (state->loop);

  if (error != NULL)
    {
      if (state->error != NULL)
        *state->error = error;
      else
        g_error_free (error);

      return;
    }

  if (state->out0 != NULL)
    *state->out0 = g_value_get_uint (args->values + 0);

  g_value_array_free (args);
}

/**
 * mc_cli_nmc4_run_get_used_channels_count:
 * @proxy: A #TpProxy or subclass
 * @timeout_ms: Timeout in milliseconds, or -1 for default
 * @in_type: Used to pass an 'in' argument: <![CDATA[D-Bus interface name representing the channel type]]>
 * @out0: Used to return an 'out' argument if %TRUE is returned: <![CDATA[Number of channels]]>
 * @error: If not %NULL, used to return errors if %FALSE 
 *  is returned
 * @loop: If not %NULL, set before re-entering 
 *  the main loop, to point to a #GMainLoop 
 *  which can be used to cancel this call with 
 *  g_main_loop_quit(), causing a return of 
 *  %FALSE with @error set to %TP_DBUS_ERROR_CANCELLED
 *
 * Call the method GetUsedChannelsCount and run the main loop
 * until it returns. Before calling this method, you must
 * add a reference to any borrowed objects you need to keep,
 * and generally ensure that everything is in a consistent
 * state.
 *
 * <![CDATA[Get the number of channels of the specified type.]]>
 *
 * Returns: TRUE on success, FALSE and sets @error on error
 */
gboolean
mc_cli_nmc4_run_get_used_channels_count (gpointer proxy,
    gint timeout_ms,
    const gchar *in_type,
    guint *out0,
    GError **error,
    GMainLoop **loop)
{
  DBusGProxy *iface;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  TpProxyPendingCall *pc;
  _mc_cli_nmc4_run_state_get_used_channels_count state = {
      NULL /* loop */, error,
    out0,
      FALSE /* completed */, FALSE /* success */ };

  g_return_val_if_fail (TP_IS_PROXY (proxy), FALSE);

  iface = tp_proxy_borrow_interface_by_id
       ((TpProxy *) proxy, interface, error);

  if (iface == NULL)
    return FALSE;

  state.loop = g_main_loop_new (NULL, FALSE);

  pc = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
      interface, "GetUsedChannelsCount", iface,
      _mc_cli_nmc4_finish_running_get_used_channels_count,
      NULL, &state, NULL, NULL, TRUE);

  if (loop != NULL)
    *loop = state.loop;

  tp_proxy_pending_call_v0_take_pending_call (pc,
      dbus_g_proxy_begin_call_with_timeout (iface,
          "GetUsedChannelsCount",
          _mc_cli_nmc4_collect_callback_get_used_channels_count,
          pc,
          tp_proxy_pending_call_v0_completed,
          timeout_ms,
              G_TYPE_STRING, in_type,
          G_TYPE_INVALID));

  if (!state.completed)
    g_main_loop_run (state.loop);

  if (!state.completed)
    tp_proxy_pending_call_cancel (pc);

  if (loop != NULL)
    *loop = NULL;

  g_main_loop_unref (state.loop);

  return state.success;
}


/**
 * mc_cli_nmc4_callback_for_get_current_status:
 * @proxy: the proxy on which the call was made
 * @out_status: Used to return an 'out' argument if @error is %NULL: <![CDATA[Integer representing the MissionControl status (as in the           <code>McStatus</code> enum):           <ul>             <li>0 - disconnected</li>             <li>1 - connecting</li>             <li>2 - connected</li>           </ul>]]>
 * @out_presence: Used to return an 'out' argument if @error is %NULL: <![CDATA[Actual presence]]>
 * @out_requested_presence: Used to return an 'out' argument if @error is %NULL: <![CDATA[Requested presence]]>
 * @out_accounts: Used to return an 'out' argument if @error is %NULL: <![CDATA[An array of structures specifying the accounts' state, fields being:           <ul>             <li>The account name</li>             <li>The account's connection status</li>             <li>The presence</li>             <li>The connection status reason</li>           </ul>]]>
 * @error: %NULL on success, or an error on failure
 * @user_data: user-supplied data
 * @weak_object: user-supplied object
 *
 * Signature of the callback called when a GetCurrentStatus method call
 * succeeds or fails.
 */
static void
_mc_cli_nmc4_collect_callback_get_current_status (DBusGProxy *proxy,
    DBusGProxyCall *call,
    gpointer user_data)
{
  GError *error = NULL;
  GValueArray *args;
  GValue blank = { 0 };
  guint i;
  guint out_status;
  guint out_presence;
  guint out_requested_presence;
  GPtrArray *out_accounts;

  dbus_g_proxy_end_call (proxy, call, &error,
      G_TYPE_UINT, &out_status,
      G_TYPE_UINT, &out_presence,
      G_TYPE_UINT, &out_requested_presence,
      (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_STRING, G_TYPE_UINT, G_TYPE_UINT, G_TYPE_UINT, G_TYPE_INVALID)))), &out_accounts,
      G_TYPE_INVALID);

  if (error != NULL)
    {
      tp_proxy_pending_call_v0_take_results (user_data, error,
          NULL);
      return;
    }

  args = g_value_array_new (4);
  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 4; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, G_TYPE_UINT);
  g_value_set_uint (args->values + 0, out_status);

  g_value_unset (args->values + 1);
  g_value_init (args->values + 1, G_TYPE_UINT);
  g_value_set_uint (args->values + 1, out_presence);

  g_value_unset (args->values + 2);
  g_value_init (args->values + 2, G_TYPE_UINT);
  g_value_set_uint (args->values + 2, out_requested_presence);

  g_value_unset (args->values + 3);
  g_value_init (args->values + 3, (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_STRING, G_TYPE_UINT, G_TYPE_UINT, G_TYPE_UINT, G_TYPE_INVALID)))));
  g_value_take_boxed (args->values + 3, out_accounts);
  tp_proxy_pending_call_v0_take_results (user_data, NULL, args);
}
static void
_mc_cli_nmc4_invoke_callback_get_current_status (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  mc_cli_nmc4_callback_for_get_current_status callback = (mc_cli_nmc4_callback_for_get_current_status) generic_callback;

  if (error != NULL)
    {
      callback ((TpProxy *) self,
          0,
          0,
          0,
          NULL,
          error, user_data, weak_object);
      g_error_free (error);
      return;
    }
  callback ((TpProxy *) self,
      g_value_get_uint (args->values + 0),
      g_value_get_uint (args->values + 1),
      g_value_get_uint (args->values + 2),
      g_value_get_boxed (args->values + 3),
      error, user_data, weak_object);

  g_value_array_free (args);
}

/**
 * mc_cli_nmc4_call_get_current_status:
 * @proxy: the #TpProxy
 * @timeout_ms: the timeout in milliseconds, or -1 to use the
 *   default
 * @callback: called when the method call succeeds or fails
 * @user_data: user-supplied data passed to the callback
 * @destroy: called with the user_data as argument, after the
 *   call has succeeded, failed or been cancelled
 * @weak_object: A #GObject which will be weakly referenced; 
 *   if it is destroyed, this callback will automatically be
 *   disconnected
 *
 * Start a GetCurrentStatus method call.
 *
 * <![CDATA[Get MissionControl's current status.]]>
 *
 * Returns: a #TpProxyPendingCall representing the call in
 *  progress. It is borrowed from the object, and will become
 *  invalid when the callback is called, the call is
 *  cancelled or the #TpProxy becomes invalid.
 */
TpProxyPendingCall *
mc_cli_nmc4_call_get_current_status (gpointer proxy,
    gint timeout_ms,
    mc_cli_nmc4_callback_for_get_current_status callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object)
{
  GError *error = NULL;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  DBusGProxy *iface;

  g_return_val_if_fail (TP_IS_PROXY (proxy), NULL);

  iface = tp_proxy_borrow_interface_by_id (
      (TpProxy *) proxy,
      interface, &error);

  if (iface == NULL)
    {
      if (callback != NULL)
        callback (proxy,
            0,
            0,
            0,
            NULL,
            error, user_data, weak_object);
      g_error_free (error);
      return NULL;
    }

  if (callback == NULL)
    {
      dbus_g_proxy_call_no_reply (iface, "GetCurrentStatus",
          G_TYPE_INVALID);
      return NULL;
    }
  else
    {
      TpProxyPendingCall *data;

      data = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
          interface, "GetCurrentStatus", iface,
          _mc_cli_nmc4_invoke_callback_get_current_status,
          G_CALLBACK (callback), user_data, destroy,
          weak_object, FALSE);
      tp_proxy_pending_call_v0_take_pending_call (data,
          dbus_g_proxy_begin_call_with_timeout (iface,
              "GetCurrentStatus",
              _mc_cli_nmc4_collect_callback_get_current_status,
              data,
              tp_proxy_pending_call_v0_completed,
              timeout_ms,
              G_TYPE_INVALID));

      return data;
    }
}

typedef struct {
    GMainLoop *loop;
    GError **error;
    guint *out_status;
    guint *out_presence;
    guint *out_requested_presence;
    GPtrArray **out_accounts;
    gboolean success:1;
    gboolean completed:1;
} _mc_cli_nmc4_run_state_get_current_status;
static void
_mc_cli_nmc4_finish_running_get_current_status (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback unused,
    gpointer user_data,
    GObject *unused2)
{
  _mc_cli_nmc4_run_state_get_current_status *state = user_data;

  state->success = (error == NULL);
  state->completed = TRUE;
  g_main_loop_quit (state->loop);

  if (error != NULL)
    {
      if (state->error != NULL)
        *state->error = error;
      else
        g_error_free (error);

      return;
    }

  if (state->out_status != NULL)
    *state->out_status = g_value_get_uint (args->values + 0);

  if (state->out_presence != NULL)
    *state->out_presence = g_value_get_uint (args->values + 1);

  if (state->out_requested_presence != NULL)
    *state->out_requested_presence = g_value_get_uint (args->values + 2);

  if (state->out_accounts != NULL)
    *state->out_accounts = g_value_dup_boxed (args->values + 3);

  g_value_array_free (args);
}

/**
 * mc_cli_nmc4_run_get_current_status:
 * @proxy: A #TpProxy or subclass
 * @timeout_ms: Timeout in milliseconds, or -1 for default
 * @out_status: Used to return an 'out' argument if %TRUE is returned: <![CDATA[Integer representing the MissionControl status (as in the           <code>McStatus</code> enum):           <ul>             <li>0 - disconnected</li>             <li>1 - connecting</li>             <li>2 - connected</li>           </ul>]]>
 * @out_presence: Used to return an 'out' argument if %TRUE is returned: <![CDATA[Actual presence]]>
 * @out_requested_presence: Used to return an 'out' argument if %TRUE is returned: <![CDATA[Requested presence]]>
 * @out_accounts: Used to return an 'out' argument if %TRUE is returned: <![CDATA[An array of structures specifying the accounts' state, fields being:           <ul>             <li>The account name</li>             <li>The account's connection status</li>             <li>The presence</li>             <li>The connection status reason</li>           </ul>]]>
 * @error: If not %NULL, used to return errors if %FALSE 
 *  is returned
 * @loop: If not %NULL, set before re-entering 
 *  the main loop, to point to a #GMainLoop 
 *  which can be used to cancel this call with 
 *  g_main_loop_quit(), causing a return of 
 *  %FALSE with @error set to %TP_DBUS_ERROR_CANCELLED
 *
 * Call the method GetCurrentStatus and run the main loop
 * until it returns. Before calling this method, you must
 * add a reference to any borrowed objects you need to keep,
 * and generally ensure that everything is in a consistent
 * state.
 *
 * <![CDATA[Get MissionControl's current status.]]>
 *
 * Returns: TRUE on success, FALSE and sets @error on error
 */
gboolean
mc_cli_nmc4_run_get_current_status (gpointer proxy,
    gint timeout_ms,
    guint *out_status,
    guint *out_presence,
    guint *out_requested_presence,
    GPtrArray **out_accounts,
    GError **error,
    GMainLoop **loop)
{
  DBusGProxy *iface;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  TpProxyPendingCall *pc;
  _mc_cli_nmc4_run_state_get_current_status state = {
      NULL /* loop */, error,
    out_status,
    out_presence,
    out_requested_presence,
    out_accounts,
      FALSE /* completed */, FALSE /* success */ };

  g_return_val_if_fail (TP_IS_PROXY (proxy), FALSE);

  iface = tp_proxy_borrow_interface_by_id
       ((TpProxy *) proxy, interface, error);

  if (iface == NULL)
    return FALSE;

  state.loop = g_main_loop_new (NULL, FALSE);

  pc = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
      interface, "GetCurrentStatus", iface,
      _mc_cli_nmc4_finish_running_get_current_status,
      NULL, &state, NULL, NULL, TRUE);

  if (loop != NULL)
    *loop = state.loop;

  tp_proxy_pending_call_v0_take_pending_call (pc,
      dbus_g_proxy_begin_call_with_timeout (iface,
          "GetCurrentStatus",
          _mc_cli_nmc4_collect_callback_get_current_status,
          pc,
          tp_proxy_pending_call_v0_completed,
          timeout_ms,
          G_TYPE_INVALID));

  if (!state.completed)
    g_main_loop_run (state.loop);

  if (!state.completed)
    tp_proxy_pending_call_cancel (pc);

  if (loop != NULL)
    *loop = NULL;

  g_main_loop_unref (state.loop);

  return state.success;
}


/**
 * mc_cli_nmc4_callback_for_remote_avatar_changed:
 * @proxy: the proxy on which the call was made
 * @error: %NULL on success, or an error on failure
 * @user_data: user-supplied data
 * @weak_object: user-supplied object
 *
 * Signature of the callback called when a RemoteAvatarChanged method call
 * succeeds or fails.
 */
static void
_mc_cli_nmc4_collect_callback_remote_avatar_changed (DBusGProxy *proxy,
    DBusGProxyCall *call,
    gpointer user_data)
{
  GError *error = NULL;

  dbus_g_proxy_end_call (proxy, call, &error,
      G_TYPE_INVALID);
  tp_proxy_pending_call_v0_take_results (user_data, error,NULL);
}
static void
_mc_cli_nmc4_invoke_callback_remote_avatar_changed (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  mc_cli_nmc4_callback_for_remote_avatar_changed callback = (mc_cli_nmc4_callback_for_remote_avatar_changed) generic_callback;

  if (error != NULL)
    {
      callback ((TpProxy *) self,
          error, user_data, weak_object);
      g_error_free (error);
      return;
    }
  callback ((TpProxy *) self,
      error, user_data, weak_object);

  if (args != NULL)
    g_value_array_free (args);
}

/**
 * mc_cli_nmc4_call_remote_avatar_changed:
 * @proxy: the #TpProxy
 * @timeout_ms: the timeout in milliseconds, or -1 to use the
 *   default
 * @in_object_path: Used to pass an 'in' argument: <![CDATA[D-Bus object path of the connection]]>
 * @in_contact_id: Used to pass an 'in' argument: <![CDATA[Telepathy handle for the account (self handle)]]>
 * @in_token: Used to pass an 'in' argument: <![CDATA[Avatar token]]>
 * @callback: called when the method call succeeds or fails
 * @user_data: user-supplied data passed to the callback
 * @destroy: called with the user_data as argument, after the
 *   call has succeeded, failed or been cancelled
 * @weak_object: A #GObject which will be weakly referenced; 
 *   if it is destroyed, this callback will automatically be
 *   disconnected
 *
 * Start a RemoteAvatarChanged method call.
 *
 * <![CDATA[Signals the MissionControl service that an account's remote avatar has         changed]]>
 *
 * Returns: a #TpProxyPendingCall representing the call in
 *  progress. It is borrowed from the object, and will become
 *  invalid when the callback is called, the call is
 *  cancelled or the #TpProxy becomes invalid.
 */
TpProxyPendingCall *
mc_cli_nmc4_call_remote_avatar_changed (gpointer proxy,
    gint timeout_ms,
    const gchar *in_object_path,
    guint in_contact_id,
    const gchar *in_token,
    mc_cli_nmc4_callback_for_remote_avatar_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object)
{
  GError *error = NULL;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  DBusGProxy *iface;

  g_return_val_if_fail (TP_IS_PROXY (proxy), NULL);

  iface = tp_proxy_borrow_interface_by_id (
      (TpProxy *) proxy,
      interface, &error);

  if (iface == NULL)
    {
      if (callback != NULL)
        callback (proxy,
            error, user_data, weak_object);
      g_error_free (error);
      return NULL;
    }

  if (callback == NULL)
    {
      dbus_g_proxy_call_no_reply (iface, "RemoteAvatarChanged",
          G_TYPE_STRING, in_object_path,
          G_TYPE_UINT, in_contact_id,
          G_TYPE_STRING, in_token,
          G_TYPE_INVALID);
      return NULL;
    }
  else
    {
      TpProxyPendingCall *data;

      data = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
          interface, "RemoteAvatarChanged", iface,
          _mc_cli_nmc4_invoke_callback_remote_avatar_changed,
          G_CALLBACK (callback), user_data, destroy,
          weak_object, FALSE);
      tp_proxy_pending_call_v0_take_pending_call (data,
          dbus_g_proxy_begin_call_with_timeout (iface,
              "RemoteAvatarChanged",
              _mc_cli_nmc4_collect_callback_remote_avatar_changed,
              data,
              tp_proxy_pending_call_v0_completed,
              timeout_ms,
              G_TYPE_STRING, in_object_path,
              G_TYPE_UINT, in_contact_id,
              G_TYPE_STRING, in_token,
              G_TYPE_INVALID));

      return data;
    }
}

typedef struct {
    GMainLoop *loop;
    GError **error;
    gboolean success:1;
    gboolean completed:1;
} _mc_cli_nmc4_run_state_remote_avatar_changed;
static void
_mc_cli_nmc4_finish_running_remote_avatar_changed (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback unused,
    gpointer user_data,
    GObject *unused2)
{
  _mc_cli_nmc4_run_state_remote_avatar_changed *state = user_data;

  state->success = (error == NULL);
  state->completed = TRUE;
  g_main_loop_quit (state->loop);

  if (error != NULL)
    {
      if (state->error != NULL)
        *state->error = error;
      else
        g_error_free (error);

      return;
    }

  if (args != NULL)
    g_value_array_free (args);
}

/**
 * mc_cli_nmc4_run_remote_avatar_changed:
 * @proxy: A #TpProxy or subclass
 * @timeout_ms: Timeout in milliseconds, or -1 for default
 * @in_object_path: Used to pass an 'in' argument: <![CDATA[D-Bus object path of the connection]]>
 * @in_contact_id: Used to pass an 'in' argument: <![CDATA[Telepathy handle for the account (self handle)]]>
 * @in_token: Used to pass an 'in' argument: <![CDATA[Avatar token]]>
 * @error: If not %NULL, used to return errors if %FALSE 
 *  is returned
 * @loop: If not %NULL, set before re-entering 
 *  the main loop, to point to a #GMainLoop 
 *  which can be used to cancel this call with 
 *  g_main_loop_quit(), causing a return of 
 *  %FALSE with @error set to %TP_DBUS_ERROR_CANCELLED
 *
 * Call the method RemoteAvatarChanged and run the main loop
 * until it returns. Before calling this method, you must
 * add a reference to any borrowed objects you need to keep,
 * and generally ensure that everything is in a consistent
 * state.
 *
 * <![CDATA[Signals the MissionControl service that an account's remote avatar has         changed]]>
 *
 * Returns: TRUE on success, FALSE and sets @error on error
 */
gboolean
mc_cli_nmc4_run_remote_avatar_changed (gpointer proxy,
    gint timeout_ms,
    const gchar *in_object_path,
    guint in_contact_id,
    const gchar *in_token,
    GError **error,
    GMainLoop **loop)
{
  DBusGProxy *iface;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  TpProxyPendingCall *pc;
  _mc_cli_nmc4_run_state_remote_avatar_changed state = {
      NULL /* loop */, error,
      FALSE /* completed */, FALSE /* success */ };

  g_return_val_if_fail (TP_IS_PROXY (proxy), FALSE);

  iface = tp_proxy_borrow_interface_by_id
       ((TpProxy *) proxy, interface, error);

  if (iface == NULL)
    return FALSE;

  state.loop = g_main_loop_new (NULL, FALSE);

  pc = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
      interface, "RemoteAvatarChanged", iface,
      _mc_cli_nmc4_finish_running_remote_avatar_changed,
      NULL, &state, NULL, NULL, TRUE);

  if (loop != NULL)
    *loop = state.loop;

  tp_proxy_pending_call_v0_take_pending_call (pc,
      dbus_g_proxy_begin_call_with_timeout (iface,
          "RemoteAvatarChanged",
          _mc_cli_nmc4_collect_callback_remote_avatar_changed,
          pc,
          tp_proxy_pending_call_v0_completed,
          timeout_ms,
              G_TYPE_STRING, in_object_path,
              G_TYPE_UINT, in_contact_id,
              G_TYPE_STRING, in_token,
          G_TYPE_INVALID));

  if (!state.completed)
    g_main_loop_run (state.loop);

  if (!state.completed)
    tp_proxy_pending_call_cancel (pc);

  if (loop != NULL)
    *loop = NULL;

  g_main_loop_unref (state.loop);

  return state.success;
}


/**
 * mc_cli_nmc4_callback_for_register_filter:
 * @proxy: the proxy on which the call was made
 * @error: %NULL on success, or an error on failure
 * @user_data: user-supplied data
 * @weak_object: user-supplied object
 *
 * Signature of the callback called when a RegisterFilter method call
 * succeeds or fails.
 */
static void
_mc_cli_nmc4_collect_callback_register_filter (DBusGProxy *proxy,
    DBusGProxyCall *call,
    gpointer user_data)
{
  GError *error = NULL;

  dbus_g_proxy_end_call (proxy, call, &error,
      G_TYPE_INVALID);
  tp_proxy_pending_call_v0_take_results (user_data, error,NULL);
}
static void
_mc_cli_nmc4_invoke_callback_register_filter (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  mc_cli_nmc4_callback_for_register_filter callback = (mc_cli_nmc4_callback_for_register_filter) generic_callback;

  if (error != NULL)
    {
      callback ((TpProxy *) self,
          error, user_data, weak_object);
      g_error_free (error);
      return;
    }
  callback ((TpProxy *) self,
      error, user_data, weak_object);

  if (args != NULL)
    g_value_array_free (args);
}

/**
 * mc_cli_nmc4_call_register_filter:
 * @proxy: the #TpProxy
 * @timeout_ms: the timeout in milliseconds, or -1 to use the
 *   default
 * @in_bus_name: Used to pass an 'in' argument: <![CDATA[D-Bus name where the filter service is]]>
 * @in_object_path: Used to pass an 'in' argument: <![CDATA[D-Bus object path where the filter service is]]>
 * @in_channel_type: Used to pass an 'in' argument: <![CDATA[Type of channel to be filtered]]>
 * @in_priority: Used to pass an 'in' argument: <![CDATA[Priority of the filter]]>
 * @in_flag: Used to pass an 'in' argument: <![CDATA[Flag]]>
 * @callback: called when the method call succeeds or fails
 * @user_data: user-supplied data passed to the callback
 * @destroy: called with the user_data as argument, after the
 *   call has succeeded, failed or been cancelled
 * @weak_object: A #GObject which will be weakly referenced; 
 *   if it is destroyed, this callback will automatically be
 *   disconnected
 *
 * Start a RegisterFilter method call.
 *
 * <![CDATA[Signals the MissionControl service that a filter service is running for         a specified type of channel.]]>
 *
 * Returns: a #TpProxyPendingCall representing the call in
 *  progress. It is borrowed from the object, and will become
 *  invalid when the callback is called, the call is
 *  cancelled or the #TpProxy becomes invalid.
 */
TpProxyPendingCall *
mc_cli_nmc4_call_register_filter (gpointer proxy,
    gint timeout_ms,
    const gchar *in_bus_name,
    const gchar *in_object_path,
    const gchar *in_channel_type,
    guint in_priority,
    guint in_flag,
    mc_cli_nmc4_callback_for_register_filter callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object)
{
  GError *error = NULL;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  DBusGProxy *iface;

  g_return_val_if_fail (TP_IS_PROXY (proxy), NULL);

  iface = tp_proxy_borrow_interface_by_id (
      (TpProxy *) proxy,
      interface, &error);

  if (iface == NULL)
    {
      if (callback != NULL)
        callback (proxy,
            error, user_data, weak_object);
      g_error_free (error);
      return NULL;
    }

  if (callback == NULL)
    {
      dbus_g_proxy_call_no_reply (iface, "RegisterFilter",
          G_TYPE_STRING, in_bus_name,
          DBUS_TYPE_G_OBJECT_PATH, in_object_path,
          G_TYPE_STRING, in_channel_type,
          G_TYPE_UINT, in_priority,
          G_TYPE_UINT, in_flag,
          G_TYPE_INVALID);
      return NULL;
    }
  else
    {
      TpProxyPendingCall *data;

      data = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
          interface, "RegisterFilter", iface,
          _mc_cli_nmc4_invoke_callback_register_filter,
          G_CALLBACK (callback), user_data, destroy,
          weak_object, FALSE);
      tp_proxy_pending_call_v0_take_pending_call (data,
          dbus_g_proxy_begin_call_with_timeout (iface,
              "RegisterFilter",
              _mc_cli_nmc4_collect_callback_register_filter,
              data,
              tp_proxy_pending_call_v0_completed,
              timeout_ms,
              G_TYPE_STRING, in_bus_name,
              DBUS_TYPE_G_OBJECT_PATH, in_object_path,
              G_TYPE_STRING, in_channel_type,
              G_TYPE_UINT, in_priority,
              G_TYPE_UINT, in_flag,
              G_TYPE_INVALID));

      return data;
    }
}

typedef struct {
    GMainLoop *loop;
    GError **error;
    gboolean success:1;
    gboolean completed:1;
} _mc_cli_nmc4_run_state_register_filter;
static void
_mc_cli_nmc4_finish_running_register_filter (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback unused,
    gpointer user_data,
    GObject *unused2)
{
  _mc_cli_nmc4_run_state_register_filter *state = user_data;

  state->success = (error == NULL);
  state->completed = TRUE;
  g_main_loop_quit (state->loop);

  if (error != NULL)
    {
      if (state->error != NULL)
        *state->error = error;
      else
        g_error_free (error);

      return;
    }

  if (args != NULL)
    g_value_array_free (args);
}

/**
 * mc_cli_nmc4_run_register_filter:
 * @proxy: A #TpProxy or subclass
 * @timeout_ms: Timeout in milliseconds, or -1 for default
 * @in_bus_name: Used to pass an 'in' argument: <![CDATA[D-Bus name where the filter service is]]>
 * @in_object_path: Used to pass an 'in' argument: <![CDATA[D-Bus object path where the filter service is]]>
 * @in_channel_type: Used to pass an 'in' argument: <![CDATA[Type of channel to be filtered]]>
 * @in_priority: Used to pass an 'in' argument: <![CDATA[Priority of the filter]]>
 * @in_flag: Used to pass an 'in' argument: <![CDATA[Flag]]>
 * @error: If not %NULL, used to return errors if %FALSE 
 *  is returned
 * @loop: If not %NULL, set before re-entering 
 *  the main loop, to point to a #GMainLoop 
 *  which can be used to cancel this call with 
 *  g_main_loop_quit(), causing a return of 
 *  %FALSE with @error set to %TP_DBUS_ERROR_CANCELLED
 *
 * Call the method RegisterFilter and run the main loop
 * until it returns. Before calling this method, you must
 * add a reference to any borrowed objects you need to keep,
 * and generally ensure that everything is in a consistent
 * state.
 *
 * <![CDATA[Signals the MissionControl service that a filter service is running for         a specified type of channel.]]>
 *
 * Returns: TRUE on success, FALSE and sets @error on error
 */
gboolean
mc_cli_nmc4_run_register_filter (gpointer proxy,
    gint timeout_ms,
    const gchar *in_bus_name,
    const gchar *in_object_path,
    const gchar *in_channel_type,
    guint in_priority,
    guint in_flag,
    GError **error,
    GMainLoop **loop)
{
  DBusGProxy *iface;
  GQuark interface = MC_IFACE_QUARK_NMC4;
  TpProxyPendingCall *pc;
  _mc_cli_nmc4_run_state_register_filter state = {
      NULL /* loop */, error,
      FALSE /* completed */, FALSE /* success */ };

  g_return_val_if_fail (TP_IS_PROXY (proxy), FALSE);

  iface = tp_proxy_borrow_interface_by_id
       ((TpProxy *) proxy, interface, error);

  if (iface == NULL)
    return FALSE;

  state.loop = g_main_loop_new (NULL, FALSE);

  pc = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
      interface, "RegisterFilter", iface,
      _mc_cli_nmc4_finish_running_register_filter,
      NULL, &state, NULL, NULL, TRUE);

  if (loop != NULL)
    *loop = state.loop;

  tp_proxy_pending_call_v0_take_pending_call (pc,
      dbus_g_proxy_begin_call_with_timeout (iface,
          "RegisterFilter",
          _mc_cli_nmc4_collect_callback_register_filter,
          pc,
          tp_proxy_pending_call_v0_completed,
          timeout_ms,
              G_TYPE_STRING, in_bus_name,
              DBUS_TYPE_G_OBJECT_PATH, in_object_path,
              G_TYPE_STRING, in_channel_type,
              G_TYPE_UINT, in_priority,
              G_TYPE_UINT, in_flag,
          G_TYPE_INVALID));

  if (!state.completed)
    g_main_loop_run (state.loop);

  if (!state.completed)
    tp_proxy_pending_call_cancel (pc);

  if (loop != NULL)
    *loop = NULL;

  g_main_loop_unref (state.loop);

  return state.success;
}


/*
 * mc_cli_nmc4_add_signals:
 * @self: the #TpProxy
 * @quark: a quark whose string value is the interface
 *   name whose signals should be added
 * @proxy: the D-Bus proxy to which to add the signals
 * @unused: not used for anything
 *
 * Tell dbus-glib that @proxy has the signatures of all
 * signals on the given interface, if it's one we
 * support.
 *
 * This function should be used as a signal handler for
 * #TpProxy::interface-added.
 */
static void
mc_cli_nmc4_add_signals (TpProxy *self,
    guint quark,
    DBusGProxy *proxy,
    gpointer unused)
{
  if (quark == MC_IFACE_QUARK_NMC4)
    mc_cli_add_signals_for_nmc4 (proxy);
}
