#include "_gen/svc-nmc4.h"

#include <telepathy-glib/dbus.h>
#include "_gen/signals-marshal.h"

static const DBusGObjectInfo _mc_svc_nmc4_object_info;

struct _McSvcNMC4Class {
    GTypeInterface parent_class;
    mc_svc_nmc4_set_presence_impl set_presence;
    mc_svc_nmc4_get_presence_impl get_presence;
    mc_svc_nmc4_get_presence_message_impl get_presence_message;
    mc_svc_nmc4_get_presence_actual_impl get_presence_actual;
    mc_svc_nmc4_get_presence_message_actual_impl get_presence_message_actual;
    mc_svc_nmc4_request_channel_impl request_channel;
    mc_svc_nmc4_request_channel_with_string_handle_impl request_channel_with_string_handle;
    mc_svc_nmc4_cancel_channel_request_impl cancel_channel_request;
    mc_svc_nmc4_connect_all_with_default_presence_impl connect_all_with_default_presence;
    mc_svc_nmc4_get_connection_status_impl get_connection_status;
    mc_svc_nmc4_get_online_connections_impl get_online_connections;
    mc_svc_nmc4_get_connection_impl get_connection;
    mc_svc_nmc4_get_account_for_connection_impl get_account_for_connection;
    mc_svc_nmc4_get_used_channels_count_impl get_used_channels_count;
    mc_svc_nmc4_get_current_status_impl get_current_status;
    mc_svc_nmc4_remote_avatar_changed_impl remote_avatar_changed;
    mc_svc_nmc4_register_filter_impl register_filter;
};

enum {
    SIGNAL_NMC4_AccountPresenceChanged,
    SIGNAL_NMC4_AccountStatusChanged,
    SIGNAL_NMC4_McdError,
    SIGNAL_NMC4_PresenceRequested,
    SIGNAL_NMC4_PresenceStatusRequested,
    SIGNAL_NMC4_PresenceChanged,
    SIGNAL_NMC4_PresenceStatusActual,
    SIGNAL_NMC4_UsedChannelsCountChanged,
    SIGNAL_NMC4_StatusActual,
    N_NMC4_SIGNALS
};
static guint nmc4_signals[N_NMC4_SIGNALS] = {0};

static void mc_svc_nmc4_base_init (gpointer klass);

GType
mc_svc_nmc4_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (McSvcNMC4Class),
        mc_svc_nmc4_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "McSvcNMC4", &info, 0);
    }

  return type;
}

/**
 * mc_svc_nmc4_set_presence_impl:
 * @self: The object implementing this interface
 * @in_presence: guint  (FIXME, generate documentation)
 * @in_message: const gchar * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * SetPresence on interface org.freedesktop.Telepathy.MissionControl.
 */
static void
mc_svc_nmc4_set_presence (McSvcNMC4 *self,
    guint in_presence,
    const gchar *in_message,
    DBusGMethodInvocation *context)
{
  mc_svc_nmc4_set_presence_impl impl = (MC_SVC_NMC4_GET_CLASS (self)->set_presence);

  if (impl != NULL)
    {
      (impl) (self,
        in_presence,
        in_message,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * mc_svc_nmc4_implement_set_presence:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the SetPresence D-Bus method
 *
 * Register an implementation for the SetPresence method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
mc_svc_nmc4_implement_set_presence (McSvcNMC4Class *klass, mc_svc_nmc4_set_presence_impl impl)
{
  klass->set_presence = impl;
}

/**
 * mc_svc_nmc4_get_presence_impl:
 * @self: The object implementing this interface
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * GetPresence on interface org.freedesktop.Telepathy.MissionControl.
 */
static void
mc_svc_nmc4_get_presence (McSvcNMC4 *self,
    DBusGMethodInvocation *context)
{
  mc_svc_nmc4_get_presence_impl impl = (MC_SVC_NMC4_GET_CLASS (self)->get_presence);

  if (impl != NULL)
    {
      (impl) (self,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * mc_svc_nmc4_implement_get_presence:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetPresence D-Bus method
 *
 * Register an implementation for the GetPresence method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
mc_svc_nmc4_implement_get_presence (McSvcNMC4Class *klass, mc_svc_nmc4_get_presence_impl impl)
{
  klass->get_presence = impl;
}

/**
 * mc_svc_nmc4_get_presence_message_impl:
 * @self: The object implementing this interface
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * GetPresenceMessage on interface org.freedesktop.Telepathy.MissionControl.
 */
static void
mc_svc_nmc4_get_presence_message (McSvcNMC4 *self,
    DBusGMethodInvocation *context)
{
  mc_svc_nmc4_get_presence_message_impl impl = (MC_SVC_NMC4_GET_CLASS (self)->get_presence_message);

  if (impl != NULL)
    {
      (impl) (self,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * mc_svc_nmc4_implement_get_presence_message:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetPresenceMessage D-Bus method
 *
 * Register an implementation for the GetPresenceMessage method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
mc_svc_nmc4_implement_get_presence_message (McSvcNMC4Class *klass, mc_svc_nmc4_get_presence_message_impl impl)
{
  klass->get_presence_message = impl;
}

/**
 * mc_svc_nmc4_get_presence_actual_impl:
 * @self: The object implementing this interface
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * GetPresenceActual on interface org.freedesktop.Telepathy.MissionControl.
 */
static void
mc_svc_nmc4_get_presence_actual (McSvcNMC4 *self,
    DBusGMethodInvocation *context)
{
  mc_svc_nmc4_get_presence_actual_impl impl = (MC_SVC_NMC4_GET_CLASS (self)->get_presence_actual);

  if (impl != NULL)
    {
      (impl) (self,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * mc_svc_nmc4_implement_get_presence_actual:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetPresenceActual D-Bus method
 *
 * Register an implementation for the GetPresenceActual method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
mc_svc_nmc4_implement_get_presence_actual (McSvcNMC4Class *klass, mc_svc_nmc4_get_presence_actual_impl impl)
{
  klass->get_presence_actual = impl;
}

/**
 * mc_svc_nmc4_get_presence_message_actual_impl:
 * @self: The object implementing this interface
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * GetPresenceMessageActual on interface org.freedesktop.Telepathy.MissionControl.
 */
static void
mc_svc_nmc4_get_presence_message_actual (McSvcNMC4 *self,
    DBusGMethodInvocation *context)
{
  mc_svc_nmc4_get_presence_message_actual_impl impl = (MC_SVC_NMC4_GET_CLASS (self)->get_presence_message_actual);

  if (impl != NULL)
    {
      (impl) (self,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * mc_svc_nmc4_implement_get_presence_message_actual:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetPresenceMessageActual D-Bus method
 *
 * Register an implementation for the GetPresenceMessageActual method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
mc_svc_nmc4_implement_get_presence_message_actual (McSvcNMC4Class *klass, mc_svc_nmc4_get_presence_message_actual_impl impl)
{
  klass->get_presence_message_actual = impl;
}

/**
 * mc_svc_nmc4_request_channel_impl:
 * @self: The object implementing this interface
 * @in_account_name: const gchar * (FIXME, generate documentation)
 * @in_type: const gchar * (FIXME, generate documentation)
 * @in_handle: guint  (FIXME, generate documentation)
 * @in_handle_type: gint  (FIXME, generate documentation)
 * @in_serial: guint  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * RequestChannel on interface org.freedesktop.Telepathy.MissionControl.
 */
static void
mc_svc_nmc4_request_channel (McSvcNMC4 *self,
    const gchar *in_account_name,
    const gchar *in_type,
    guint in_handle,
    gint in_handle_type,
    guint in_serial,
    DBusGMethodInvocation *context)
{
  mc_svc_nmc4_request_channel_impl impl = (MC_SVC_NMC4_GET_CLASS (self)->request_channel);

  if (impl != NULL)
    {
      (impl) (self,
        in_account_name,
        in_type,
        in_handle,
        in_handle_type,
        in_serial,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * mc_svc_nmc4_implement_request_channel:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the RequestChannel D-Bus method
 *
 * Register an implementation for the RequestChannel method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
mc_svc_nmc4_implement_request_channel (McSvcNMC4Class *klass, mc_svc_nmc4_request_channel_impl impl)
{
  klass->request_channel = impl;
}

/**
 * mc_svc_nmc4_request_channel_with_string_handle_impl:
 * @self: The object implementing this interface
 * @in_account_name: const gchar * (FIXME, generate documentation)
 * @in_type: const gchar * (FIXME, generate documentation)
 * @in_handle: const gchar * (FIXME, generate documentation)
 * @in_handle_type: gint  (FIXME, generate documentation)
 * @in_serial: guint  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * RequestChannelWithStringHandle on interface org.freedesktop.Telepathy.MissionControl.
 */
static void
mc_svc_nmc4_request_channel_with_string_handle (McSvcNMC4 *self,
    const gchar *in_account_name,
    const gchar *in_type,
    const gchar *in_handle,
    gint in_handle_type,
    guint in_serial,
    DBusGMethodInvocation *context)
{
  mc_svc_nmc4_request_channel_with_string_handle_impl impl = (MC_SVC_NMC4_GET_CLASS (self)->request_channel_with_string_handle);

  if (impl != NULL)
    {
      (impl) (self,
        in_account_name,
        in_type,
        in_handle,
        in_handle_type,
        in_serial,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * mc_svc_nmc4_implement_request_channel_with_string_handle:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the RequestChannelWithStringHandle D-Bus method
 *
 * Register an implementation for the RequestChannelWithStringHandle method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
mc_svc_nmc4_implement_request_channel_with_string_handle (McSvcNMC4Class *klass, mc_svc_nmc4_request_channel_with_string_handle_impl impl)
{
  klass->request_channel_with_string_handle = impl;
}

/**
 * mc_svc_nmc4_cancel_channel_request_impl:
 * @self: The object implementing this interface
 * @in_operation_id: guint  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * CancelChannelRequest on interface org.freedesktop.Telepathy.MissionControl.
 */
static void
mc_svc_nmc4_cancel_channel_request (McSvcNMC4 *self,
    guint in_operation_id,
    DBusGMethodInvocation *context)
{
  mc_svc_nmc4_cancel_channel_request_impl impl = (MC_SVC_NMC4_GET_CLASS (self)->cancel_channel_request);

  if (impl != NULL)
    {
      (impl) (self,
        in_operation_id,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * mc_svc_nmc4_implement_cancel_channel_request:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the CancelChannelRequest D-Bus method
 *
 * Register an implementation for the CancelChannelRequest method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
mc_svc_nmc4_implement_cancel_channel_request (McSvcNMC4Class *klass, mc_svc_nmc4_cancel_channel_request_impl impl)
{
  klass->cancel_channel_request = impl;
}

/**
 * mc_svc_nmc4_connect_all_with_default_presence_impl:
 * @self: The object implementing this interface
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * ConnectAllWithDefaultPresence on interface org.freedesktop.Telepathy.MissionControl.
 */
static void
mc_svc_nmc4_connect_all_with_default_presence (McSvcNMC4 *self,
    DBusGMethodInvocation *context)
{
  mc_svc_nmc4_connect_all_with_default_presence_impl impl = (MC_SVC_NMC4_GET_CLASS (self)->connect_all_with_default_presence);

  if (impl != NULL)
    {
      (impl) (self,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * mc_svc_nmc4_implement_connect_all_with_default_presence:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the ConnectAllWithDefaultPresence D-Bus method
 *
 * Register an implementation for the ConnectAllWithDefaultPresence method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
mc_svc_nmc4_implement_connect_all_with_default_presence (McSvcNMC4Class *klass, mc_svc_nmc4_connect_all_with_default_presence_impl impl)
{
  klass->connect_all_with_default_presence = impl;
}

/**
 * mc_svc_nmc4_get_connection_status_impl:
 * @self: The object implementing this interface
 * @in_account_name: const gchar * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * GetConnectionStatus on interface org.freedesktop.Telepathy.MissionControl.
 */
static void
mc_svc_nmc4_get_connection_status (McSvcNMC4 *self,
    const gchar *in_account_name,
    DBusGMethodInvocation *context)
{
  mc_svc_nmc4_get_connection_status_impl impl = (MC_SVC_NMC4_GET_CLASS (self)->get_connection_status);

  if (impl != NULL)
    {
      (impl) (self,
        in_account_name,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * mc_svc_nmc4_implement_get_connection_status:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetConnectionStatus D-Bus method
 *
 * Register an implementation for the GetConnectionStatus method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
mc_svc_nmc4_implement_get_connection_status (McSvcNMC4Class *klass, mc_svc_nmc4_get_connection_status_impl impl)
{
  klass->get_connection_status = impl;
}

/**
 * mc_svc_nmc4_get_online_connections_impl:
 * @self: The object implementing this interface
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * GetOnlineConnections on interface org.freedesktop.Telepathy.MissionControl.
 */
static void
mc_svc_nmc4_get_online_connections (McSvcNMC4 *self,
    DBusGMethodInvocation *context)
{
  mc_svc_nmc4_get_online_connections_impl impl = (MC_SVC_NMC4_GET_CLASS (self)->get_online_connections);

  if (impl != NULL)
    {
      (impl) (self,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * mc_svc_nmc4_implement_get_online_connections:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetOnlineConnections D-Bus method
 *
 * Register an implementation for the GetOnlineConnections method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
mc_svc_nmc4_implement_get_online_connections (McSvcNMC4Class *klass, mc_svc_nmc4_get_online_connections_impl impl)
{
  klass->get_online_connections = impl;
}

/**
 * mc_svc_nmc4_get_connection_impl:
 * @self: The object implementing this interface
 * @in_account_name: const gchar * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * GetConnection on interface org.freedesktop.Telepathy.MissionControl.
 */
static void
mc_svc_nmc4_get_connection (McSvcNMC4 *self,
    const gchar *in_account_name,
    DBusGMethodInvocation *context)
{
  mc_svc_nmc4_get_connection_impl impl = (MC_SVC_NMC4_GET_CLASS (self)->get_connection);

  if (impl != NULL)
    {
      (impl) (self,
        in_account_name,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * mc_svc_nmc4_implement_get_connection:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetConnection D-Bus method
 *
 * Register an implementation for the GetConnection method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
mc_svc_nmc4_implement_get_connection (McSvcNMC4Class *klass, mc_svc_nmc4_get_connection_impl impl)
{
  klass->get_connection = impl;
}

/**
 * mc_svc_nmc4_get_account_for_connection_impl:
 * @self: The object implementing this interface
 * @in_object_path: const gchar * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * GetAccountForConnection on interface org.freedesktop.Telepathy.MissionControl.
 */
static void
mc_svc_nmc4_get_account_for_connection (McSvcNMC4 *self,
    const gchar *in_object_path,
    DBusGMethodInvocation *context)
{
  mc_svc_nmc4_get_account_for_connection_impl impl = (MC_SVC_NMC4_GET_CLASS (self)->get_account_for_connection);

  if (impl != NULL)
    {
      (impl) (self,
        in_object_path,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * mc_svc_nmc4_implement_get_account_for_connection:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetAccountForConnection D-Bus method
 *
 * Register an implementation for the GetAccountForConnection method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
mc_svc_nmc4_implement_get_account_for_connection (McSvcNMC4Class *klass, mc_svc_nmc4_get_account_for_connection_impl impl)
{
  klass->get_account_for_connection = impl;
}

/**
 * mc_svc_nmc4_get_used_channels_count_impl:
 * @self: The object implementing this interface
 * @in_type: const gchar * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * GetUsedChannelsCount on interface org.freedesktop.Telepathy.MissionControl.
 */
static void
mc_svc_nmc4_get_used_channels_count (McSvcNMC4 *self,
    const gchar *in_type,
    DBusGMethodInvocation *context)
{
  mc_svc_nmc4_get_used_channels_count_impl impl = (MC_SVC_NMC4_GET_CLASS (self)->get_used_channels_count);

  if (impl != NULL)
    {
      (impl) (self,
        in_type,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * mc_svc_nmc4_implement_get_used_channels_count:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetUsedChannelsCount D-Bus method
 *
 * Register an implementation for the GetUsedChannelsCount method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
mc_svc_nmc4_implement_get_used_channels_count (McSvcNMC4Class *klass, mc_svc_nmc4_get_used_channels_count_impl impl)
{
  klass->get_used_channels_count = impl;
}

/**
 * mc_svc_nmc4_get_current_status_impl:
 * @self: The object implementing this interface
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * GetCurrentStatus on interface org.freedesktop.Telepathy.MissionControl.
 */
static void
mc_svc_nmc4_get_current_status (McSvcNMC4 *self,
    DBusGMethodInvocation *context)
{
  mc_svc_nmc4_get_current_status_impl impl = (MC_SVC_NMC4_GET_CLASS (self)->get_current_status);

  if (impl != NULL)
    {
      (impl) (self,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * mc_svc_nmc4_implement_get_current_status:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetCurrentStatus D-Bus method
 *
 * Register an implementation for the GetCurrentStatus method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
mc_svc_nmc4_implement_get_current_status (McSvcNMC4Class *klass, mc_svc_nmc4_get_current_status_impl impl)
{
  klass->get_current_status = impl;
}

/**
 * mc_svc_nmc4_remote_avatar_changed_impl:
 * @self: The object implementing this interface
 * @in_object_path: const gchar * (FIXME, generate documentation)
 * @in_contact_id: guint  (FIXME, generate documentation)
 * @in_token: const gchar * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * RemoteAvatarChanged on interface org.freedesktop.Telepathy.MissionControl.
 */
static void
mc_svc_nmc4_remote_avatar_changed (McSvcNMC4 *self,
    const gchar *in_object_path,
    guint in_contact_id,
    const gchar *in_token,
    DBusGMethodInvocation *context)
{
  mc_svc_nmc4_remote_avatar_changed_impl impl = (MC_SVC_NMC4_GET_CLASS (self)->remote_avatar_changed);

  if (impl != NULL)
    {
      (impl) (self,
        in_object_path,
        in_contact_id,
        in_token,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * mc_svc_nmc4_implement_remote_avatar_changed:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the RemoteAvatarChanged D-Bus method
 *
 * Register an implementation for the RemoteAvatarChanged method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
mc_svc_nmc4_implement_remote_avatar_changed (McSvcNMC4Class *klass, mc_svc_nmc4_remote_avatar_changed_impl impl)
{
  klass->remote_avatar_changed = impl;
}

/**
 * mc_svc_nmc4_register_filter_impl:
 * @self: The object implementing this interface
 * @in_bus_name: const gchar * (FIXME, generate documentation)
 * @in_object_path: const gchar * (FIXME, generate documentation)
 * @in_channel_type: const gchar * (FIXME, generate documentation)
 * @in_priority: guint  (FIXME, generate documentation)
 * @in_flag: guint  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * RegisterFilter on interface org.freedesktop.Telepathy.MissionControl.
 */
static void
mc_svc_nmc4_register_filter (McSvcNMC4 *self,
    const gchar *in_bus_name,
    const gchar *in_object_path,
    const gchar *in_channel_type,
    guint in_priority,
    guint in_flag,
    DBusGMethodInvocation *context)
{
  mc_svc_nmc4_register_filter_impl impl = (MC_SVC_NMC4_GET_CLASS (self)->register_filter);

  if (impl != NULL)
    {
      (impl) (self,
        in_bus_name,
        in_object_path,
        in_channel_type,
        in_priority,
        in_flag,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * mc_svc_nmc4_implement_register_filter:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the RegisterFilter D-Bus method
 *
 * Register an implementation for the RegisterFilter method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
mc_svc_nmc4_implement_register_filter (McSvcNMC4Class *klass, mc_svc_nmc4_register_filter_impl impl)
{
  klass->register_filter = impl;
}

/**
 * mc_svc_nmc4_emit_account_presence_changed:
 * @instance: The object implementing this interface
 * @arg_status: guint  (FIXME, generate documentation)
 * @arg_presence: guint  (FIXME, generate documentation)
 * @arg_message: const gchar * (FIXME, generate documentation)
 * @arg_reason: guint  (FIXME, generate documentation)
 * @arg_account_id: const gchar * (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * AccountPresenceChanged signal on interface org.freedesktop.Telepathy.MissionControl.
 */
void
mc_svc_nmc4_emit_account_presence_changed (gpointer instance,
    guint arg_status,
    guint arg_presence,
    const gchar *arg_message,
    guint arg_reason,
    const gchar *arg_account_id)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, MC_TYPE_SVC_NMC4));
  g_signal_emit (instance,
      nmc4_signals[SIGNAL_NMC4_AccountPresenceChanged],
      0,
      arg_status,
      arg_presence,
      arg_message,
      arg_reason,
      arg_account_id);
}

/**
 * mc_svc_nmc4_emit_account_status_changed:
 * @instance: The object implementing this interface
 * @arg_status: guint  (FIXME, generate documentation)
 * @arg_presence: guint  (FIXME, generate documentation)
 * @arg_reason: guint  (FIXME, generate documentation)
 * @arg_account_id: const gchar * (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * AccountStatusChanged signal on interface org.freedesktop.Telepathy.MissionControl.
 */
void
mc_svc_nmc4_emit_account_status_changed (gpointer instance,
    guint arg_status,
    guint arg_presence,
    guint arg_reason,
    const gchar *arg_account_id)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, MC_TYPE_SVC_NMC4));
  g_signal_emit (instance,
      nmc4_signals[SIGNAL_NMC4_AccountStatusChanged],
      0,
      arg_status,
      arg_presence,
      arg_reason,
      arg_account_id);
}

/**
 * mc_svc_nmc4_emit_mcd_error:
 * @instance: The object implementing this interface
 * @arg_serial: guint  (FIXME, generate documentation)
 * @arg_client_id: const gchar * (FIXME, generate documentation)
 * @arg_error_id: guint  (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * McdError signal on interface org.freedesktop.Telepathy.MissionControl.
 */
void
mc_svc_nmc4_emit_mcd_error (gpointer instance,
    guint arg_serial,
    const gchar *arg_client_id,
    guint arg_error_id)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, MC_TYPE_SVC_NMC4));
  g_signal_emit (instance,
      nmc4_signals[SIGNAL_NMC4_McdError],
      0,
      arg_serial,
      arg_client_id,
      arg_error_id);
}

/**
 * mc_svc_nmc4_emit_presence_requested:
 * @instance: The object implementing this interface
 * @arg_presence: guint  (FIXME, generate documentation)
 * @arg_message: const gchar * (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * PresenceRequested signal on interface org.freedesktop.Telepathy.MissionControl.
 */
void
mc_svc_nmc4_emit_presence_requested (gpointer instance,
    guint arg_presence,
    const gchar *arg_message)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, MC_TYPE_SVC_NMC4));
  g_signal_emit (instance,
      nmc4_signals[SIGNAL_NMC4_PresenceRequested],
      0,
      arg_presence,
      arg_message);
}

/**
 * mc_svc_nmc4_emit_presence_status_requested:
 * @instance: The object implementing this interface
 * @arg_presence: guint  (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * PresenceStatusRequested signal on interface org.freedesktop.Telepathy.MissionControl.
 */
void
mc_svc_nmc4_emit_presence_status_requested (gpointer instance,
    guint arg_presence)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, MC_TYPE_SVC_NMC4));
  g_signal_emit (instance,
      nmc4_signals[SIGNAL_NMC4_PresenceStatusRequested],
      0,
      arg_presence);
}

/**
 * mc_svc_nmc4_emit_presence_changed:
 * @instance: The object implementing this interface
 * @arg_presence: guint  (FIXME, generate documentation)
 * @arg_message: const gchar * (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * PresenceChanged signal on interface org.freedesktop.Telepathy.MissionControl.
 */
void
mc_svc_nmc4_emit_presence_changed (gpointer instance,
    guint arg_presence,
    const gchar *arg_message)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, MC_TYPE_SVC_NMC4));
  g_signal_emit (instance,
      nmc4_signals[SIGNAL_NMC4_PresenceChanged],
      0,
      arg_presence,
      arg_message);
}

/**
 * mc_svc_nmc4_emit_presence_status_actual:
 * @instance: The object implementing this interface
 * @arg_presence: guint  (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * PresenceStatusActual signal on interface org.freedesktop.Telepathy.MissionControl.
 */
void
mc_svc_nmc4_emit_presence_status_actual (gpointer instance,
    guint arg_presence)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, MC_TYPE_SVC_NMC4));
  g_signal_emit (instance,
      nmc4_signals[SIGNAL_NMC4_PresenceStatusActual],
      0,
      arg_presence);
}

/**
 * mc_svc_nmc4_emit_used_channels_count_changed:
 * @instance: The object implementing this interface
 * @arg_type: const gchar * (FIXME, generate documentation)
 * @arg_count: guint  (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * UsedChannelsCountChanged signal on interface org.freedesktop.Telepathy.MissionControl.
 */
void
mc_svc_nmc4_emit_used_channels_count_changed (gpointer instance,
    const gchar *arg_type,
    guint arg_count)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, MC_TYPE_SVC_NMC4));
  g_signal_emit (instance,
      nmc4_signals[SIGNAL_NMC4_UsedChannelsCountChanged],
      0,
      arg_type,
      arg_count);
}

/**
 * mc_svc_nmc4_emit_status_actual:
 * @instance: The object implementing this interface
 * @arg_status: guint  (FIXME, generate documentation)
 * @arg_presence: guint  (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * StatusActual signal on interface org.freedesktop.Telepathy.MissionControl.
 */
void
mc_svc_nmc4_emit_status_actual (gpointer instance,
    guint arg_status,
    guint arg_presence)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, MC_TYPE_SVC_NMC4));
  g_signal_emit (instance,
      nmc4_signals[SIGNAL_NMC4_StatusActual],
      0,
      arg_status,
      arg_presence);
}

static void
mc_svc_nmc4_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (initialized)
    return;

  initialized = TRUE;

  nmc4_signals[SIGNAL_NMC4_AccountPresenceChanged] =
  g_signal_new ("account-presence-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _mc_ext_marshal_VOID__UINT_UINT_STRING_UINT_STRING,
      G_TYPE_NONE,
      5,
      G_TYPE_UINT,
      G_TYPE_UINT,
      G_TYPE_STRING,
      G_TYPE_UINT,
      G_TYPE_STRING);

  nmc4_signals[SIGNAL_NMC4_AccountStatusChanged] =
  g_signal_new ("account-status-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _mc_ext_marshal_VOID__UINT_UINT_UINT_STRING,
      G_TYPE_NONE,
      4,
      G_TYPE_UINT,
      G_TYPE_UINT,
      G_TYPE_UINT,
      G_TYPE_STRING);

  nmc4_signals[SIGNAL_NMC4_McdError] =
  g_signal_new ("mcd-error",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _mc_ext_marshal_VOID__UINT_STRING_UINT,
      G_TYPE_NONE,
      3,
      G_TYPE_UINT,
      G_TYPE_STRING,
      G_TYPE_UINT);

  nmc4_signals[SIGNAL_NMC4_PresenceRequested] =
  g_signal_new ("presence-requested",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _mc_ext_marshal_VOID__UINT_STRING,
      G_TYPE_NONE,
      2,
      G_TYPE_UINT,
      G_TYPE_STRING);

  nmc4_signals[SIGNAL_NMC4_PresenceStatusRequested] =
  g_signal_new ("presence-status-requested",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__UINT,
      G_TYPE_NONE,
      1,
      G_TYPE_UINT);

  nmc4_signals[SIGNAL_NMC4_PresenceChanged] =
  g_signal_new ("presence-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _mc_ext_marshal_VOID__UINT_STRING,
      G_TYPE_NONE,
      2,
      G_TYPE_UINT,
      G_TYPE_STRING);

  nmc4_signals[SIGNAL_NMC4_PresenceStatusActual] =
  g_signal_new ("presence-status-actual",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__UINT,
      G_TYPE_NONE,
      1,
      G_TYPE_UINT);

  nmc4_signals[SIGNAL_NMC4_UsedChannelsCountChanged] =
  g_signal_new ("used-channels-count-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _mc_ext_marshal_VOID__STRING_UINT,
      G_TYPE_NONE,
      2,
      G_TYPE_STRING,
      G_TYPE_UINT);

  nmc4_signals[SIGNAL_NMC4_StatusActual] =
  g_signal_new ("status-actual",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _mc_ext_marshal_VOID__UINT_UINT,
      G_TYPE_NONE,
      2,
      G_TYPE_UINT,
      G_TYPE_UINT);

  dbus_g_object_type_install_info (mc_svc_nmc4_get_type (),
      &_mc_svc_nmc4_object_info);
}
static const DBusGMethodInfo _mc_svc_nmc4_methods[] = {
  { (GCallback) mc_svc_nmc4_set_presence, _mc_ext_marshal_VOID__UINT_STRING_POINTER, 0 },
  { (GCallback) mc_svc_nmc4_get_presence, g_cclosure_marshal_VOID__POINTER, 81 },
  { (GCallback) mc_svc_nmc4_get_presence_message, g_cclosure_marshal_VOID__POINTER, 150 },
  { (GCallback) mc_svc_nmc4_get_presence_actual, g_cclosure_marshal_VOID__POINTER, 226 },
  { (GCallback) mc_svc_nmc4_get_presence_message_actual, g_cclosure_marshal_VOID__POINTER, 301 },
  { (GCallback) mc_svc_nmc4_request_channel, _mc_ext_marshal_VOID__STRING_STRING_UINT_INT_UINT_POINTER, 383 },
  { (GCallback) mc_svc_nmc4_request_channel_with_string_handle, _mc_ext_marshal_VOID__STRING_STRING_STRING_INT_UINT_POINTER, 506 },
  { (GCallback) mc_svc_nmc4_cancel_channel_request, g_cclosure_marshal_VOID__UINT_POINTER, 645 },
  { (GCallback) mc_svc_nmc4_connect_all_with_default_presence, g_cclosure_marshal_VOID__POINTER, 727 },
  { (GCallback) mc_svc_nmc4_get_connection_status, _mc_ext_marshal_VOID__STRING_POINTER, 801 },
  { (GCallback) mc_svc_nmc4_get_online_connections, g_cclosure_marshal_VOID__POINTER, 895 },
  { (GCallback) mc_svc_nmc4_get_connection, _mc_ext_marshal_VOID__STRING_POINTER, 974 },
  { (GCallback) mc_svc_nmc4_get_account_for_connection, _mc_ext_marshal_VOID__STRING_POINTER, 1075 },
  { (GCallback) mc_svc_nmc4_get_used_channels_count, _mc_ext_marshal_VOID__STRING_POINTER, 1172 },
  { (GCallback) mc_svc_nmc4_get_current_status, g_cclosure_marshal_VOID__POINTER, 1259 },
  { (GCallback) mc_svc_nmc4_remote_avatar_changed, _mc_ext_marshal_VOID__STRING_UINT_STRING_POINTER, 1402 },
  { (GCallback) mc_svc_nmc4_register_filter, _mc_ext_marshal_VOID__STRING_BOXED_STRING_UINT_UINT_POINTER, 1507 },
};

static const DBusGObjectInfo _mc_svc_nmc4_object_info = {
  0,
  _mc_svc_nmc4_methods,
  17,
"org.freedesktop.Telepathy.MissionControl\0SetPresence\0A\0presence\0I\0u\0message\0I\0s\0\0org.freedesktop.Telepathy.MissionControl\0GetPresence\0A\0arg0\0O\0F\0N\0u\0\0org.freedesktop.Telepathy.MissionControl\0GetPresenceMessage\0A\0arg0\0O\0F\0N\0s\0\0org.freedesktop.Telepathy.MissionControl\0GetPresenceActual\0A\0arg0\0O\0F\0N\0u\0\0org.freedesktop.Telepathy.MissionControl\0GetPresenceMessageActual\0A\0arg0\0O\0F\0N\0s\0\0org.freedesktop.Telepathy.MissionControl\0RequestChannel\0A\0account_name\0I\0s\0type\0I\0s\0handle\0I\0u\0handle_type\0I\0i\0serial\0I\0u\0\0org.freedesktop.Telepathy.MissionControl\0RequestChannelWithStringHandle\0A\0account_name\0I\0s\0type\0I\0s\0handle\0I\0s\0handle_type\0I\0i\0serial\0I\0u\0\0org.freedesktop.Telepathy.MissionControl\0CancelChannelRequest\0A\0operation_id\0I\0u\0\0org.freedesktop.Telepathy.MissionControl\0ConnectAllWithDefaultPresence\0A\0\0org.freedesktop.Telepathy.MissionControl\0GetConnectionStatus\0A\0account_name\0I\0s\0arg1\0O\0F\0N\0u\0\0org.freedesktop.Telepathy.MissionControl\0GetOnlineConnections\0A\0arg0\0O\0F\0N\0as\0\0org.freedesktop.Telepathy.MissionControl\0GetConnection\0A\0account_name\0I\0s\0arg1\0O\0F\0N\0s\0arg2\0O\0F\0N\0o\0\0org.freedesktop.Telepathy.MissionControl\0GetAccountForConnection\0A\0object_path\0I\0s\0arg1\0O\0F\0N\0s\0\0org.freedesktop.Telepathy.MissionControl\0GetUsedChannelsCount\0A\0type\0I\0s\0arg1\0O\0F\0N\0u\0\0org.freedesktop.Telepathy.MissionControl\0GetCurrentStatus\0A\0status\0O\0F\0N\0u\0presence\0O\0F\0N\0u\0requested_presence\0O\0F\0N\0u\0accounts\0O\0F\0N\0a(suuu)\0\0org.freedesktop.Telepathy.MissionControl\0RemoteAvatarChanged\0A\0object_path\0I\0s\0contact_id\0I\0u\0token\0I\0s\0\0org.freedesktop.Telepathy.MissionControl\0RegisterFilter\0A\0bus_name\0I\0s\0object_path\0I\0o\0channel_type\0I\0s\0priority\0I\0u\0flag\0I\0u\0\0\0",
"org.freedesktop.Telepathy.MissionControl\0AccountPresenceChanged\0org.freedesktop.Telepathy.MissionControl\0AccountStatusChanged\0org.freedesktop.Telepathy.MissionControl\0McdError\0org.freedesktop.Telepathy.MissionControl\0PresenceRequested\0org.freedesktop.Telepathy.MissionControl\0PresenceStatusRequested\0org.freedesktop.Telepathy.MissionControl\0PresenceChanged\0org.freedesktop.Telepathy.MissionControl\0PresenceStatusActual\0org.freedesktop.Telepathy.MissionControl\0UsedChannelsCountChanged\0org.freedesktop.Telepathy.MissionControl\0StatusActual\0\0",
"\0"
};


