#include "_gen/svc-Account.h"

#include <telepathy-glib/dbus.h>
#include "_gen/signals-marshal.h"

static const DBusGObjectInfo _mc_svc_account_object_info;

struct _McSvcAccountClass {
    GTypeInterface parent_class;
    mc_svc_account_remove_impl remove;
    mc_svc_account_update_parameters_impl update_parameters;
};

enum {
    SIGNAL_ACCOUNT_Removed,
    SIGNAL_ACCOUNT_AccountPropertyChanged,
    N_ACCOUNT_SIGNALS
};
static guint account_signals[N_ACCOUNT_SIGNALS] = {0};

static void mc_svc_account_base_init (gpointer klass);

GType
mc_svc_account_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (McSvcAccountClass),
        mc_svc_account_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "McSvcAccount", &info, 0);
    }

  return type;
}

/**
 * mc_svc_account_remove_impl:
 * @self: The object implementing this interface
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * Remove on interface org.freedesktop.Telepathy.Account.
 */
static void
mc_svc_account_remove (McSvcAccount *self,
    DBusGMethodInvocation *context)
{
  mc_svc_account_remove_impl impl = (MC_SVC_ACCOUNT_GET_CLASS (self)->remove);

  if (impl != NULL)
    {
      (impl) (self,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * mc_svc_account_implement_remove:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the Remove D-Bus method
 *
 * Register an implementation for the Remove method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
mc_svc_account_implement_remove (McSvcAccountClass *klass, mc_svc_account_remove_impl impl)
{
  klass->remove = impl;
}

/**
 * mc_svc_account_update_parameters_impl:
 * @self: The object implementing this interface
 * @in_Set: GHashTable * (FIXME, generate documentation)
 * @in_Unset: const gchar ** (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * UpdateParameters on interface org.freedesktop.Telepathy.Account.
 */
static void
mc_svc_account_update_parameters (McSvcAccount *self,
    GHashTable *in_Set,
    const gchar **in_Unset,
    DBusGMethodInvocation *context)
{
  mc_svc_account_update_parameters_impl impl = (MC_SVC_ACCOUNT_GET_CLASS (self)->update_parameters);

  if (impl != NULL)
    {
      (impl) (self,
        in_Set,
        in_Unset,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * mc_svc_account_implement_update_parameters:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the UpdateParameters D-Bus method
 *
 * Register an implementation for the UpdateParameters method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
mc_svc_account_implement_update_parameters (McSvcAccountClass *klass, mc_svc_account_update_parameters_impl impl)
{
  klass->update_parameters = impl;
}

/**
 * mc_svc_account_emit_removed:
 * @instance: The object implementing this interface
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * Removed signal on interface org.freedesktop.Telepathy.Account.
 */
void
mc_svc_account_emit_removed (gpointer instance)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, MC_TYPE_SVC_ACCOUNT));
  g_signal_emit (instance,
      account_signals[SIGNAL_ACCOUNT_Removed],
      0);
}

/**
 * mc_svc_account_emit_account_property_changed:
 * @instance: The object implementing this interface
 * @arg_Properties: GHashTable * (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * AccountPropertyChanged signal on interface org.freedesktop.Telepathy.Account.
 */
void
mc_svc_account_emit_account_property_changed (gpointer instance,
    GHashTable *arg_Properties)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, MC_TYPE_SVC_ACCOUNT));
  g_signal_emit (instance,
      account_signals[SIGNAL_ACCOUNT_AccountPropertyChanged],
      0,
      arg_Properties);
}

static void
mc_svc_account_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (initialized)
    return;

  initialized = TRUE;

  account_signals[SIGNAL_ACCOUNT_Removed] =
  g_signal_new ("removed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__VOID,
      G_TYPE_NONE,
      0);

  account_signals[SIGNAL_ACCOUNT_AccountPropertyChanged] =
  g_signal_new ("account-property-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__BOXED,
      G_TYPE_NONE,
      1,
      (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE)));

  dbus_g_object_type_install_info (mc_svc_account_get_type (),
      &_mc_svc_account_object_info);
}
static const DBusGMethodInfo _mc_svc_account_methods[] = {
  { (GCallback) mc_svc_account_remove, g_cclosure_marshal_VOID__POINTER, 0 },
  { (GCallback) mc_svc_account_update_parameters, _mc_ext_marshal_VOID__BOXED_BOXED_POINTER, 44 },
};

static const DBusGObjectInfo _mc_svc_account_object_info = {
  0,
  _mc_svc_account_methods,
  2,
"org.freedesktop.Telepathy.Account\0Remove\0A\0\0org.freedesktop.Telepathy.Account\0UpdateParameters\0A\0Set\0I\0a{sv}\0Unset\0I\0as\0\0\0",
"org.freedesktop.Telepathy.Account\0Removed\0org.freedesktop.Telepathy.Account\0AccountPropertyChanged\0\0",
"\0"
};


